     subroutine th_hdeqf(isubthe,icase,iput,iget,info) 
     use glbconst, only: maxscrd,icstrf,icfr2trf,ivstrf,ivfr2trf,     &
                         infotext,enwr,nwr
     use comthe, only: array_fr,real_fr,theoryname
     implicit none 
                                                                        
     integer isubthe,icase,iput,iget,info 
!    transmission: fr2 defines external magnetic field, orientation    
!    of the sample by phi,theta,psi is calculated by the routine sample
!    orientation tansferred by  array_fr to main and than passed to fr2
                                                                        
     real            acfr2,rep_grp,aset,asymmetry,a_psi,dumcfr2 
     common/acfr2trf/acfr2,rep_grp,aset,asymmetry,a_psi,               &
                     dumcfr2(icfr2trf-5)                               
     logical         bcfr2,bumcfr2 
     common/bcfr2trf/bcfr2,bumcfr2(icfr2trf-1) 
     real            avfr2,dum5,Hext,thetaHe,phiHe,                    &
                     phi_ls,theta_ls,psi_ls,                           &
                     d_x2,eta_xx,phi_xx,theta_xx,psi_xx,               &
                     t200,t400,dumvfr2                                 
     common/avfr2trf/avfr2,dum5(5),Hext,thetaHe,phiHe,                 &
                     phi_ls,theta_ls,psi_ls,                           &
                     d_x2,eta_xx,phi_xx,theta_xx,psi_xx,               &
                     t200,t400,dumvfr2(ivfr2trf-19)                    
!    b_phi is named b_laba (laboratory angles of the sample)           
!    b_laba has got the value of b_phi.or.b_theta.or.b_psi             
!    in the routine th_sampleorient                                    
!    b_dum5(5) is reserved place for the parameters thicklay,re_chilay,
!    ai_chilay,roughness,xxx  which are used in scattering theories,   
     logical         b_vfr2,b_dum5,b_Hext,b_thetaHe,b_phiHe,           &
                     b_laba,b_thetals,b_psils,b_dx2,b_etaxx,           &
                     b_phixx,b_thetaxx,b_psixx,b_t200,b_t400,b_dumvfr2 
     common/bvfr2trf/b_vfr2,b_dum5(5),b_Hext,b_thetaHe,b_phiHe,        &
                     b_laba,b_thetals,b_psils,b_dx2,b_etaxx,b_phixx,   &
                     b_thetaxx,b_psixx,b_t200,b_t400,                  &
                     b_dumvfr2(ivfr2trf-19)                            
                                                                       
     real          c1,symcase,timeinvers,cTms,                         &
                   ajg,aje,amueg,amuee,QgdQe,r_E2M1,e1m1,dumc          
     common/acmaps/c1,cTms,ajg,aje,amueg,amuee,QgdQe,r_E2M1,e1m1,      &
                   symcase,timeinvers,dumc(icstrf-11)                  
     logical       b_c1,b_dum 
     common/bcmaps/b_c1,b_dum(icstrf-1) 
!    arrays derived from constants are calculated only once (transforma
!    matrices for equivalent orientations, clebsch Gordan coefficients 
!    in the routine  hamJgJe, ...)                                     
                                                                       
     real          avss,                                               &
                   dsx2,eta_sx,phi_sx,theta_sx,psi_sx,                 &
                   aH,thetaH,phiH,DEq,eta,phi_CE,theta_CE,psi_CE,dumvss
     common/avmaps/avss,                                               &
                   dsx2,eta_sx,phi_sx,theta_sx,psi_sx,                 &
                   aH,thetaH,phiH,DEq,eta,phi_CE,theta_CE,psi_CE,      &
                   dumvss(ivstrf-14)                                   
     logical       b_vss,                                              &
                   b_dsx2,b_etasx,b_phisx,b_thetasx,b_psisx,           &
                   b_aH,b_thetaH,b_phiH,                               &
                   b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,b_dumvss         
     common/bvmaps/b_vss,                                              &
                   b_dsx2,b_etasx,b_phisx,b_thetasx,b_psisx,           &
                   b_aH,b_thetaH,b_phiH,                               &
                   b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,                 &
                   b_dumvss(ivstrf-14)                                 
                                                                       
!    logical avssfr,avari,dumvssfr                                     
!    common/avsstrf/avssfr,avari(17),dumvssfr(ivsstrf-18)              
!    logical b_vssfr,b_vari,b_dumvssfr                                 
!    common/bvsstrf/b_vssfr,b_vari(17),b_dumvssfr(ivsstrf-18)          
                                                                       
                                                                       
!    parameter(maxloop=5,..) has also to be changed in sym_equiv(...)  
      integer,parameter::maxloop=11,ivv=90,iec=ivv+25,icl=iec+25,       &
                        iecv=icl+9,id1=iecv+9,id2=id1+1+10*maxloop,     &
                        istore=id2+25*maxloop  

     real,dimension(maxloop)  :: timeinv                                                                      
     real,dimension(3,3)      :: uveca,vik,vdd
     complex,dimension(-2:2):: efgPAS,efgC,efgC0,efgL,xxPAS,sx2C,sx2C0,  &
                               x2C,x2Clab
     complex,dimension(-1:1)     :: hv,hvL,hvC,hvC0,hve
     complex,dimension(-2:2,-2:2):: Dect,Dsxct,Dxxct,Dslt,Dclt,Dcpt    
     complex,dimension(-1:1,-1:1):: Decv,Dslv,d21,Dclv,Dcpv
     complex,dimension(-2:2,-2:2,maxloop):: d2
     complex,dimension(-1:1,-1:1,maxloop):: d1
     complex,dimension(maxloop)  :: ctimeinv
                                                                       
     complex,dimension(istore):: store
     complex      caseloop
     equivalence (store(1),efgPAS(-2)),(store(6),efgC(-2)),            &
                 (store(11),efgL(-2)),(store(16),xxPAS(-2)),           &
                 (store(21),sx2C(-2)),(store(26),x2C(-2)),             &
                 (store(31),hve(-1)),(store(34),hvC(-1)),              &
                 (store(37),hvL(-1)),(store(40),Dect(-2,-2)),          &
                 (store(65),Dsxct(-2,-2)),(store(ivv),Dxxct(-2,-2)),   &
                 (store(iec),Dslt(-2,-2)),                             &
                 (store(icl),Decv(-1,-1)),(store(iecv),Dslv(-1,-1)),   &
                 (store(id1),caseloop),(store(id1+1),ctimeinv(1)),     &
            (store(id1+1+maxloop),d1(-1,-1,1)),(store(id2),d2(-2,-2,1))
                                                                       

     integer,parameter:: idumscrd=maxscrd-6144*3-128*3-9*24 
     real        thetaOM,phiOM,psiOM,eh,mat,dumscrd                                              
     common/scrd/phiOM(6144),thetaOM(6144),psiOM(6144),                &
                 eh(3,128),mat(3,3,24),dumscrd(idumscrd)               
     real,parameter :: sqrt2=1.4142136,q62=1.224745,                   &
                        rad=0.0174533,pi=3.14159                             

     integer i,j,k,l,m,n,ip,ii,iset,isymmetry,n_psi,jpsi,iOM,jOM,      &
             je,jg,jge,ncase,                                          &
             nloop,nloop_b,nloop_e,jloop,nput,jljpjO,n_all    
     logical b_He,b_Hi,b_Hea,b_Hegt0,b_Higt0,b_Hgt0,                   &
             b_eq,b_eqa,b_eqgt0,b_sx2,b_sx2a,b_sx2gt0,                 &
             b_x2,b_x2a,b_x2gt0,b_xx,b_hf,b_laba0,b_integer,b_wrtensor                      
     real    a_mueg,a_muee,c_Tms,efg0,efg2,x22,sx22,                   &
             aszz,azz,texture,cost2,Stexture,                          &
             txx,tyy,tzz,txy,txz,tyz,                                  &
             pp,hmm,pp1,hmm1,pp2,hmm2,pp12,hmm12,rEM2,qEM2,            &
             h,hx,hy,hz,thetaC,phiC,sintC,                             &
             psiOMa,arcos
     real    phiH_r,thetaH_r,phi_r,theta_r,psi_r,phiE_r,thetaE_r,      &
             psiE_r,phiHe_r,thetaHe_r,h1
     complex pm,pm1,pm2,pm12,hc1 

     real,    dimension(:),   allocatable :: eagd_zz 
     real,    dimension(:),   allocatable :: Eagd
     complex, dimension(:),   allocatable :: eagdzz
     complex, dimension(:,:), allocatable :: V1m
     complex, dimension(:,:), allocatable :: V2m
!      write(6,'(a)')' th_hdeqf avmaps ::'                              
!      write(6,'(6f12.3)')avss,                                         
!     &              dsx2,eta_sx,phi_sx,theta_sx,psi_sx,                
!     &              aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE            
!      write(6,'(a,10f10.2)') ' acmaps:',c1,symcase,                    
!     &       timeinvers,cTms,ajg,aje,amueg,amuee                       
      jge=(2.*ajg+1)*(2.*aje+1)+0.01 
 
     if(acfr2.lt.3.)aset=0.0 
!     this way iset,... have not to be defined in frstr_..              
      if(isubthe.lt.0) then 
       theoryname='H_DEQ_f_equivalent_sites      v=200' 
       if(isubthe.eq.-16) then 
!       reading .par file ncase,symcase are not mapped (-> 8888.88)     
!       asking name with isubthe=-1 the routine sym_equiv (later        
!       calculating storage space) leads to an error exit               
        symcase=0.0 
        ncase=0 
        return 
       end if 
!      routines only asking for the name (not values for storage space) 
!      put isubthe to -16 (far away from -ntheory)                      
                                                                        
       ncase=symcase 
       call sym_equiv(-ncase,timeinvers,nloop,ctimeinv,d1,d2) 
       iset=aset 
                                       ! only 1 rotation                
       if(nloop.eq.-1)nloop=0 
       if(iset.gt.0) then 
        isymmetry=asymmetry 
        n_psi=a_psi 
        call sphere(-iset,isymmetry,.false.,iOM,phiOM,thetaOM,psiOM,    &
                                                      eh,mat)          
        if(iOM.eq.0) then 
         info=1 
         infotext(1)=' ' 
         infotext(2)(1:17)='*** error ***' 
         infotext(3)='meaningless values of constants iset/isymmetry' 
         infotext(4)=                                                   &
              'help available: {co a}, {he cn} (n=number of constant)'    
         infotext(5)=' ' 
         return 
        end if 
        i=1+istore+2+3*jge*(nloop+1)*iOM*(n_psi+1)+(iOM/2)*3 
        if(iOM.eq.1)i=i+2 
        c1=i 
       else 
        c1=1+istore+2+3*jge*(nloop+1)+2 
       end if 
       return 
      end if 
                                                                        
!       write(6,'(a,f15.2)')'th_22nuclear avfr2...',r_E2M1                          
!       write(6,'(8f10.2)')avfr2,dum5(5),Hext,thetaHe,phiHe             
!      write(6,'(20L3)')b_vfr2,b_dum5(5),b_Hext,b_thetaHe,b_phiHe       
!     &                phi,theta,psi,d_x2,eta_xx,phi_xx,theta_xx,psi_xx,
!     &                axtexture                                        
!      write(6,'(a)')'th_22nuclear avss...'                             
!      write(6,'(8f10.2)')avss,                                         
!     &              dsx2,eta_sx,phi_sx,theta_sx,psi_sx,                
!     &              aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE            
!       write(6,'(20L3)')b_vss,                                         
!     &              b_dsx2,b_etasx,b_phisx,b_thetasx,b_psisx,          
!     &              b_aH,b_thetaH,b_phiH,                              
!     &              b_DEq,b_eta,b_phiE,b_thetaE,b_psiE                 
                                                                        
!       if(b_vssfr) then                                                
!        write(6,'(2L2,3x,20L3)')b_vssfr,b_vss,b_vari                   
!        write(6,'(2f10.3,3x,20f10.3)')avssfr,avss,avari                
!      write(6,'(8f10.2)')d_x2,eta_xx,phi_xx,theta_xx,psi_xx            
!     any parameter changed ?                                           
                                                                        
      if(.not.(b_vss.or.b_vfr2)) then 
       isubthe=-abs(isubthe)             ! 24.10.07 theory not changed  
!       write(6,'(a)') ' no change'                                     
       return 
      end if 
! ----------------------------------------------------------------------
  allocate(Eagd(jge),eagd_zz(2*jge),V1m(-1:1,jge),V2m(-2:2,jge),eagdzz(jge))
      j=iput+1 
      nput=j+istore 
      do i=1,istore 
       store(i)=array_fr(j+i) 
      end do 
      array_fr(j)=cmplx(float(nput),float(istore)) 
!     bvfr2trf                                                           
!     external magnetic field                                           
      b_Hea=b_thetaHe.or.b_phiHe 
      b_He=b_Hext.or.b_Hea 
!     orientation of the crystal/sample in the la. system               
!     b_laba=b_phils.or.b_thetals.or.b_psils                            
                                                                        
!     <x2> of the crystal                                               
      b_x2a =b_phixx.or.b_thetaxx.or.b_psixx 
      b_x2  =b_dx2.or.b_etaxx.or.b_x2a 
                                                                        
!    avmap                                                              
!    <sx2> of the called site of the crystal                            
      b_sx2a=b_phisx.or.b_thetasx.or.b_psisx 
      b_sx2 =b_dsx2.or.b_etasx.or.b_sx2a 
!     internal magnetic field at the called site of the crystal         
      b_Hi=b_aH.or.b_thetaH.or.b_phiH 
!     electric field gradient at the called site of the crystal         
      b_eqa=b_phiE.or.b_thetaE.or.b_psiE 
      b_eq=b_DEq.or.b_eta.or.b_eqa 
                                                                        
!     hyperfine parameter (He depends on angles phi,theta,psi)          
      b_hf=b_He.or.b_Hi.or.b_eq.or.b_laba 
!     <x2>+<sx2> (<x2> depends on angles phi,theta,psi)                 
      b_xx  =b_dsx2.or.b_sx2.or.b_dx2.or.b_x2.or.b_laba 
                                                                        
      ii=jge/2 
      if(2*ii.eq.jge) then 
       b_integer=.false. 
       je=2*aje+0.01 
       jg=2*ajg+0.01 
      else 
       b_integer=.true. 
       je=aje+0.01 
       jg=ajg+0.01 
      end if 

      a_mueg=amueg 
      a_muee=amuee 
      c_Tms=cTms 
      rEM2=r_E2M1**2 
      qEM2=1./(1.+rEM2) 
                                                                        
      n_psi=a_psi 
      iset=aset 
      ncase=symcase 
      isymmetry=asymmetry 
                                                                        
      nloop_b=0 
      if(b_c1) then 
       call sym_equiv(ncase,timeinvers,nloop,ctimeinv,d1,d2) 
       nloop_e=nloop 
       if(nloop.eq.-1)then 
        nloop_b=1 
        nloop_e=1 
       end if 
      else 
       nloop=real(caseloop) 
!      write(6,'(a,i6)')'th_22nuclear nloop=',nloop                     
       nloop_e=nloop 
       if(nloop.eq.-1)then 
        nloop_b=1 
        nloop_e=1 
       end if 
      end if 
      do k=1,nloop_e 
       timeinv(k)=real(ctimeinv(k)) 
      end do 
                                                                        
      if(bcfr2) then 
       call sphere(iset,isymmetry,.false.,iOM,phiOM,thetaOM,psiOM,      &
     &                                                 eh,mat)          
       caseloop=cmplx(float(nloop),float(iOM)) 
       if(nloop.eq.-1)then 
        n_all=(n_psi+1)*iOM 
       else 
        n_all=(n_psi+1)*iOM*(nloop+1) 
       end if 
       j=(nput+2+3*jge*n_all)*2 
       do i=1,iOM 
        k=(i-1)*3+j 
        real_fr(k+1)=phiOM(i) 
        real_fr(k+2)=thetaOM(i) 
        real_fr(k+3)=psiOM(i) 
       end do 
      else 
       iOM=aimag(caseloop) 
       if(nloop.eq.-1)then 
        n_all=(n_psi+1)*iOM 
       else 
        n_all=(n_psi+1)*iOM*(nloop+1) 
       end if 
       j=(nput+2+3*jge*n_all)*2 
       do i=1,iOM 
        k=(i-1)*3+j 
        phiOM(i)=real_fr(k+1) 
        thetaOM(i)=real_fr(k+2) 
        psiOM(i)=real_fr(k+3) 
       end do 
      end if 
      caseloop=cmplx(float(nloop),float(iOM)) 
                                                                        
                                                                        
!     <sx2> tensor                                                      
      b_sx2gt0=abs(dsx2).gt.0. 
      if(b_sx2) then 
       if(b_sx2a)then 
!       The Euler angles rotate the crystal system S_C to the PAS S_sx2 
!       of <sx2> tensor.The Euler angles are obtained with the          
!       program called by  {eu} [1 Euler angles from unit vectors]      
!       ->[unit vectors eb(n) in system Sa].                            
!       Input are the unit vectors eb(x,y,z)=e_sx2 of S_sx2 with respect
!       to the crystal system S_C.                                      
!       The transformation Dsxct(-gamma,-theta,-alpha) transforms       
!       the tensor components to the crystal system.                    
!       Symbolic:  e_sx2 in S_C  -> t_C=t_sx2*d^(-1)                    
        call dimj(-psi_sx*rad,-theta_sx*rad,-phi_sx*rad,2,Dsxct)
       end if 
                                                                        
!      xxPAS (-2..2) are the spherical tensor components of <sx2> in the
!      S_sx2 system. The tensor is attached to site 1 (of nloop+1       
!      equivalent sites) of the crystal.                                
       sx22=eta_sx/sqrt(6.) 
                                                                        
       xxPAS(0)=cmplx(1.,0.0) 
       xxPAS(-1)=(0.,0.) 
       xxPAS(1)=(0.,0.) 
       xxPAS(-2)=cmplx(sx22,0.) 
       xxPAS(2)=cmplx(sx22,0.) 

       call vecxmat(2,xxPAS,Dsxct,sx2C)
!      sc2C(n) are the components of the tensor in the crystal system.  
!      Taking these components (the Cathesian one) to the program called
!      by  {eu} [9 Euler angles of PAS of 2. rank tensor]               
!      the PAS-values and Euler angles are obtained back.               
              ! b_sx2                                                   
      end if 
                                                                        
!     <x2> tensor                                                       
!     see comment on the <sx2> tensor                                   
      b_x2gt0=abs(d_x2).gt.0. 
      if(b_x2) then 
       if(b_x2a) call dimj(-psi_xx*rad,-theta_xx*rad,-phi_xx*rad,2,Dxxct)
                                                                        
       x22=eta_xx/sqrt(6.) 
       xxPAS(0)=cmplx(1.,0.0) 
       xxPAS(-1)=(0.,0.) 
       xxPAS(1)=(0.,0.) 
       xxPAS(-2)=cmplx(x22,0.) 
       xxPAS(2)=cmplx(x22,0.) 
                                                                        
       call vecxmat(2,xxPAS,Dxxct,x2C)   
      end if ! b_x2 
                                                                        
      phiE_r  =phi_CE*rad 
      thetaE_r=theta_CE*rad 
      psiE_r  =psi_CE*rad 
                                                                        
      b_eqgt0=abs(DEq).gt.0. 
      if(b_eq)then 
!      efg (-2..2) are the spherical tensor components of the EFG in the PAS
       efg0=1.0/sqrt(1.+eta**2/3.) 
       efg2=eta*efg0/sqrt(6.) 
                                                                        
       efgPAS(0)=cmplx(efg0,0.0) 
       efgPAS(-1)=(0.,0.) 
       efgPAS(1)=(0.,0.) 
       efgPAS(-2)=cmplx(efg2,0.) 
       efgPAS(2)=cmplx(efg2,0.) 
                                                                        
       if(b_eqa) call dimj(-psiE_r,-thetaE_r,-phiE_r,2,Dect) 
       call vecxmat(2,efgPAS,Dect,efgC)   
      end if  ! b_eq
                                                                        
!-----enable write-----EFG (site 1) in the crystal system --------------
       if(enwr(6)(1:2).eq.'s1') then 
        if(enwr(6)(3:4).eq.'cx') then 
         h=0.5*d_x2 
         txx=real(-x2C(0)+q62*(x2C(2)+x2C(-2)))*h 
         tyy=real(-x2C(0)-q62*(x2C(2)+x2C(-2)))*h 
         tzz=2*real(x2C(0))*h 
         txy=-real(q62*(x2C(2)-x2C(-2))*cmplx(0.,1.))*h 
         txz=-real(q62*(x2C(1)-x2C(-1)))*h 
         tyz=real(q62*(x2C(1)+x2C(-1))*cmplx(0.,1.))*h 
         write(nwr,'(2x,a,2(f7.3,1x),f7.3,a1)')                         &
         '            x ( ',txx,txy,txz,')'                            
         write(nwr,'(2x,a,8x,f7.3,1x,f7.3,a1)')                         &
         '<i|T_C|k> = y ( ',tyy,tyz,')'                                
         write(nwr,'(2x,a,16x,f7.3,a1)')                                &
         '            z ( ',tzz,')'                                    
                                                                        
        else if(enwr(6)(3:4).eq.'sx') then 
         h=0.5*dsx2 
         txx=real(-sx2C(0)+q62*(sx2C(2)+sx2C(-2)))*h 
         tyy=real(-sx2C(0)-q62*(sx2C(2)+sx2C(-2)))*h 
         tzz=2*real(sx2C(0))*h 
         txy=-real(q62*(sx2C(2)-sx2C(-2))*cmplx(0.,1.))*h 
         txz=-real(q62*(sx2C(1)-sx2C(-1)))*h 
         tyz=real(q62*(sx2C(1)+sx2C(-1))*cmplx(0.,1.))*h 
         write(nwr,'(a,/)') '-- local <sx> in the S_C -- site 1' 
         write(nwr,'(2x,a,2(f7.3,1x),f7.3,a1)')                         &
         '            x ( ',txx,txy,txz,')'                            
         write(nwr,'(2x,a,8x,f7.3,1x,f7.3,a1)')                         &
         '<i|T_C|k> = y ( ',tyy,tyz,')'                                
         write(nwr,'(2x,a,16x,f7.3,a1)')                                &
         '            z ( ',tzz,')'                                    
        else if(enwr(6)(3:4).eq.'ef') then 
         txx=real(-efgC(0)+q62*(efgC(2)+efgC(-2))) 
         tyy=real(-efgC(0)-q62*(efgC(2)+efgC(-2))) 
         tzz=2*real(efgC(0)) 
         txy=-real(q62*(efgC(2)-efgC(-2))*cmplx(0.,1.)) 
         txz=-real(q62*(efgC(1)-efgC(-1))) 
         tyz=real(q62*(efgC(1)+efgC(-1))*cmplx(0.,1.)) 
         write(nwr,'(a,/)') '-- EFG in the crystal system -- site 1' 
                                                                        
         call dimj(phiE_r,thetaE_r,psiE_r,1,d21) 
                                                                        
         uveca(1,1)=0.5*real(d21(1,1)-d21(-1,1)-d21(1,-1)+d21(-1,-1)) 
         uveca(1,2)=-0.5*aimag(d21(1,1)+d21(-1,1)-d21(1,-1)-d21(-1,-1)) 
         uveca(1,3)=-1./sqrt2*real(d21(0,1)-d21(0,-1)) 
                                                                        
         uveca(2,1)=0.5*aimag(d21(1,1)-d21(-1,1)+d21(1,-1)-d21(-1,-1)) 
         uveca(2,2)=0.5*real(d21(1,1)+d21(-1,1)+d21(1,-1)+d21(-1,-1)) 
         uveca(2,3)=-1./sqrt2*aimag(d21(0,1)+d21(0,-1)) 
                                                                        
         uveca(3,1)=-1./sqrt2*real(d21(1,0)-d21(-1,0)) 
         uveca(3,2)=1./sqrt2*aimag(d21(1,0)+d21(-1,0)) 
         uveca(3,3)=real(d21(0,0)) 
                                                                        
                                                                        
         vik(1,1)=txx 
         vik(1,2)=txy 
         vik(1,3)=txz 
         vik(2,1)=txy 
         vik(2,2)=tyy 
         vik(2,3)=tyz 
         vik(3,1)=txz 
         vik(3,2)=tyz 
         vik(3,3)=tzz 
                                                                        
         do i=1,3 
         do l=1,3 
          h1=0.0 
          do j=1,3 
          do k=1,3 
           h1=h1+uveca(i,k)*vik(k,j)*uveca(l,j) 
          end do 
          end do 
          vdd(i,l)=h1 
         end do 
         end do 
         write(nwr,'(10x,a,3(f7.3,a1))')                                &
         '      ( ',vdd(1,1),',',vdd(1,2),',',vdd(1,3),')'             
         write(nwr,'(a10,a,3(f7.3,a1))')'          ',                   &
         'tik = ( ',vdd(2,1),',',vdd(2,2),',',vdd(2,3),')'             
         write(nwr,'(10x,a,3(f7.3,a1),/)')                              &
         '      ( ',vdd(3,1),',',vdd(3,2),',',vdd(3,3),')'             
                                                                        
!         write(nwr,'(2(6x,a,3(f8.3,a1)))') &                            
!         'eQx=(',uveca(1,1),',',uveca(1,2),',',uveca(1,3),')'         
!         write(nwr,'(2(6x,a,3(f8.3,a1)))') &                            
!         'eQy=(',uveca(2,1),',',uveca(2,2),',',uveca(2,3),')'         
!         write(nwr,'(2(6x,a,3(f8.3,a1)))') &                            
!         'eQz=(',uveca(3,1),',',uveca(3,2),',',uveca(3,3),')'         
                                                                        
         write(nwr,'(2x,a,2(f7.3,1x),f7.3,a1,2(4x,a,3(f7.3,a1)))')      &
          '            x ( ',txx,txy,txz,')',                           &
          ' u = x (',uveca(1,1),',',uveca(1,2),',',uveca(1,3),')'       
                                                                        
         write(nwr,'(2x,a,8x,f7.3,1x,f7.3,a1,2(4x,a,3(f7.3,a1)))')      &
          '<i|T_C|k> = y ( ',tyy,tyz,')',                               &
          '   = y (',uveca(2,1),',',uveca(2,2),',',uveca(2,3),')'       
         write(nwr,'(2x,a,16x,f7.3,a1,2(4x,a,3(f7.3,a1)))')             &
          '            z ( ',tzz,')',                                   &
          '   = z (',uveca(3,1),',',uveca(3,2),',',uveca(3,3),')'       
        end if 
       end if 
!------end enable write---------------------------------------------    
                                                                        
!     Transformation of the tensors sx2,x2 tensor given in the crystal  
!     system  to the lab-system.                                        
!     The gamma-direction is parallel to +z of the lab-system.          
!     The orientation of the crystal in the laboratory is decribed by   
!     the Euler angles (phi,theta,psi). e_z(S_C) in the la. system S_L  
!     determines phi,theta, which are the polar angle of e_z(S_C).      
!     The Euler angles are obtained with the                            
!     program euler in the directory effi/helproutines/euler:           
!      [1 Euler angles from unit vectors]->[unit vectors eb(n) in system
!     Input are the unit vectors e_C=eb(x,y,z) of the crystal system S_C
!      with respect to the lab. system S_L.                             
!     The tensor components known in the system S_C are tranformed to th
!     Lab. system by the invers transformation Dsl(-psi,-theta,-phi).   
!     Symbolic:  e_C in S_L  -> t_L=t_C*dlc^(-1)                        
!     (see comment for sx2 above)                                       
      b_laba0=abs(phi_ls)+abs(theta_ls)+abs(psi_ls).lt.0.001 
      if(b_laba)then 
!      write(6,'(a,3f10.2)')' phi,theta,psi_ls=',phi_ls,theta_ls,psi_ls 
                                                                        
       phi_r=phi_ls*rad 
       theta_r=theta_ls*rad 
       psi_r=psi_ls*rad 
!      1. rank tensor transformation matrix: crystal/sample to Lab      
       call dimj(-psi_r,-theta_r,-phi_r,1,Dslv) 
!      2. rank tensor transformation matrix: crstal/sample to Lab       
       call dimj(-psi_r,-theta_r,-phi_r,2,Dslt)
      end if ! b_laba (lab angle) 
                                                                        
!     write(6,'(10f8.4)')Dslt                                           
!     electric field gradient tensor  transformed to the crystal system 
!     (see comment for sx2 above)                                       
                                                                        
!     magnetic field                                                    
      b_Hegt0=abs(Hext).gt.0.0 
      b_Higt0=abs(aH).gt.0.0 
      b_Hgt0=b_Higt0.or.b_Hegt0 
      if(b_Hi) then 
       phiH_r=phiH*rad 
       thetaH_r=thetaH*rad 
       hv(1) =-cmplx(cos(phiH_r),sin(phiH_r))*                          &
                     sin(thetaH_r)/sqrt2                              
       hv(0) = cmplx(cos(thetaH_r),0.0) 
       hv(-1)=-conjg(hv(1)) 
!      write(6,'(a,f10.1,a2,6f10.4)') 'hv  = ',aH,'*(',hv               
                                                                        
       if(icase.eq.1) then 
!       internal field with respect to the EFG system                   
!       transformation of the magnetic field H from the  S_E to the     
!       crystal system S_C. hvC(n) in the crystal system  S_C.          
        if(b_eqa) call dimj(-psiE_r,-thetaE_r,-phiE_r,1,Decv) 
        call vecxmat(1,hv,Decv,hvC)   
!        write(6,'(a,8f12.4)') 'hv    =',(hvC(i),i=-1,1)                
       else 
!       magnetic field given in the crystal system Sc                   
         hvC= hv 
       end if ! case 1
      end if  ! b_Hi
                                                                        
!-----enable write---H-field in the crystal system -----------------    
      if(enwr(6).eq.'s1hf') then 
       hx=-real(hvC(1)-hvC(-1))/sqrt2 
       hy= real((hvC(1)+hvC(-1))*cmplx(0.,1.))/sqrt2 
       hz= real(hvC(0)) 
       write(nwr,'(/,a,3f8.3,a1)')'        h_C =   (', hx,hy,hz,')' 
      end if 
!--------------------------------------------------------------------   
                                                                        
!      external field defined in the LAB system S_L                     
       if(b_Hea)then 
        phiHe_r=phiHe*rad 
        thetaHe_r=thetaHe*rad 
        hve(1) =-cmplx(cos(phiHe_r),sin(phiHe_r))*                      &
                       sin(thetaHe_r)/sqrt2                            
        hve(0) = cmplx(cos(thetaHe_r),0.0) 
        hve(-1)=-conjg(hve(1)) 
       end if 
                                                                        
!      storing the tensors of the 1. site if there are nloop+1          
!      equivalent sites (nloop >0)                                      
       efgC0=efgC 
       sx2C0=sx2C 
       hvC0 =hvC 
                                                                        
!      ----------------------------------------------------             
!       thetaOM(1)=54.7*rad                                             
!       phiOM(1)=pi/4.                                                  
!       thetaOM(1)=0.                                                   
!      Omega loop in case of an average over different crystal          
!      orientations: powder, texture                                    
!      ----------------------- loops-----------------------             
      psiOMa=2.*pi/(n_psi+1) 
      jljpjO=0 
      Stexture=0.0 
      do jOM=1,iOM 
!      write(6,'(a,i4,f12.3)')'jOM,thetaOM(jOM))=',jOM,thetaOM(jOM)     
       cost2=cos(thetaOM(jOM))**2 
       texture=(1.+t200*(3.0*cost2-1.)/2.                               &
                +t400*((35*cost2-30)*cost2+3.)/8.)/float(n_all)        
!      loop over equivalent sites. In the routine sym_equiv(...,d1,d2)  
!      the transformations d1 and d2 and timeinv() are defined          
!      write(6,'(a,2i4)')' nloop_b,nloop_e=',nloop_b,nloop_e            
       do jloop=nloop_b,nloop_e 
                                                                        
        if(jloop.gt.0) then 
         if(b_Higt0) then 
          do n=-1,1 
           hc1=(0.,0.) 
           do m=-1,1 
            hc1=hc1+hvC0(m)*d1(m,n,jloop) 
           end do 
           hvC(n)=hc1*timeinv(jloop) 
          end do 
         end if 
                                                                        
         if(b_eqgt0)then 
          do n=-2,2 
           hc1=(0.,0.) 
           do m=-2,2 
            hc1=hc1+efgC0(m)*d2(m,n,jloop) 
           end do 
           efgC(n)=hc1 
          end do 

         end if 
         if(b_sx2gt0)then 
          do n=-2,2 
           hc1=(0.,0.) 
           do m=-2,2 
            hc1=hc1+sx2C0(m)*d2(m,n,jloop) 
           end do 
           sx2C(n)=hc1 
          end do 
         end if 
        else 
         do m=-2,2 
          efgC(m)=efgC0(m) 
         end do 
         do m=-2,2 
          sx2C(m)=sx2C0(m) 
         end do 
         do i=-1,1 
          hvC(i)=hvC0(i) 
         end do 
        end if   ! jloop > 0   
                                                                        
!------enable write--- of site i ------------------------------------   
       if(enwr(6)(1:2).eq.'si') then 
        b_wrtensor=.false. 
        if(enwr(6)(3:4).eq.'cx') then 
         h=0.5*d_x2 
         txx=real(-x2C(0)+q62*(x2C(2)+x2C(-2)))*h 
         tyy=real(-x2C(0)-q62*(x2C(2)+x2C(-2)))*h 
         tzz=2*real(x2C(0))*h 
         txy=-real(q62*(x2C(2)-x2C(-2))*cmplx(0.,1.))*h 
         txz=-real(q62*(x2C(1)-x2C(-1)))*h 
         tyz=real(q62*(x2C(1)+x2C(-1))*cmplx(0.,1.))*h 
         write(nwr,'(/,a,i2,/)') '--- equivalent <xx> ---- site',jloop+1 
         b_wrtensor=.true. 
        else if(enwr(6)(3:4).eq.'sx') then 
         h=0.5*dsx2 
         txx=real(-sx2C(0)+q62*(sx2C(2)+sx2C(-2)))*h 
         tyy=real(-sx2C(0)-q62*(sx2C(2)+sx2C(-2)))*h 
         tzz=2*real(sx2C(0))*h 
         txy=-real(q62*(sx2C(2)-sx2C(-2))*cmplx(0.,1.))*h 
         txz=-real(q62*(sx2C(1)-sx2C(-1)))*h 
         tyz=real(q62*(sx2C(1)+sx2C(-1))*cmplx(0.,1.))*h 
         write(nwr,'(/,a,i2,/)') '--- equivalent <sx> ---- site',jloop+1 
         b_wrtensor=.true. 
        else if(enwr(6)(3:4).eq.'ef') then 
         txx=real(-efgC(0)+q62*(efgC(2)+efgC(-2))) 
         tyy=real(-efgC(0)-q62*(efgC(2)+efgC(-2))) 
         tzz=2*real(efgC(0)) 
         txy=-real(q62*(efgC(2)-efgC(-2))*cmplx(0.,1.)) 
         txz=-real(q62*(efgC(1)-efgC(-1))) 
         tyz=real(q62*(efgC(1)+efgC(-1))*cmplx(0.,1.)) 
         write(nwr,'(/,a,i2,/)') '--- equivalent EFGs ---- site',jloop+1 
         b_wrtensor=.true. 
!-------enable write------H-field in the crystal system --------------  
        else if(enwr(6)(3:4).eq.'hf') then 
         hx=-real(hvC(1)-hvC(-1))/sqrt2 
         hy= real((hvC(1)+hvC(-1))*cmplx(0.,1.))/sqrt2 
         hz= real(hvC(0)) 
         thetaC=arcos(hz) 
         sintC=sin(thetaC) 
         if(sintC.lt.0.001) then 
          phiC=0.0 
         else 
          phic=arcos(hx/sintC) 
          if(hy.lt.0.)phiC=2.*pi-phiC 
         end if 
                                                                        
         write(nwr,'(/,a,i2,a,3f8.3,a4,2f8.3,a1)')' site',jloop+1,      &
            ' ------  h_C = (',hx,hy,hz,'):=(',thetaC/rad,phiC/rad,')' 
        end if 
        if(b_wrtensor)then 
         write(nwr,'(2x,a,2(f7.3,1x),f7.3,a1,2(4x,a,3(f7.3,a1)))')      &
         '            x ( ',txx,txy,txz,')'
         write(nwr,'(2x,a,8x,f7.3,1x,f7.3,a1,2(4x,a,3(f7.3,a1)))')      &
         '<i|t_c|k> = y ( ',tyy,tyz,')'
         write(nwr,'(2x,a,16x,f7.3,a1,2(4x,a,3(f7.3,a1)))')             &
         '            z ( ',tzz,')'
        end if 
       end if 
!------enable write--- of site i ------------------------------------   
                                                                        
       do jpsi=0,n_psi 
!       averaging over psiOM with n_psi+1 steps                         
        jljpjO=jljpjO+1 
        Stexture= Stexture+ texture 
!       write(6,'(a,i4,f10.3)')' jpsi,texture=',jpsi,texture            
        if(b_Hgt0) then 
!        The grid point p(thetaOM,phiOM) defines z-axis of the system   
!        S_S of the sample. (If the sample is not rotated S_S coincides 
!        with the lab. system S_L, and the z_axis is the direction of   
!        observation).                                                  
!        The rotation around the z-axis starts with angle psiOM         
!        and has n_psi steps for averaging. The components in the       
!        S_OM system are                                                
!        Symbolic:  e_OM in S_C  -> t_C*dcs=t_OM   (t_S=t_OM)           
!        If the sample system S_S  is rotated with respect to the Lab. s
!        -Dsl (=djsl)- the tensor components are                        
!        transformations are:                                           
!         Symbolic:  e_S in S_L  -> t_L=t_S*dls^(-1)                    
!                                   t_L= t_C*dcs*dls^(-1)               
                                                                        
!           write(6,'(i3,a,3f10.3,3x,3f9.3)')jOM,' phi,theta,psi=',     
!     &                phiOM(jOM),thetaOM(jOM),psiOM(jOM)               
         call dimj(phiOM(jOM),thetaOM(jOM),psiOM(jOM)+jpsi*psiOMa,1,Dcpv) 
         if(b_laba0)then 
!         1. rank tensor transformation                                 
          Dclv=Dcpv 
         else
          Dclv=matmul(Dcpv,Dslv)
         end if 
                                                                        
         call vecxmat(1,hvC,Dclv,hvL)   
         hvL=hvL*aH+hve*Hext 
        else 
         hvL=(0.,0.)
        end if    ! b_Hgt0 

        call dimj(phiOM(jOM),thetaOM(jOM),psiOM(jOM)+jpsi*psiOMa,2,Dcpt) 
        if(b_laba0)then 
!        2. rank tensor transformation                                  
         Dclt=Dcpt 
        else 
         Dclt=matmul(Dcpt,Dslt) 
        end if 
                                                                        
        if(b_eqgt0)then
         call vecxmat(2,efgC,Dclt,efgL)   
         efgL=efgL*Deq
        else 
          efgL=(0.,0.) 
        end if   ! b_eqgt0
                                                                        
        if(b_sx2gt0)then 
         hc1=(0.,0.) 
         do m=-2,2 
          hc1=hc1+sx2C(m)*Dclt(m,0) 
         end do 
         aszz=real(hc1) 
        else 
         aszz=0. 
        end if  ! b_sx2gt0   
                                                                        
        if(b_x2gt0)then 
         call vecxmat(2,x2C,Dclt,x2Clab)   
         azz=real(x2Clab(0)) 
        else 
         azz=0. 
        end if   ! b_x2gt0  
                                                                        
!-------enable write-------- EFG in the Lab system -------------------  
        if(enwr(6)(1:2).eq.'lb') then 
                                                                        
        if(enwr(6)(3:4).eq.'cx') then 
         h=0.5*d_x2 
         txx=real(-x2Clab(0)+q62*(x2Clab(2)+x2Clab(-2)))*h 
         tyy=real(-x2Clab(0)-q62*(x2Clab(2)+x2Clab(-2)))*h 
         tzz=2*real(x2Clab(0))*h 
         txy=-real(q62*(x2Clab(2)-x2Clab(-2))*cmplx(0.,1.))*h 
         txz=-real(q62*(x2Clab(1)-x2Clab(-1)))*h 
         tyz=real(q62*(x2Clab(1)+x2Clab(-1))*cmplx(0.,1.))*h 
         write(nwr,'(2x,a,6f8.3,a1,3f10.3)')' (',txx,txy,txz,tyy,tyz,tzz,')'
        else if(enwr(6)(3:4).eq.'sx') then 

         write(nwr,'(a,f10.3)')' ez(lab)*<x**2(i)>*ez(lab)=', aszz*dsx2
                                                                        
        else if(enwr(6)(3:4).eq.'ef') then 
         txx=real(-efgL(0)+q62*(efgL(2)+efgL(-2))) 
         tyy=real(-efgL(0)-q62*(efgL(2)+efgL(-2))) 
         tzz=2*real(efgL(0)) 
         txy=-real(q62*(efgL(2)-efgL(-2))*cmplx(0.,1.)) 
         txz=-real(q62*(efgL(1)-efgL(-1))) 
         tyz=real(q62*(efgL(1)+efgL(-1))*cmplx(0.,1.)) 
                                                                        
         write(nwr,'(2x,a,6f8.3,a1,3f10.3)')' (',txx,txy,txz,tyy,tyz,tzz,')'
!         write(nwr,'(a)')                                              
!         write(nwr,'(2x,a,3f8.3,a1)')  '            x (',txx,txy,txz,')
!         write(nwr,'(2x,a,8x,2f8.3,a1)')'<i|V_L|k> = y (',tyy,tyz,')'  
!         write(nwr,'(2x,a,16x,f8.3,a1)')'            z (',tzz,')'      
                                                                        
!-------enable write---H-field in the Lab system ---------------------  
        else if(enwr(6)(3:4).eq.'hf') then 
         hx=-real(hvL(1)-hvL(-1))/sqrt2 
         hy= real((hvL(1)+hvL(-1))*cmplx(0.,1.))/sqrt2 
         hz= real(hvL(0)) 
         write(nwr,'(a,i2,a,3f8.3,a1)')' site',jloop+1,                 &
                   ' ------  h_L = (',hx,hy,hz,')'                            
        end if 
                                                                        
        end if 
!-------enable write-------- in the Lab system -------------------      
                                                                        
        call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvL,efgL,         &
                                                 je,jg,jge,Eagd,V1m,V2m)
        eagd_zz(2)=aszz 
        eagd_zz(4)=dsx2 
        eagd_zz(6)=azz 
        eagd_zz(8)=d_x2 
        eagd_zz(10)=aszz*dsx2+azz*d_x2 
!        write(6,'(a,f12.4)')'aszz*dsx2+azz*d_x2=',aszz*dsx2+azz*d_x2   
        do i=1,jge 
         eagd_zz(2*i-1)=Eagd(i) 
        end do 
        do i=1,jge 
         eagdzz(i)=cmplx(eagd_zz(2*i-1),eagd_zz(2*i)) 
        end do 

!       write(6,'(10f10.3)') (eagdzz(j),j=1,10)   ! trick with equivalen
                                                                        
        ip=nput+2+3*jge*(jljpjO-1) 
        if(r_E2M1.eq.0.)then 
         do i=1,jge 
          pp =real(conjg(V1m(1,i))*V1m(1,i)) 
          hmm=real(conjg(V1m(-1,i))*V1m(-1,i)) 
          ii=ip+3*(i-1) 
          array_fr(ii+1)=eagdzz(i) 
          array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0*texture 
          array_fr(ii+3)=conjg(V1m(1,i))*V1m(-1,i)*texture 
         end do 
        else 
         if(abs(r_E2M1).lt.9999.)then 
!         mixed M1/E2 transition                                        
          do i=1,jge 
             pp1=real(conjg(V1m(1,i))*V1m(1,i)) 
            hmm1=real(conjg(V1m(-1,i))*V1m(-1,i)) 
             pm1=conjg(V1m(1,i))*V1m(-1,i) 
                                                                        
            pp2=real(conjg(V2m(1,i))*V2m(1,i)) 
           hmm2=real(conjg(V2m(-1,i))*V2m(-1,i)) 
            pm2=conjg(V2m(1,i))*V2m(-1,i) 
                                                                        
            pp12= 2.*real(conjg(V2m(1,i))*V1m(1,i)) 
           hmm12=-2.*real(conjg(V2m(-1,i))*V1m(-1,i)) 
            pm12= conjg(V2m(1,i))*V1m(-1,i)-conjg(V1m(1,i))*V2m(-1,i) 
                                                                        
             pp=(pp1 +rEM2*pp2  -r_E2M1*pp12)*qEM2 
            hmm=(hmm1+rEM2*hmm2-r_E2M1*hmm12)*qEM2 
             pm=(pm1 -rEM2*pm2  -r_E2M1*pm12)*qEM2 
!           write(6,'(8f10.3)')eagdzz(i),pp,hmm,pm                      
                                                                        
           ii=ip+3*(i-1) 
           array_fr(ii+1)=eagdzz(i) 
           array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0*texture 
           array_fr(ii+3)=pm*texture 
          end do 
         else 
!         E2 transition                                                 
          do i=1,jge 
           pp =real(conjg(V2m(1,i))*V2m(1,i)) 
           hmm=real(conjg(V2m(-1,i))*V2m(-1,i)) 
           ii=ip+3*(i-1) 
           array_fr(ii+1)=eagdzz(i) 
           array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0*texture 
           array_fr(ii+3)=-conjg(V2m(1,i))*V2m(-1,i)*texture 
          end do 
         end if 
        end if 
       end do    ! n_psi  
       end do    ! nloop 
      end do ! iOM 
                                                                        
      if(enwr(7).eq.'tetu')write(nwr,'(a,f10.3)')'Sum texture=',Stexture 
!     array_fr(nput+i):                                                 
!     (nput+1)=(n_all,jge)    (nput+2) = (b_xx,0)                       
!     (nput+3)=(Eagd(1),aszz) (nput+4) = (pp-hmm,hr+hmm)/2   (nput+5) =p
!     (nput+6)=(Eagd(2),dsx2) (nput+7) = (pp-hmm,hr+hmm)/2   (nput+8) =p
!     (nput+9)=(Eagd(3),dsx2) (nput+10)= (pp-hmm,hr+hmm)/2   (nput+11)=p
!                                                                       
!      ................................................................ 
!                                                                       
!     (nput+j1)=(Eagd(2),dsx2) (nput+j2)= (pp-hmm,hr+hmm)/2   (nput+j3)=
!      j=2+3*(jge-1) j1=j+1,...,j3=j+3                                  
!                                                                       
!     for the case: b_xx=.false. the f-factor fd=exp(-azz*d_x2-aszz*dsx2
!     itself is stored                                                  
                                                                        
      array_fr(nput+1)=cmplx(float(n_all),float(jge)) 
      if(b_xx) then 
       array_fr(nput+2)=cmplx(1.0,0.) 
      else 
       array_fr(nput+2)=cmplx(0.,0.) 
      end if 
!     aimag of array_fr(nput+2) for further use                         
                                                                        
      if(nloop_e.gt.0) then 
!      to be stored in array store() => array_fr()                      
       efgC=efgC0 
       sx2C=sx2C0 
       hvC=hvC0 
      end if 
      j=iput+1 
      do i=1,istore 
       array_fr(j+i)=store(i) 
      end do 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
      subroutine th_hdeq(isubthe,icase,iput,iget,info) 
      use glbconst, only: maxscrd,icstrf,icfr2trf,ivstrf,ivfr2trf,     &
                          infotext,enwr,nwr
      use comthe, only: array_fr,theoryname
      implicit none 
                                                                        
                                                                        
      integer         isubthe,icase,iput,iget,info 
                                                                        
      real            acfr2,rep_grp,aset,asymmetry,dumcfr2 
      common/acfr2trf/acfr2,rep_grp,aset,asymmetry,dumcfr2(icfr2trf-4) 
      logical         bcfr2,bumcfr2 
      common/bcfr2trf/bcfr2,bumcfr2(icfr2trf-1) 
                                                                        
      real           avfr2,pvfr2,Hext,thetaHe,phiHe,                   &
                     phi_ls,theta_ls,psi_ls,dum,dumvfr2                
     common/avfr2trf/avfr2,pvfr2,dum(4),Hext,thetaHe,phiHe,            &
                     phi_ls,theta_ls,psi_ls,dumvfr2(ivfr2trf-12)       
     logical         b_vfr2,b_Hext,b_thetaHe,b_phiHe,                  &
                     b_phils,b_thetals,b_psils,b_dum,b_dumvfr2         
     common/bvfr2trf/b_vfr2,b_dum(5),b_Hext,b_thetaHe,b_phiHe,         &
                     b_phils,b_thetals,b_psils,b_dumvfr2(ivfr2trf-12)  
                                                                       
     real          c1,cTms,ajg,aje,amueg,amuee,QgdQe,r_E2M1,e1m1,      &
                   symcase,timeinvers,dumc                             
     common/acmaps/c1,cTms,ajg,aje,amueg,amuee,QgdQe,r_E2M1,e1m1,      &
                   symcase,timeinvers,dumc(icstrf-11)                  
                                                                       
     real          avm,aH,thetaH,phiH,                                 &
                   DEq,eta,phi_CE,theta_CE,psi_CE,dumvm                
     common/avmaps/avm,aH,thetaH,phiH,                                 &
                   DEq,eta,phi_CE,theta_CE,psi_CE,dumvm(ivstrf-9)      
     logical       b_vm,b_aH,b_thetaH,b_phiH,                          &
                   b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,b_dumvm          
     common/bvmaps/b_vm,b_aH,b_thetaH,b_phiH,                          &
                   b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,b_dumvm(ivstrf-9)
     logical       b_c1,b_dumcm 
     common/bcmaps/b_c1,b_dumcm(icstrf-1) 
                                                                       
     integer,parameter:: maxloop=11,ivv=28,iec=ivv+25,icl=iec+25,     &
                         iecv=icl+9,id1=iecv+9,id2=id1+1+10*maxloop,  &
                         istore=id2+25*maxloop 
     logical,dimension(0:maxloop):: b_timeinv
     integer,dimension(-1:1,-1:1):: ipq
  
     real,dimension(-1:1,-1:1) :: dj1
     real,dimension(-2:2,-2:2) :: dj2
     real,dimension(-1:1)      :: TI1
     real,dimension(-2:2)      :: TI2
     real,dimension(-1:1,4)    :: DH1,DH12,DH21
     real,dimension(-2:2,4)    :: DH2
      
     complex,dimension(-2:2):: efgPAS,efgC,efgC0,efgL,V2mi,V2hi
     complex,dimension(-1:1):: hv,hve,hvL,hvC,hvC0,TI12,TI21,V1mi,V1hi 

     complex,dimension(-2:2,-2:2):: Dslt,Dect,Dcpt 
     complex,dimension(-1:1,-1:1):: Decv,Dslv,Dcpv
     complex,dimension(-2:2,-2:2,maxloop):: d2
     complex,dimension(-1:1,-1:1,maxloop):: d1
     complex,dimension(maxloop) ::ctimeinv

 
     logical  b_He,b_Hi,b_efg,b_eqgt0,b_Hegt0,b_Higt0,b_efgC,b_LS 
     real     phiH_r,thetaH_r,phiHe_r,thetaHe_r,phiE_r,thetaE_r, psiE_r 
                                                                       
     complex,dimension(istore):: store
     complex      caseloop
     equivalence (store(1),efgPAS(-2)),(store(6),efgC(-2)),            &
                 (store(11),efgL(-2)),                                 &
                 (store(16),hv(-1)),(store(19),hve(-1)),               &
                 (store(22),hvC(-1)),(store(25),hvL(-1)),              &
                 (store(ivv),Dect(-2,-2)),(store(iec),Dslt(-2,-2)),    &
                 (store(icl),Decv(-1,-1)),(store(iecv),Dslv(-1,-1)),   &
                 (store(id1),caseloop),(store(id1+1),ctimeinv(1)),     &
            (store(id1+1+maxloop),d1(-1,-1,1)),(store(id2),d2(-2,-2,1))
                                                                       
     integer,parameter :: idumscrd=maxscrd-6144*3-128*3-9*24
     real        phiOM,thetaOM,psiOM,eh,mat,dumscrd          
     common/scrd/phiOM(6144),thetaOM(6144),psiOM(6144),                &
                 eh(3,128),mat(3,3,24),dumscrd(idumscrd)               

     logical b_integer 
     integer je,jg,jge,i,ip,ii,k,j,m,n,nput,n_all,ncase,      &
             jloop,nloop,nloop_b,nloop_e,jOM,iOM,iset,isymmetry,jljO
     real    phils_r,thetals_r,psils_r,rEM2,qEM2,                      &
             a_mueg,a_muee,efg0,efg2,c_Tms,                           &
             pp,hmm,pp1,hmm1,pp2,hmm2,                                &
             pp12,hmm12,h,hx,hy,hz,thetaC,phiC,sintC,arcos,           &
             vxx,vyy,vzz,vxy,vxz,vyz
                                                                       
     complex  pm,pm1,pm2,pm12,hc1,hc2                   
     real,    parameter :: sqrt2=1.4142136,q62=1.224745,              &
                           rad=0.0174533,pi=3.14159 
     complex, parameter:: C0=(0.,0.) 

     real,    dimension(:),   allocatable :: eagd_zz 
     real,    dimension(:),   allocatable :: Eagd
     complex, dimension(:),   allocatable :: eagdzz,rtr,rpm
     complex, dimension(:,:), allocatable :: V1m
     complex, dimension(:,:), allocatable :: V2m
                          
      info=0                                                                  
      jge=(2.*ajg+1)*(2.*aje+1)+0.01 
                                                                        
      if(acfr2.lt.3.)aset=0.0 
!     this way iset,... have not to be defined in frstr_..              
      if(isubthe.lt.0) then 
       theoryname='H_DEQ_equivalent_sites     v=200' 
       if(isubthe.eq.-16) then 
!       reading .par file ncase,symcase are not mapped (-> 8888.88)     
!       asking name with isubthe=-1 the routine sym_equiv (later        
!       calculating storage space) leads to an error exit               
        symcase=0.0 
        ncase=0 
        return 
       end if 
       ncase=symcase 
       call sym_equiv(-ncase,timeinvers,nloop,ctimeinv,d1,d2) 
       if(nloop.eq.-1)nloop=0 
       iset=aset 
       isymmetry=asymmetry 
       if(iset.gt.0.and.isymmetry.gt.0) then 
       call sphere(-iset,isymmetry,.true.,iOM,phiOM,thetaOM,psiOM,      &
     &                                                 eh,mat)          
        c1=1+istore+2+3*jge*(nloop+1)*iOM+iOM 
       else if(iset.gt.0.and.isymmetry.eq.0) then 
        c1=1+istore+2+3*jge+1 
       else 
        c1=1+istore+2+3*jge*(nloop+1)+1 
       end if 
                                                                        
       return 
      end if 
                                                                        
      if(.not.(b_vm.or.b_vfr2)) then 
                                         ! 24.10.07 theory not changed  
       isubthe=-abs(isubthe) 
!      write(6,'(a)') ' no change in th_hdeq'                           
       return 
      end if 
! ----------------------------------------------------------------------
!      write(6,'(a)')'th_22nuclear avfr2...'                            
!      write(6,'(6f10.2)')Hext,thetaHe,phiHe,phi_ls,theta_ls,psi_ls     
!      write(6,'(6L5)')b_Hext,b_thetaHe,b_phiHe,b_phils,b_thetals,b_psil
  allocate(Eagd(jge),eagd_zz(2*jge),V1m(-1:1,jge),V2m(-2:2,jge),&
           eagdzz(jge),rtr(jge),rpm(jge))
                                                                        
      j=iput+1 
      nput=j+istore 
      do i=1,istore 
       store(i)=array_fr(j+i) 
      end do 
      array_fr(j)=cmplx(float(nput),float(istore)) 
!      write(6,'(8f10.1)')store                                         
!     logicals 
!     write(6,'(a,5f12.4)') 'DEq,eta,phi_CE,theta_CE,psi_CE=',    &
!            DEq,eta,phi_CE,theta_CE,psi_CE
                                                         
      b_efg=b_DEq.or.b_eta 
      b_eqgt0=abs(DEq).gt.0. 
      b_Hegt0=abs(Hext).gt.0.0 
      b_Higt0=abs(aH).gt.0.0 

      b_He=b_Hext.or.b_thetaHe.or.b_phiHe 
      b_Hi=b_aH.or.b_thetaH.or.b_phiH 
      b_LS=b_phils.or.b_thetals.or.b_psils 
      b_efgC=b_phiE.or.b_thetaE.or.b_psiE 

!     write(6,'(a,L5,5f12.4)') ' b_LS,phi_ls,theta_ls,psi_lsE=',    &
!                             b_LS,phi_ls,theta_ls,psi_ls
                                                                        
                                                                        
                                                                        
      phils_r=phi_ls*rad 
      thetals_r=theta_ls*rad 
      psils_r=psi_ls*rad 
                                                                        
      phiE_r=phi_CE*rad 
      thetaE_r=theta_CE*rad 
      psiE_r=psi_CE*rad 
                                                                        
      a_mueg=amueg 
      a_muee=amuee 
      c_Tms=cTms 
      rEM2=r_E2M1**2 
      qEM2=1./(1.+rEM2) 
                                                                        
      iset=aset 
      ncase=symcase 
      isymmetry=asymmetry 
                                                                        
      ii=jge/2 
      if(2*ii.eq.jge) then 
       b_integer=.false. 
       je=2*aje+0.01 
       jg=2*ajg+0.01 
      else 
       b_integer=.true. 
       je=aje+0.01 
       jg=ajg+0.01 
      end if 
                                                                        
!     icase=1,2 magnetic field aH defined with respect to S_E, S_C      
      nloop_b=0 
      if(b_c1) then 
       call sym_equiv(ncase,timeinvers,nloop,ctimeinv,d1,d2) 
       nloop_e=nloop 
       if(nloop.eq.-1)then 
        nloop_b=1 
        nloop_e=1 
       end if 
      else 
       nloop=real(caseloop) 
!      write(6,'(a,i6)')'th_22nuclear nloop=',nloop                     
       nloop_e=nloop 
       if(nloop.eq.-1)then 
        nloop_b=1 
        nloop_e=1 
       end if 
      end if 
      b_timeinv(0)=.false. 
      do k=1,nloop_e 
       b_timeinv(k)=real(ctimeinv(k)).lt.0. 
      end do 
                                                                        
      if(bcfr2) then 
       call sphere(iset,isymmetry,.true.,iOM,phiOM,thetaOM,psiOM,       &
                                                       eh,mat)          
       caseloop=cmplx(float(nloop),float(iOM)) 
!      write(6,'(a,i6)')'bcfr2 th_22nuclear nloop=',nloop               
       if(nloop.eq.-1)then 
        n_all=iOM 
       else 
        n_all=iOM*(nloop+1) 
       end if 
       j=nput+2+3*jge*n_all 
       do i=1,iOM 
        array_fr(j+i)=cmplx(thetaOM(i),phiOM(i)) 
       end do 
      else 
       iOM=aimag(caseloop) 
       if(nloop.eq.-1)then 
        n_all=iOM 
       else 
        n_all=iOM*(nloop+1) 
       end if 
       j=nput+2+3*jge*n_all 
       do i=1,iOM 
        thetaOM(i)=real(array_fr(j+i)) 
        phiOM(i) =aimag(array_fr(j+i)) 
       end do 
      end if 
      caseloop=cmplx(float(nloop),float(iOM)) 
!     write(6,'(a,5f12.6)') '   efg=', eta,phi_CE,theta_CE,psi_CE       
!     write(6,'(a,5f12.6)') '    H=',aH,phiH,thetaH                     
!     write(6,'(a,5f12.6)') '    A=',phi_ls,theta_ls,psi_ls             
!     write(6,'(a,3i6)')'thmossub  sym=',inv_time,nconyi,nconzi         
                                                                        
                                                                  
      if(b_efg)then 
       if(b_eqgt0)then 
!       efg (-2..2) are the spherical tensor components of the EFG in th
        efg0=1./sqrt(1.+eta**2/3.) 
        efg2=eta*efg0/sqrt(6.) 
                                                                        
        efgPAS(0)=cmplx(efg0,0.0) 
        efgPAS(-1)=C0 
        efgPAS(1)=C0 
        efgPAS(-2)=cmplx(efg2,0.) 
        efgPAS(2)=cmplx(efg2,0.) 
       else 
        efgPAS=C0
       end if 
      end if 
      if(b_He)then 
       if(b_Hegt0)then 
!       external field defined in the LAB system S_L                    
        phiHe_r=phiHe*rad 
        thetaHe_r=thetaHe*rad 
        hve(1) =-cmplx(cos(phiHe_r),sin(phiHe_r))*                      &
                       sin(thetaHe_r)/sqrt2*Hext                       
        hve(0) = cmplx(cos(thetaHe_r),0.0)*Hext 
        hve(-1)=-conjg(hve(1)) 
       else 
        hve=C0
       end if 
      end if 
!      write(6,*)'b_He,b_Hegt0,Hext,aH=',b_He,b_Hegt0,Hext,aH                                                                  
!      write(6,'(a,8f12.4)') 'hve    =',hve                
                                                                        
      if(b_Hi)then 
       if(b_Higt0) then 
!      internal field hv defined in the system S_E or S_C (case)        
        phiH_r=phiH*rad 
        thetaH_r=thetaH*rad 
        hv(1) =-cmplx(cos(phiH_r),sin(phiH_r))*                         &
                      sin(thetaH_r)/sqrt2*aH                           
        hv(0) = cmplx(cos(thetaH_r),0.0)*aH 
        hv(-1)=-conjg(hv(1)) 
       else 
        hv=C0
       end if 
      end if 
!      write(6,'(a,8f12.4)') 'hv    =',hv                   
! --------------------------------------------------------------------  
      if(iset.eq.0) then 
!      single crystal case,  EFG(efgL) in the S_L sytem                 
!      transformation:                                                  
!      Sum;n T(n)*Dnm(phi_CE,teta_CE,psi_CE) = T(m)                     
                                                                        
       if(b_efgC) call dimj(-psiE_r,-thetaE_r,-phiE_r,2,Dect)
       if(b_efg.or.b_efgC) call vecxmat(2,efgPAS,Dect,efgC)       
       if(b_LS) call dimj(-psils_r,-thetals_r,-phils_r,2,Dslt)

       if(b_efg.or.b_efgC.or.b_LS)then 
        call vecxmat(2,efgC,Dslt,efgL)                        
        efgL=efgL*Deq
       end if 
                                                                        
       if(icase.eq.1)then 
!       transformation of the magnetic field H (hv) from the  S_E to    
!       the crystal system S_C  (hvC(n) in the crystal system  S_C)     
        if(b_efgC) call dimj(-psiE_r,-thetaE_r,-phiE_r,1,Decv)
        if(b_LS.or.b_Hi.or.b_efgC)then 
         call vecxmat(1,hv,Decv,hvC) 
        else
         hvC=C0
        end if 
       else 
!       magnetic field given in the crystal system Sc                   
        hvC=hv
       end if  ! case 1 

!       write(6,'(a,8f12.4)') 'hvC    =',hvC 
!       write(6,'(a,8f12.4)') 'hv    =',hv     
!------enable write------H-field in the crystal system --------------   
       if(enwr(6).eq.'sihf') then 
        hx=-real(hvC(1)-hvC(-1))/sqrt2 
        hy= real((hvC(1)+hvC(-1))*cmplx(0.,1.))/sqrt2 
        hz= real(hvC(0)) 
!        hz= real(hvC(0))+49.72                                         
        h=sqrt(hx**2+hy**2+hz**2) 
        if(abs(h).gt.0.01)then 
         thetaC=arcos(hz/h) 
         sintC=sin(thetaC) 
         if(sintC.lt.0.001) then 
          phiC=0.0 
         else 
          phic=arcos(hx/h/sintC) 
          if(hy.lt.0.)phiC=2.*pi-phiC 
         end if 
                                                                        
         write(nwr,'(/,a,3f8.3,a2,f7.2,a2,2f7.2,a1)')                   &
            ' H_C = (',hx,hy,hz,')=',h,'*(',thetaC/rad,phiC/rad,')'     
        else 
         write(nwr,'(/,a,3f8.3,a2)')' H_C = (',hx,hy,hz,')' 
        end if 
       end if 
!--------------------------------------------------------------------   
!       magnetic field transformed to the Lab system       
       if(b_LS) call dimj(-psils_r,-thetals_r,-phils_r,1,Dslv)

       if(b_LS.or.b_Hi.or.b_He.or.b_efgC)then 
        call vecxmat(1,hvC,Dslv,hvL) 
        hvL=hvL+hve
       end if 
!       write(6,'(a,8f12.4)') 'hve    =',hve 
!       write(6,'(a,8f12.4)') 'hvL    =',hvL  
!-------enable write-------- EFG in the Lab system -------------------  
        if(enwr(6).eq.'lbef') then 
         vxx=real(-efgL(0)+q62*(efgL(2)+efgL(-2))) 
         vyy=real(-efgL(0)-q62*(efgL(2)+efgL(-2))) 
         vzz=2*real(efgL(0)) 
         vxy=-real(q62*(efgL(2)-efgL(-2))*cmplx(0.,1.)) 
         vxz=-real(q62*(efgL(1)-efgL(-1))) 
         vyz=real(q62*(efgL(1)+efgL(-1))*cmplx(0.,1.)) 
                                                                        
         write(nwr,'(a)') 
         write(nwr,'(2x,a,3f8.3,a1)')  '            x (',vxx,vxy,vxz,')' 
         write(nwr,'(2x,a,8x,2f8.3,a1)')'<i|V_L|k> = y (',vyy,vyz,')' 
         write(nwr,'(2x,a,16x,f8.3,a1)')'            z (',vzz,')' 
        end if 
!-------enable write---H-field in the Lab system ---------------------  
        if(enwr(6).eq.'lbhf') then 
         hx=-real(hvL(1)-hvL(-1))/sqrt2 
         hy= real((hvL(1)+hvL(-1))*cmplx(0.,1.))/sqrt2 
         hz= real(hvL(0)) 
         write(nwr,'(/,a,3f8.3,a1)')' H_L = (',hx,hy,hz,')'                                    
        end if
!--------------------------------------------------------------------   
       call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvL,efgL,          &
                                                 je,jg,jge,Eagd,V1m,V2m)
       do i=1,jge 
        eagd_zz(2*i-1)=Eagd(i) 
       end do 
                                                                        
       n_all=nloop_e-nloop_b+1 
       do i=1,jge 
!       transformation (rotation and time inversion) of V1m,V2m         
!       calculation of r_pq and averaging                               
        pp=0. 
        hmm=0. 
        pm=C0 
                                                                        
        do jloop=nloop_b,nloop_e 
                                                                        
          if(b_timeinv(jloop))then 
           do m=-1,1 
            V1mi(m)=-(-1)**m*conjg(V1m(-m,i)) 
           end do 
           do m=-1,1 
            V2mi(m)=(-1)**m*conjg(V1m(-m,i)) 
           end do 
          else 
           do m=-1,1 
            V1mi(m)=V1m(m,i) 
           end do 
           do m=-2,2 
            V2mi(m)=V2m(m,i) 
           end do 
          end if 
                                                                        
         if(jloop.gt.0) then 
          do n=-1,1 
           hc1=C0 
           do m=-1,1 
            hc1=hc1+V1mi(m)*d1(m,n,jloop) 
           end do 
           V1hi(n)=hc1 
          end do 
          V1mi= V1hi 
                                                                        
          do n=-2,2 
           hc1=C0 
           do m=-2,2 
            hc1=hc1+V2mi(m)*d2(m,n,jloop) 
           end do 
           V2hi(n)=hc1 
          end do 
          V2mi=V2hi
         end if 
!         if(jloop.gt.0)write(6,'(9f9.3)') (V1mi(m),m=-1,1)             
!         if(jloop.gt.0)write(6,'(9f10.5)')real(conjg(V1mi(1))*V1mi(1)),
!     &   real(conjg(V1mi(-1))*V1mi(-1)),conjg(V1mi(1))*V1mi(-1),Eagd(i)
                                                                        
         if(r_E2M1.eq.0.)then 
          pp =pp+real(conjg(V1mi(1))*V1mi(1)) 
          hmm=hmm+real(conjg(V1mi(-1))*V1mi(-1)) 
          pm =pm+conjg(V1mi(1))*V1mi(-1) 
         else 
          if(abs(r_E2M1).lt.9999.)then 
!          mixed M1/E2 transition                                       
           pp1 =real(conjg(V1mi(1))*V1mi(1)) 
           hmm1=real(conjg(V1mi(-1))*V1mi(-1)) 
            pm1=conjg(V1mi(1))*V1mi(-1) 
                                                                        
            pp2=real(conjg(V2mi(1))*V2mi(1)) 
           hmm2=real(conjg(V2mi(-1))*V2mi(-1)) 
            pm2=conjg(V2mi(1))*V2mi(-1) 
                                                                        
            pp12= 2.*real(conjg(V2mi(1))*V1mi(1)) 
           hmm12=-2.*real(conjg(V2mi(-1))*V1mi(-1)) 
            pm12= conjg(V2mi(1))*V1mi(-1)-conjg(V1mi(1))*V2mi(-1) 
                                                                        
             pp=pp+(pp1 +rEM2*pp2  -r_E2M1*pp12)*qEM2 
            hmm=hmm+(hmm1+rEM2*hmm2-r_E2M1*hmm12)*qEM2 
             pm=pm+(pm1 -rEM2*pm2  -r_E2M1*pm12)*qEM2 
          else 
!          E2 transition                                                
           pp =pp+real(conjg(V2mi(1))*V2mi(1)) 
           hmm=hmm+real(conjg(V2mi(-1))*V2mi(-1)) 
          end if 
         end if 
!        write(6,'(2i3,a,2f10.3,3x,2f10.3)')                            
!     &       i,jloop,' pp,hmm,pm=',real(conjg(V1mi(1))*V1mi(1)),       
!     &  real(conjg(V1mi(-1))*V1mi(-1)),conjg(V1mi(1))*V1mi(-1)         
                  ! nloop                                               
        end do 
                                                                        
        rtr(i)=cmplx(pp-hmm,pp+hmm)/2.0/float(n_all) 
        rpm(i)=pm/float(n_all) 
       end do   ! i=1-jge 
                                                                        
      else 
!      ----------------------powder case  iset>0 -----------------------
!      phi_ls,theta_ls,psi_ls would  rotate a powder (no effect)        
       if(b_Hegt0)then 
!        The polar angles  thetaOM,phiOM define the direction of        
!        the z-axis of one of the crystals of the powder with system S_C
!        rotated with respect to the sample system S_S. (If the sample  
!        is not rotated S_S coincides with the lab. system S_L).        
!        The Euler angles of the rotation are alpha=phiOM and beta=theta
!        and the angle psiOM which is averaged analytically (off diagona
!        elements of r_pq vanish). The components in the S_OM system are
!        (symbolic):  e_OM in S_C  -> t_OM=t_C*d   (t_S=t_OM)           
                                                                        
        array_fr(nput+1)=cmplx(float(n_all),float(jge)) 
        array_fr(nput+2)=C0
        ipq(1,1)=1 
        ipq(-1,-1)=2 
        ipq(1,-1)=3 
        ipq(-1,1)=4 
        call wigner(1,thetaHe_r,dj1) 
        do m=-1,1 
         do i=-1,1,2 
         do k=-1,1,2 
           j=ipq(i,k) 
           DH1(m,j)=dj1(m,i)*dj1(m,k) 
         end do 
         end do 
        end do 
                                                                        
        call wigner(2,thetaHe_r,dj2) 
        do m=-2,2 
         do i=-1,1,2 
         do k=-1,1,2 
           j=ipq(i,k) 
           DH2(m,j)=dj2(m,i)*dj2(m,k) 
         end do 
         end do 
        end do 
                                                                        
        do m=-1,1 
         do i=-1,1,2 
         do k=-1,1,2 
           j=ipq(i,k) 
           DH12(m,j)=dj1(m,i)*dj2(m,k) 
           DH21(m,j)=dj2(m,i)*dj1(m,k) 
         end do 
         end do 
        end do 
                                                                        
                                                                        
                                                                        
        hve(0)=cmplx(Hext,0.) 
        hve(1)=C0
        hve(-1)=C0
 
        efgC=efgPAS 
  
        eagd_zz(2)=0. 
        eagd_zz(4)=0. 
        eagd_zz(6)=0. 
        eagd_zz(8)=0. 
        eagd_zz(10)=0. 
                                                                        
        if(icase.eq.2) then 
!        H internal defined with respect to the crystal system          
         if(b_efgC)then 
          call dimj(phiE_r,thetaE_r,psiE_r,1,Decv)
          call vecxmat(1,hv,Decv,hvC)                                 
         end if 
        else 
         hvC=hv 
        end if 
        hvC0=hvC 
        efgC0=efgC 
        jljO=0 
        do jOM=1,iOM 
         call dimj(phiOM(jOM),thetaOM(jOM),0.0,1,Dcpv)
         call dimj(phiOM(jOM),thetaOM(jOM),0.0,2,Dcpt)               
!        loop for isymmetry and timeinvers could be inserted here       
!        hvC(n)=hvC0(m)*d1(m,n,jloop)   efgC(n)=efgC0(m)*d2(m,n,jloop)  
!        if(b_timeinv(jloop)) hvC(n)=-hvC(n)                            
         do jloop=nloop_b,nloop_e 
         jljO=jljO+1 
         if(jloop.gt.0) then 
          do n=-1,1 
           hc1=C0 
           do m=-1,1 
            hc1=hc1+hvC0(m)*d1(m,n,jloop) 
           end do 
           hvC(n)=hc1 
          end do 
          if(b_timeinv(jloop))then 
           do n=-1,1 
           hvC(n)=-hvC(n) 
           end do 
          end if 
                                                                        
          do n=-2,2 
           hc1=C0 
           do m=-2,2 
            hc1=hc1+efgC0(m)*d2(m,n,jloop) 
           end do 
           efgC(n)=hc1 
          end do 
         else 
          hvC=hvC0 
          efgC=efgC0 
         end if 
!        1. rank tensor transformation                                 
         call vecxmat(1,hvC,Dcpv,hvL)                       
         hvL=hvl+hve
         if(b_eqgt0)then 
          call vecxmat(2,efgC,Dcpt,efgL)  
          efgL=efgL*DEq 
         end if ! b_eqgt0   
                                                                        
!-------enable write-------- EFG in the Lab system -------------------  
        if(enwr(6).eq.'lbef') then 
         vxx=real(-efgL(0)+q62*(efgL(2)+efgL(-2))) 
         vyy=real(-efgL(0)-q62*(efgL(2)+efgL(-2))) 
         vzz=2*real(efgL(0)) 
         vxy=-real(q62*(efgL(2)-efgL(-2))*cmplx(0.,1.)) 
         vxz=-real(q62*(efgL(1)-efgL(-1))) 
         vyz=real(q62*(efgL(1)+efgL(-1))*cmplx(0.,1.)) 
                                                                        
         write(nwr,'(2x,a,6f8.3,a1,3f10.3)')                            &
                   ' (',vxx,vyy,vzz,vxy,vxz,vyz,')'                      
         
!         write(nwr,'(a)')                                              
!         write(nwr,'(2x,a,3f8.3,a1)')  '            x (',vxx,vxy,vxz,')
!         write(nwr,'(2x,a,8x,2f8.3,a1)')'<i|V_L|k> = y (',vyy,vyz,')'  
!         write(nwr,'(2x,a,16x,f8.3,a1)')'            z (',vzz,')'      
        end if 
!-------enable write---H-field in the Lab system ---------------------  
        if(enwr(6).eq.'lbhf') then 
         hx=-real(hvL(1)-hvL(-1))/sqrt2 
         hy= real((hvL(1)+hvL(-1))*cmplx(0.,1.))/sqrt2 
         hz= real(hvL(0)) 
         write(nwr,'(/,a,3f8.3,a1)')' *H_L = (',hx,hy,hz,')'                                    
        end if 
!--------------------------------------------------------------------   
         call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvL,efgL,        &
                                                 je,jg,jge,Eagd,V1m,V2m)
         do i=1,jge 
          eagd_zz(2*i-1)=Eagd(i) 
         end do 
         do i=1,jge 
          eagdzz(i)=cmplx(eagd_zz(2*i-1),eagd_zz(2*i)) 
         end do 
                                                                        
!        write(6,'(10f10.3)') (eagdzz(j),j=1,10)   ! trick with equivale
!        if(jOM.eq.1)                                                   
!     &  write(6,'(a,i4,f12.3)')' iOM,thetaHe=',iOM,thetaHe_r/rad       
                                                                        
         ip=nput+2+3*jge*(jljO-1) 
         do i=1,jge 
                                                                        
          if(r_E2M1.eq.0.)then 
           do m=-1,1 
            TI1(m)=real(conjg(V1m(m,i))*V1m(m,i)) 
           end do 
           pp=0. 
           do m=-1,1 
            pp=pp+TI1(m)*DH1(m,1) 
           end do 
           hmm=0. 
           do m=-1,1 
            hmm=hmm+TI1(m)*DH1(m,2) 
           end do 
           pm=C0 
           do m=-1,1 
            pm=pm+cmplx(0.,TI1(m)*DH1(m,3)) 
           end do 
          else 
           if(abs(r_E2M1).lt.1000.)then 
!           mixed M1/E2 transition                                      
            do m=-1,1 
             TI1(m)=real(conjg(V1m(m,i))*V1m(m,i)) 
            end do 
            do m=-2,2 
             TI2(m)=real(conjg(V2m(m,i))*V2m(m,i)) 
            end do 
            do m=-1,1 
             TI12(m)=conjg(V1m(m,i))*V2m(m,i) 
             TI21(m)=conjg(V2m(m,i))*V1m(m,i) 
            end do 
            pp=0. 
            do m=-1,1 
             pp=pp+TI1(m)*DH1(m,1)-                                     &
                r_E2M1*real(TI21(m)*DH21(m,1)+TI12(m)*DH12(m,1))        
            end do 
            do m=-2,2 
             pp=pp+rEM2*TI2(m)*DH2(m,1) 
            end do 
            pp=pp*qEM2 
            hmm=0. 
            do m=-1,1 
             hmm=hmm+TI1(m)*DH1(m,2)-                                   &
                 r_E2M1*real(TI21(m)*DH21(m,2)+TI12(m)*DH12(m,2))        
            end do 
            do m=-2,2 
             hmm=hmm+rEM2*TI2(m)*DH2(m,2) 
            end do 
            hmm=hmm*qEM2 
            pm=0. 
            do m=-1,1 
             pm=pm+cmplx(0,TI1(m)*DH1(m,3))-                            &
                r_E2M1*(TI21(m)*DH21(m,3)-TI12(m)*DH12(m,3))            
            end do 
            do m=-2,2 
             pm=pm-rEM2*cmplx(0.,TI2(m)*DH2(m,3)) 
            end do 
            pm=pm*qEM2 
           else 
!           E2 transition                                               
            do m=-1,1 
             TI2(m)=real(conjg(V2m(m,i))*V2m(m,i)) 
            end do 
            pp=0. 
            do m=-2,2 
             pp=pp+TI2(m)*DH2(m,1) 
            end do 
            hmm=0. 
            do m=-2,2 
             hmm=hmm+TI2(m)*DH2(m,2) 
            end do 
            pm=C0 
            do m=-2,2 
             pm=pm+cmplx(0.,TI2(m)*DH2(m,3)) 
            end do 
           end if 
          end if 
          ii=ip+3*(i-1) 
          array_fr(ii+1)=eagdzz(i) 
          array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0/float(n_all) 
          array_fr(ii+3)=pm/float(n_all) 
         end do 
         end do ! nloop
        end do ! iOM
        goto 100 
!       end of powder average (Collins etc)                             
       else 
!       average intensities of efg with only Hi (no external H)         
        if(icase.eq.2) then 
!        H internal defined with respect to the crystal system          
         if(b_efgC) call dimj(-psiE_r,-thetaE_r,-phiE_r,2,Dect)
 
         if(b_efg.or.b_efgC)then 
          call vecxmat(2,efgPAS,Dect,efgC)
         end if 
        else 
         efgC=efgPAS 
        end if 
        efgC=efgC*DEq 
        hvC=hv 

!       write(6,'(a,10f9.1)') 'efgC=',efgC                             
!       write(6,'(a,8f9.1)') 'hv =',hv                                 
!       write(6,'(a,L5,8f9.3)')'... =',b_integer,amueg,amuee,QgdQe,cTms
        call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvC,efgC,         &
                                                je,jg,jge,Eagd,V1m,V2m)
        if(r_E2M1.eq.0.)then 
         do i=1,jge 
          hc1=V1m(1,i)*conjg(V1m(1,i))+V1m(0,i)*conjg(V1m(0,i))+        &
              V1m(-1,i)*conjg(V1m(-1,i))                                  
          rtr(i)=cmplx(0.,real(hc1)/3.) 
          rpm(i)=C0 
         end do 
        else 
         if(abs(r_E2M1).lt.1000.)then 
!         mixed M1/E2 transition                                        
          do i=1,jge 
           hc1=V1m(1,i)*conjg(V1m(1,i))+V1m(0,i)*conjg(V1m(0,i))+       &
               V1m(-1,i)*conjg(V1m(-1,i))                               
           hc2=V2m(2,i)*conjg(V2m(2,i))+V2m(1,i)*conjg(V2m(1,i))+       &
               V2m(0,i)*conjg(V2m(0,i))+V2m(-1,i)*conjg(V2m(-1,i))+     &
               V2m(-2,i)*conjg(V2m(-2,i))                               
           rtr(i)=cmplx(0.,(real(hc1)/3.+rEM2*real(hc2)/5.)*qEM2) 
           rpm(i)=C0
          end do 
         else 
!         E2 transition                                                 
          do i=1,jge 
           hc2=V2m(2,i)*conjg(V2m(2,i))+V2m(1,i)*conjg(V2m(1,i))+       &
               V2m(0,i)*conjg(V2m(0,i))+V2m(-1,i)*conjg(V2m(-1,i))+     &
               V2m(-2,i)*conjg(V2m(-2,i))                               
           rtr(i)=cmplx(0.,real(hc2)/5.) 
           rpm(i)=C0 
          end do 
         end if 
        end if 
       end if 
      end if 
                                                                        
      ip=nput+2 
      do i=1,jge 
       ii=ip+3*(i-1) 
       array_fr(ii+1)=cmplx(Eagd(i),0.0) 
       array_fr(ii+2)=rtr(i) 
       array_fr(ii+3)=rpm(i) 
!      write(6,'(i8,a,8g12.4)')ii,' E=',Eagd(i),rtr(i),rpm(i)           
      end do 
                                                                        
      n_all=1 
      array_fr(nput+1)=cmplx(float(n_all),float(jge)) 
      array_fr(nput+2)=C0 
                                                                        
  100 if(nloop_e.gt.0) then 
!      to be stored in array store() => array_fr()                      
       efgC=efgC0 
       hvC=hvC0 
      end if 
      j=iput+1 
      do i=1,istore 
       array_fr(j+i)=store(i) 
      end do 
      return 
      END                                           
