    subroutine x_data(mdastr,b_data,mxpt,nexp,xb_exp,dx_exp) 
    use comthe, only: real_fr
    implicit none 
    integer, intent(inout):: mdastr
    logical, intent(in):: b_data
    integer, intent(in):: mxpt,nexp
    real,    intent(in):: xb_exp,dx_exp

    integer k
    real    x
    
                                                                 
    if(.not.b_data) then 
     if(mdastr.eq.3) then 
      print *,' **warning** dastr=3 requires data; set to 1' 
      mdastr=1 
     end if 
    end if 

   select case(mdastr)  
     case(1,2)
!     dastr of experimental points calculated 
      x=xb_exp-dx_exp 
      do k=1,nexp 
       x=x+dx_exp 
       real_fr(mxpt+k)=x 
      end do 
   case(3)
!     dastr of experimental points 
!     data for time or angle array taken from data file
    end select 
    return 
    END                                           
 

     subroutine syn_plot(cmch) 
     use glbconst, only: maxfr1,maxfr2,maxn,max8,maxthss,maxsub,    &
                         maxscrt,ivstrf,MDBPLFT,infplot
     use comdat, only: ichanks,mfpt,mdfpt,b_data,name_data,formdata,  &
                       file_data,b_theory,name_theory
     use complt, only: display_mode,ndisplay_mode,n_subset,icolor_sub
     use comthe, only: ifrcase,real_fr,array_fr,thfk     
     implicit none 

     character(len=4),intent(in):: cmch 

     integer, parameter:: istr=38+4*(maxfr1+maxfr2)+3*maxthss
     integer       dstr,nstorTH1,idum1,iaddr
     common/struct/dstr(istr),idum1,nstorTH1,iaddr(6)

     integer       idum2,nTH1,nCP,nsrw,idum3,mxpt,nexp,ifrth,idum,ien
     real          srw8,xb_the,dx_the
     common/strLOC/nTH1,nCP,idum2,nsrw,idum3,nexp,mxpt,ifrth(13),          &
                        srw8,idum(5),xb_the,dx_the,ien(4)   

     integer      n_subspectra,logx,logy,logf,                         &
                  int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor  
     real         plotx,ploty,ploterry,plotres,plotxx,plotyy,plotsub,  &
                  xyzdz,vtxt,vtxtp                                     

     character(len=132):: plotstrpu,title
     character(len=24) :: axesname,abscissa,ordinata,bgcolor,fgcolor,   &  
                          datacolor,thcolor,rescolor,auxcolor1,         &        
                          auxcolor2,auxcolor3
     character(len=80) :: datfile,plotstrdef  
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=4)  :: namechan,chardum
                  
     integer,parameter :: max8subn=maxsub*max8,                        &
                 idumpl=MDBPLFT*2-140*maxn-8*39-5*infplot-maxsub-188  
     common/plot/plotx(max8),ploty(max8),ploterry(max8),plotres(max8), &
                 plotxx(max8),plotyy(max8),plotsub(max8subn),          &
                 xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),                  &
                 int3d(maxn*16),npnt3d(16),ifeder(maxn*4),ltext(32),   &
                 npntplot(infplot),nchanplot(infplot),ncolor(maxsub),  &
                 n_subspectra,logx,logy,logf,                          &
                 namechan(infplot),kform(infplot),axisformat(3),       &
                 axesname(3),title,plotstrdef,plotstrpu,               &
                 bgcolor,fgcolor,datacolor,thcolor,rescolor,           &
                 auxcolor1,auxcolor2,auxcolor3,datfile,chardum(idumpl) 
                                                                       
     real          avsp,counts,background,Pdum,                        &
                   t_shift,dumvsp                                      
     common/avstrf/avsp,counts,background,Pdum(6),                     &
                   t_shift,dumvsp(ivstrf-10)                           
                                                                       
     integer,parameter:: max4=max8/2,                                  & 
                        idumscrt=maxscrt-max4*maxsub-5*max4
     integer     idumsc
     logical     b_12,b_34 
     real        datx,errx,sym,subspectrum,daty,erry 
     common/scrt/datx(max4),errx(max4),sym(max4),                      &
                 subspectrum(max4,maxsub),                             &
                 daty(max4),erry(max4),idumsc(idumscrt)                

     integer       nthe,isd            
                                                                       
     logical             b_logx,b_logy 
     character(len=1) :: chx,chbx,chlr,chy,chby,chbt,ch0 
     character(len=80):: CTEXT,CXTEXT,CYTEXT
     character(len=24):: frcolor
     character(len=9) :: chsub
     integer   nformx,nformy,i0,                                & 
               n_plotsub,nresidue,ny,nyy,ns,i,ii,j,jj,k 
     real      h,hm,htr,schrw,resmin,resmax,xmin,xmax,ymin,ymax,hd,  &
               chh,chw,syw,syh 

      i0=ichar('0') 
      ch0=char(0) 
      nthe=2*nTH1
                                                                        
      if(cmch.eq.'dstr') then 
!      format  reading data                                             
       formdata(1)='y'           ! dastr=1
       formdata(2)='y,dy'        ! dastr=2 
       formdata(3)='y,x'         ! dastr=3
       formdata(4)='y,dy,x'      ! dastr=4
        return 
      end if 
      if(cmch.eq.'dmod') then 
!      format  writing data and theory                                  
       namechan(1)='x' 
       namechan(2)='y' 
       namechan(3)='dy' 
       namechan(4)='res' 
       namechan(5)='xt' 
       namechan(6)='yt' 
       namechan(7)='su' 
       namechan(8)=' ' 
       plotstrdef='(x,y,dy)' 
       if(b_theory) plotstrdef='(xt,yt)' 
!      if there is not the standard xd,yd,erry a d(...) identifies data 
       if(b_theory.and.b_data)then 
        plotstrdef='(x,y,dy) (xt,yt)' 
        j=21 
       end if 
       if(ifrcase.ge.22) then 
        display_mode(1)='angle scale, log(counts)' 
        display_mode(2)='angle scale, residual counts' 
        display_mode(3)='channel scale, counts' 
        display_mode(4)='channel scale,residual counts' 
        if(b_theory)then 
         if(ndisplay_mode.eq.2.or.ndisplay_mode.eq.4)then 
          plotstrdef='(x,y,dy) (xt,yt) (x,res)' 
          j=30 
         end if 
         if(n_subset.gt.0)then 
          do i=1,n_subset 
           chsub=' (xt,su'//char(i+i0)//')' 
           k=j+(i-1)*9 
           plotstrdef(k:)=chsub 
          end do 
         end if 
        end if 
       else 
        display_mode(1)='time scale, log(counts)' 
        display_mode(2)='time scale, residual counts' 
        display_mode(3)='channel scale, counts' 
        display_mode(4)='channel scale,residual counts' 
        display_mode(5)='velocity scale, cross section' 
        display_mode(6)='channel scale, cross section' 
        if(b_theory)then 
         if(ndisplay_mode.eq.2.or.ndisplay_mode.eq.4)then 
          plotstrdef='(x,y,dy) (xt,yt) (x,res)' 
          j=30 
         end if 
         if(n_subset.gt.0)then 
          do i=1,n_subset 
           chsub=' (xt,su'//char(i+i0)//')' 
           k=j+(i-1)*9 
           plotstrdef(k:)=chsub 
          end do 
         end if 
        end if 
       end if 
                                                                        
       return 
      end if 
                                                                        
      ii=index(file_data,'.') 
      if(ii.eq.0) then 
       datfile='Ptheory_nodata.ps'//char(0) 
      else 
       datfile='P'//file_data(1:ii)//'ps'//char(0) 
      end if 
                                                                        
      b_logy=.false. 
      b_logx=.false. 
      b_12=.false. 
      b_34=.false. 
      if(ifrcase.ge.22.and.ndisplay_mode.gt.4) ndisplay_mode=4 
      goto(1,2,3,4,1,2,3,4,5,6), ndisplay_mode 
!       display_mode(1)='angle, time scale'                             
    1  b_12=.true. 
       if(ifrcase.ge.22) then 
        abscissa='theta[mrad] ' 
        axisformat(1)='%6.2f ' 
       else 
        abscissa='T[ns] ' 
        axisformat(1)='%6.1f ' 
       end if 
       ordinata='log count'//ch0 
       axisformat(2)='%6.2f ' 
       b_logy=.true. 
       nformx=0 
       nformy=2 
       goto 7 
!       display_mode(2)='angle, time scale, residual counts'            
    2   b_12=.true. 
        if(ifrcase.ge.22) then 
        abscissa='theta[mrad] ' 
        axisformat(1)='%6.2f ' 
       else 
        abscissa='T[ns] ' 
        axisformat(1)='%6.1f ' 
       end if 
       ordinata='log count'//ch0 
       axisformat(2)='%6.2f ' 
       b_logy=.true. 
       nformx=0 
       nformy=2 
       goto 7 
!       display_mode(3)='channel scale'                                 
    3  b_34=.true. 
       abscissa='channel ' 
       ordinata='counts ' 
       axisformat(1)='%6.0f ' 
       axisformat(2)='%8.0f ' 
       nformx=0 
       nformy=0 
       goto 7 
!       display_mode(4)='-channel scale, residual counts'               
    4   b_34=.true. 
        abscissa='channel ' 
       ordinata='counts ' 
       axisformat(1)='%6.0f ' 
       axisformat(2)='%8.0f ' 
       b_logy=.false. 
       nformx=0 
       nformy=0 
       goto 7 
!      display_mode(5)='velocity scale, cross section'                  
    5   abscissa='[mm/s] ' 
       ordinata='cross section ' 
       axisformat(1)='%6.1f ' 
       axisformat(2)='%10.2f ' 
       nformx=1 
       nformy=2 
       goto 7 
!      display_mode(6)='channel scale, cross section'                   
    6  abscissa='channels ' 
       ordinata='cross section ' 
       axisformat(1)='%6.0f ' 
       axisformat(2)='%10.2f ' 
       nformx=0 
       nformy=2 
    7  continue 
                                                                        
                                                                        
                                                                        
      if(b_12.or.ndisplay_mode.eq.5) then 
       kform(1)='f7.2' 
       kform(2)='f10.4' 
       kform(3)='f12.6' 
       kform(4)='f10.6' 
       kform(5)='f7.2' 
       kform(6)='f8.4' 
       kform(7)='f8.4' 
       nformy=2 
      else 
       kform(1)='f6.0' 
       kform(2)='f12.0' 
       kform(3)='f9.1' 
       kform(4)='f9.1' 
       kform(5)='f6.0' 
       kform(6)='f12.0' 
       kform(7)='f12.0' 
       nformy=0 
      end if 
      kform(8)=' ' 
                                                                        
      bgcolor='LightYellow'//char(0) 
      fgcolor='black'//char(0) 
      datacolor=fgcolor 
      thcolor=fgcolor 
      rescolor='blue'//char(0) 
      do j=1,maxsub 
       ncolor(j)=icolor_sub(j) 
      end do 
                                                                        
      n_subspectra=n_subset 
                                                                        
      n_plotsub=n_subspectra 
      axesname(1)=abscissa 
      axesname(2)=ordinata 
      axesname(3)=' ' 
      title=name_data 
      if(.not.b_data) title=name_theory 
                                                                        
!      write(6,'(a,i4)')'frame02 plot nexp=',nexp                       
                                                                        
      isd=nexp/1024 
      if(nexp-isd*1024.gt.0)isd=isd+1 
      if(isd.eq.0)isd=1 
      if(b_data) then 
       do i=1,nexp 
        daty(i)=real_fr(mfpt+i) 
       end do 
       do i=1,nexp 
        erry(i)=real_fr(mdfpt+i) 
       end do 
      end if

      nresidue=0 
      do ii=1,infplot 
       nchanplot(ii)=0 
      end do 
                                                                        
!      write(6,'(4(a,f10.3))')'counts=',counts, &                        
!        ' T_bunch=',T_bunch, '  background=',background               
!       write(6,'(6g12.2)') (thfk(i),i=1,256)                           
!      do j=1,nexp                                                      
!       write(6,'(i4,4x,4f15.6)') j,daty(j),erry(j),real_fr(mxpt+j) 
!      end do                                                           
!      do j=1,nexp                                                      
!       write(11,'(i4,4x,2f15.6)') j,thfk(j)                            
!      end do                                                           
!      close(unit=11)                                                   
!      do j=240,250                                                     
!      write(6,'(i4,4x,f15.6)') j,thfk(j)                               
!      end do                                                           
!      write(6,*)(ichanks(i),i=1,5)

      nyy=0 
      ny=0 
      if(b_12) then 
       if(b_data) then 
        if(ndisplay_mode.eq.1)then 
         do k=2,ichanks(0),2 
          do j=ichanks(k-1),ichanks(k),isd 
           ny=ny+1 
           plotx(ny)=real_fr(mxpt+j) !   =x_exp(j) 
           h=abs(daty(j)) 
           if(h.lt.0.1) then 
            ploty(ny)=0. 
            ploterry(ny)=1. 
            ny=ny-1 
           else 
            ploty(ny)=LOG10(h) 
            ploterry(ny)=1./erry(j) 
           end if 
          end do 
         end do 
!         write(6,*)ny,'=ny  ichanks:',(ichanks(j),j=0,5) 
        else 
         do k=2,ichanks(0),2 
          do j=ichanks(k-1),ichanks(k),isd 
           ny=ny+1 
           plotx(ny)=real_fr(mxpt+j) !  x_exp(j) 
           ploty(ny)=daty(j) 
           ploterry(ny)=erry(j) 
          end do 
         end do 
         if(b_theory)then 
          nresidue=1 
          ns=0 
          do k=2,ichanks(0),2 
           do j=ichanks(k-1),ichanks(k),isd 
            ns=ns+1 
            plotres(ns)=daty(j)-thfk(j) 
           end do 
          end do 
         end if 
        end if 
       end if  ! b_data
                                                                        
       if(b_theory) then 
        if(ndisplay_mode.eq.1)then 
!         do k=2,ichanks(0),2 
          do j=ichanks(1)+1,ichanks(ichanks(0)),isd 
           nyy=nyy+1 
           plotxx(nyy)=real_fr(mxpt+j)
           plotyy(nyy)=LOG10(abs(thfk(j)+0.1)) 
          end do
!         end do 
!         write(6,*)nyy,'=nyy ichanks:',(ichanks(j),j=0,5) 
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do ii=1,nyy 
            ns=ns+1 
            plotsub(ns)=LOG10(abs(subspectrum(ii,j)+0.1)) 
           end do 
          end do 
         end if 
        else 
         nyy=nexp 
         do ii=1,nyy 
          plotxx(ii)=real_fr(mxpt+ii) !  x_exp(ii) 
          plotyy(ii)=thfk(ii) 
         end do 
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do ii=1,nyy 
            ns=ns+1 
            plotsub(ns)=subspectrum(ii,j) 
           end do 
          end do 
         end if 
        end if 
       end if ! b_theory
      end if  ! log scale  
                                                                        
                                                                        
      if(b_34) then 
       if(b_data) then 
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k),isd 
          ny=ny+1 
          plotx(ny)=j 
          ploty(ny)=daty(j) 
          ploterry(ny)=erry(j) 
!          if(daty(j).lt.0.1) ny=ny-1                                   
         end do 
        end do 
        if(b_theory.and.ndisplay_mode.eq.4)then 
         nresidue=1 
         ns=0 
         do k=2,ichanks(0),2 
          do j=ichanks(k-1),ichanks(k),isd 
           ns=ns+1 
           plotres(ns)=daty(j)-thfk(j) 
          end do 
         end do 
        end if 
       end if ! b_data 
                                                                        
       if(b_theory) then 
        nyy=0 
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k),isd 
         nyy=nyy+1 
         plotxx(nyy)=j 
         plotyy(nyy)=thfk(j) 
        end do 
        end do 
        if(n_subspectra.gt.0) then 
         do j=1,n_subspectra 
          ns=(j-1)*max8 
          nchanplot(6+j)=nyy 
          do i=1,nyy 
            ns=ns+1 
            plotsub(ns)=subspectrum(ii,j) 
          end do 
         end do 
        end if 
       end if  ! b_theory 
      end if  ! counts  
                                                                        
!      display_mode(5)='velocity scale, cross section'                  
!      abscissa='[mm/s]'                                                
!      ordinata='cross section'                                         
                                                                        
!      display_mode(5)='channel scale, cross section'                   
!      abscissa='channels'                                              
!       ordinata='cross section'                                        
                                                                        
      if(ndisplay_mode.eq.5.or.ndisplay_mode.eq.6) then 
       schrw=1.0 
       nresidue=0 
!       cv_ET=100.*wavelength                                           
!       iT_max=aiT_max                                                  
!       iT_max2=2**iT_max                                               
                                                                        
       if(ndisplay_mode.eq.5) schrw=8*srw8 
!       if(ndisplay_mode.eq.9) schrw=cv_ET/abs(T_bunch*iT_max2)         
       schrw=schrw*nsrw 
!       write(6,'(a,2i8,f10.4)')                                        
!     &   'array_fr( nn+),nCP,nsrw,schrw=',nCP,nsrw,schrw               
                                                                        
       nyy=0 
       hm=0. 
       do ii=-nCP,nCP-1 
        jj=nstorTH1+(nCP+ii)*4 
        nyy=nyy+1 
        plotxx(nyy)=schrw*ii 
        htr=0.0 
!        do k=1,4                                                       
!         htr=htr+array_fr(jj+k)*conjg(array_fr(jj+k))                  
        do k=1,4,3 
         htr=htr+real(array_fr(jj+k)) 
        end do 
        if(hm.lt.htr) hm=htr 
        plotyy(nyy)=htr 
       end do 
       plotyy(nyy-1)=hm 
       plotyy(nyy)=-hm/2. 
                                                                        
!      write(6,'(a,2i4,f10.4)') ' nyy,nCP,schrw=',nyy,nCP,schrw         
       n_plotsub=8 
       n_subspectra=n_plotsub 
       do j=1,n_plotsub/2 
        ns=2*(j-1)*max8 
        nchanplot(5+2*j)=nyy 
        do ii=-nCP,nCP-1 
         jj=nstorTH1+(nCP+ii)*4 
         ns=ns+1 
         plotsub(ns)=real(array_fr(jj+j)) 
        end do 
!       write(6,'(a,4i8)') ' real nstorTH1,j,nyy=',nstorTH1,j,nyy       
        ns=(2*j-1)*max8 
        nchanplot(6+2*j)=nyy 
        do ii=-nCP,nCP-1 
         jj=nstorTH1+(nCP+ii)*4 
         ns=ns+1 
         plotsub(ns)=aimag(array_fr(jj+j)) 
        end do 
!       write(6,'(a,2i6)') ' aimag nstorTH1,j=',nstorTH1,j              
!       write(6,'(8f10.4)') (plotsub(ii),ii=(2*j-1)*nyy+1,2*j*nyy)      
       end do 
      end if  ! 5,6 
                                                                        
      xmin=1.e30 
      xmax=-xmin 
      ymin=xmin 
                                    ! counts > 0                        
      ymax=0. 
      if(b_data.and.ndisplay_mode.lt.5) then 
       do ii=1,3 
        nchanplot(ii)=ny 
       end do 
       if(xmin.gt.plotx(1))xmin=plotx(1) 
       if(xmax.lt.plotx(ny))xmax=plotx(ny) 
       if(xmin.gt.plotx(ny))xmin=plotx(ny) 
       if(xmax.lt.plotx(1))xmax=plotx(1) 
       do i=1,ny 
        if(ymin.gt.ploty(i)-ploterry(i))then
!         write(6,*)ploty(i),ploterry(i) 
         ymin=ploty(i)-ploterry(i) 
        end if
       end do 

       do i=1,ny 
        if(ymax.lt.ploty(i)+ploterry(i))ymax=ploty(i)+ploterry(i) 
       end do 
      else 
       do ii=1,4 
        nchanplot(ii)=0 
       end do 
      end if 
                                                                        
      if(b_theory) then 
       nchanplot(5)=nyy 
       nchanplot(6)=nyy 
       if(xmin.gt.plotxx(1))xmin=plotxx(1) 
       if(xmax.lt.plotxx(nyy))xmax=plotxx(nyy) 
       if(xmin.gt.plotxx(nyy))xmin=plotxx(nyy) 
       if(xmax.lt.plotxx(1))xmax=plotxx(1) 
       do i=1,nyy-2 
        if(ymin.gt.plotyy(i))ymin=plotyy(i) 
       end do 
       do i=1,nyy-2 
        if(ymax.lt.plotyy(i))ymax=plotyy(i) 
       end do 
       if(n_subspectra.gt.0) then 
         do j=1,n_subspectra 
          ns=(j-1)*max8 
          do i=1,nyy 
           if(ymin.gt.plotsub(ns+i))ymin=plotsub(ns+i) 
          end do 
         end do 
       end if 
      end if 
!       write(6,'(a,2i5,2g12.2)')'nyy,ny,xmin,xmax=',nyy,ny,xmin,xmax 
      if(nresidue.eq.1) then 
        nchanplot(4)=ny 
        resmin=0. 
        resmax=0. 
        do i=1,ns 
         hd= plotres(i)-ploterry(i) 
         if(resmin.gt.hd) resmin=hd 
        end do 
        do i=1,ns 
         hd= plotres(i)+ploterry(i) 
         if(resmax.lt.hd) resmax=hd 
        end do 
         hd= resmax-2.0*resmin 
        do i=1,ns 
         plotres(i)=plotres(i)+ymax-resmin 
        end do 
        ymax=ymax-resmin+resmax 
      end if 
!      write(6,'(a,4g12.2)')'m=',xmin,xmax,ymin,ymax
       xyzdz(1)=xmin 
       xyzdz(2)=xmax 
       xyzdz(3)=ymin 
       xyzdz(4)=ymax 
                                                                        
       bgcolor='Ivory'//char(0)     ! color background  (0...) [0]  
       fgcolor='black'//char(0) 
       datacolor=fgcolor 
       thcolor=fgcolor 
       rescolor='blue'//char(0) 
       do j=1,maxsub 
        ncolor(j)=icolor_sub(j) 
       end do 

       logx=0 
       logy=0 
       if(b_logx)logx=1 
       logf=0 
       if(b_logy)logf=1 
                                                                        
!      definitions taken from allplo                                    
!      x                                                                
       chx='b'                 ! (none,Both,bottom,top)  [B]            
       chbx='n'                ! (none,bottom,top)  [n]                 
       chlr='l'                ! (left,right)  [r]                                       
       chy='B'                 ! (none,Both,left,right)  [B]            
       chby='r'                ! (none,left,right)  [r]                 
       chbt='t'                ! (bottom,top)  [t]                      
       chh=0.3                 !                                        
       chw=0.25                ! character cw,ch  [0.40,0.40]           
       syw=0.1                 !                                        
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]           
       frcolor=fgcolor         ! color frame       [black]          

       frcolor='blue'//char(0) 
       CTEXT=title 
       CXTEXT=abscissa 
       CYTEXT=ordinata 
                                                                       
       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,            &
                  chh,chw,syw,syh,                                      &
                  CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)      
                                                                        
!       write(6,'(a,4g12.6)')' min-max=',xmin,xmax,ymin,ymax            
                                                                        
!      write(6,'(a,f15.5)') ' in frame in plotf plotyy(2)=',plotyy(2)   
!       write(6,'(8f10.4)') (plotx(ii),ii=1,ny,16)                      
!       write(6,'(8f10.4)') (ploty(ii),ii=1,ny,16)                      
!      write(6,'(a,3i8)') 'syn_plot xx nexp,nyy=',nexp,nyy              
!      write(6,'(8f10.4)') (plotxx(ii),ii=1,nyy,16)                     
!      write(6,'(a,3i8)') 'syn_plot yy nexp,nyy=',nexp,nyy              
!      write(6,'(8f10.4)') (plotyy(ii),ii=1,nyy)                        
                                                                        
      return 
      END                                           
                                                                        
     subroutine offspec_plot(cmch,n5_offspec,info) 
     use glbconst, only: maxn,max8,maxsub,maxscrt,MDBPLFT,infplot,   &
                         infotext
     use comdat, only: ichanks,mfpt,mdfpt,name_data,       &
                       formdata,b_data,file_data,name_theory,b_theory
     use complt, only: display_mode,ndisplay_mode,icolor_sub
     use comthe, only: real_fr,array_fr,thfk     
     implicit none 
     character(len=4),intent(in):: cmch                                                                       
     integer,intent(in),dimension(5):: n5_offspec
     integer ,intent(out):: info 
                                                                       
     integer      n_subspectra,logx,logy,logf,                  &
                  int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor  
     real         parray,xyzdz,vtxt,vtxtp 


     character(len=132):: plotstrpu,title
     character(len=24) :: axesname,abscissa,ordinata,bgcolor,fgcolor,   &  
                         datacolor,thcolor,rescolor,auxcolor1,         &        
                         auxcolor2,auxcolor3
     character(len=80) :: datfile,plotstrdef 
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=4)  :: namechan,chardum
                 
     integer,parameter :: max8subn=maxsub*max8,                                &
                idumpl=MDBPLFT*2-140*maxn-8*39-5*infplot-maxsub-188  
     common/plot/ parray(maxn*112),xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),&
                  int3d(maxn*16),npnt3d(16),ifeder(4*maxn),ltext(32),  &
                  npntplot(infplot),nchanplot(infplot),ncolor(maxsub), &
                  n_subspectra,logx,logy,logf,                         &
                  namechan(infplot),kform(infplot),axisformat(3),      &
                  axesname(3),title,plotstrdef,plotstrpu,              &
                  bgcolor,fgcolor,datacolor,thcolor,rescolor,          &
                  auxcolor1,auxcolor2,auxcolor3,datfile,chardum(idumpl)
                                                                       
     integer    idumscrt,idumsc,max4 
     parameter(max4=max8/2, idumscrt=maxscrt-max4*maxsub-5*max4) 
     real        datx,errx,sym,subspectrum,daty,erry 
     common/scrt/datx(max4),errx(max4),sym(max4),                      &
                 subspectrum(max4,maxsub),                             &
                 daty(max4),erry(max4),idumsc(idumscrt)                
                                                                       
     real            x_exp,x_the 
     common/dastr3d/ x_exp(maxn),x_the(maxn) 
     integer   i,i0,ii,j,jj,k,ISTEU,j6th,j9th,nchannel,ny,isd,         &
               icase,n_omega,n_theta,nstorTH,i_angle,i_angp1,k_omega,  &
               nn,im,i_theta,ntxt,l1_get0,n_anglepair                  
     real      h,h1,Xl,Yl,Zl,BREITE,HOEHE,alpha,rad,                   &
               thmax,damax,damin,scmin,                                &
               omega,omega_beg,domega,omega_end,omegaend,omegabeg,     &
               theta,dtheta,theta_beg,theta_end,thetaend,thetabeg,     &
               anglemax,grazinc,grazout,                               &
               xend,yend,xbeg,ybeg,vxend,vyend,vxbeg,vybeg,            &
               counts,background                                       
     logical   omgtheta,log_mode,b_showangles 
                                                                       
     real,dimension(max8)::plotx,ploty,ploterry,plotres,plotxx,plotyy
     real,dimension(0:8):: OP
     equivalence (parray(1),plotx(1)),(parray(max8+1),ploty(1)),       &
                  (parray(max8*2+1),ploterry(1)),                      &
                  (parray(max8*3+1),plotres(1)),                       &
                  (parray(max8*4+1),plotxx(1)),                        &
                  (parray(max8*5+1),plotyy(1))                         
                                                                       
     logical         b_logx,b_logy 
     character(len=1) :: chx,chbx,chlr,chy,chby,chbt,bsl
     character(len=80):: CTEXT,CXTEXT,CYTEXT,TEXT
     character(len=24):: frcolor,chl,chr
     character(len=7) :: form
     character(len=4) :: ch4
     character(len=2) :: dbsl
     integer         nformx,nformy,mxpt,mypt 
     real            chh,chw,syw,syh 
                                                                        
      if(cmch.eq.'dstr') then 
!      format  reading data                                             
       formdata(1)='z,dz,x y' ! dastr=1 
       return 
      end if 
                                                                        
      l1_get0 =n5_offspec(1) 
      icase=int(real(array_fr(l1_get0+1))) 
      if(cmch.eq.'dmod') then 
!      format  writing data and theory                                  
       namechan(1)='xd' 
       namechan(2)='yd' 
       namechan(3)='zd' 
       namechan(4)='dz' 
       namechan(5)='res' 
       namechan(6)='xt' 
       namechan(7)='yt' 
       namechan(8)='zt' 
       namechan(9)='  ' 
       display_mode(1)='angle scale (linear scale)' 
       display_mode(2)='angle scale-(log scale)' 
       if(icase.lt.3.or.icase.eq.5)then 
        display_mode(3)='channel scale (2d) (linear scale)' 
        display_mode(4)='channel scale (2d) (log scale)' 
       end if 
       return 
      end if 
                                                                        
      nchannel    =n5_offspec(2) 
      n_anglepair=n5_offspec(3) 
      counts      =n5_offspec(4) 
      background  =n5_offspec(5) 

      mxpt=mfpt+2*nchannel        ! x data (angle)                      
      mypt=mfpt+3*nchannel        ! y data (angle)                      

                                                                        
      isd=nchannel/1024 
      if(nchannel-isd*1024.gt.0)isd=isd+1 
      if(isd.eq.0)isd=1 
                                                                        
      b_showangles=n_anglepair.eq.1 
      i0=ichar('0') 
      j6th=max8*6 
      j9th=max8*9 
      do k=1,infplot 
       nchanplot(k)=0 
      end do 
                                                                        
      if(.not.b_theory) then 
       info=10 
       infotext(1)='effi/3dplot/notheory' 
       infotext(2)='*** no theory calculated -> no dimensions of the plot'
       infotext(3)='calculate dummy (z=0) to obtaine x,y grid ' 
       infotext(4)=' ' 
       return 
      end if 
                                                                        
      nformx=1 
      nformy=1 
      b_logx=.false. 
      b_logy=.false. 
      log_mode=ndisplay_mode.eq.2.or.ndisplay_mode.eq.4 
      if(log_mode) then 
       kform(1)='f7.2' 
       kform(2)='f8.4' 
       kform(3)='f8.6' 
       kform(4)='f10.6' 
       kform(5)='f7.2' 
       kform(6)='f8.4' 
       kform(7)='f8.4' 
       kform(8)='f8.4' 
       b_logy=.true. 
      else 
       kform(1)='f10.3' 
       kform(2)='f10.3' 
       kform(3)='f8.1' 
       kform(4)='f8.1' 
       kform(5)='f6.0' 
       kform(6)='f10.3' 
       kform(7)='f10.3' 
       kform(8)='f10.0' 
      end if 
      kform(9)=' ' 
      plotstrdef='(xd,yd,zd,dz) (xt,yt,zt)' 
                                                                        
      ii=index(file_data,'.') 
      datfile='P'//file_data(1:ii)//'ps'//char(0) 
                                                                        
      bgcolor='Ivory'//char(0) 
      fgcolor='black'//char(0) 
      datacolor=fgcolor 
      thcolor=fgcolor 
      rescolor='blue'//char(0) 
      do j=1,maxsub 
       ncolor(j)=icolor_sub(j) 
      end do 
                                                                        
      rad=0.0174533 
      do i=1,16 
       ltext(i)=0 
      end do 
                                                                        
                                                                        
!      n_theta,theta_beg,dtheta,n_omega,omega_beg,domega                
       n_omega=int(real(array_fr(l1_get0+2))) 
       n_theta=int(aimag(array_fr(l1_get0+2))) 
       omgtheta= n_omega.ge.n_theta 
       omega_beg=real(array_fr(l1_get0+3)) 
       domega=aimag(array_fr(l1_get0+3)) 
       theta_beg=real(array_fr(l1_get0+4)) 
       dtheta=aimag(array_fr(l1_get0+4)) 
       omega_end=real(array_fr(l1_get0+5)) 
       theta_end=aimag(array_fr(l1_get0+5)) 
                                                                        
                                       ! see th_scanmode()              
       nstorTH=l1_get0+6 
                                                                        
!       write(6,'(a,i4,4x,3f10.4)')                                     
!     &  'n_theta,theta_beg,dtheta,theta_end=',                         
!     &   n_theta,theta_beg,dtheta,theta_end                            
!       write(6,'(a,i4,4x,3f10.4)')                                     
!     &   'n_omega,omega_beg,domega,omega_end=',                        
!     &   n_omega,omega_beg,domega,omega_end                            
                                                                        
       if(ndisplay_mode.ge.3) goto 1000 
!        display_mode(1)='angle scale (linear scale)'                   
!        display_mode(2)='angle scale-(log scale)'                      
!        display_mode(3)='channel scale (2d) (linear scale)'            
!        display_mode(4)='channel scale (2d) (log scale)'               
        if(icase.eq.1.or.icase.eq.4)then 
         h=(omega_end-omega_beg) 
         h1=(theta_end-theta_beg) 
         if(h.lt.h1)h=h1 
         xyzdz(1)=omega_beg-1. 
         xyzdz(2)=(h+2.)/2. 
         xyzdz(3)=theta_beg-1. 
         xyzdz(4)=xyzdz(2) 
         anglemax=theta_end 
         if(theta_end.lt.omega_end) anglemax=omega_end 
         thetabeg=theta_beg 
         omegabeg=omega_beg 
         thetaend=theta_end*1.01 
         omegaend=theta_end*1.01 
        else if(icase.eq.2.or.icase.eq.3)then 
         xyzdz(1)=omega_beg 
         xyzdz(2)=(theta_end-omega_beg)/2. 
         xyzdz(3)=omega_beg 
         xyzdz(4)=(theta_end-omega_beg)/2. 
         anglemax=theta_end 
         thetaend=theta_end*1.01 
         omegaend=theta_end*1.01 
         thetabeg=omega_beg 
         omegabeg=omega_beg 
        else if(icase.eq.5)then 
         h=omega_end 
         xyzdz(1)=omega_beg-1 
         xyzdz(2)=(h+2.)/2. 
         xyzdz(3)=theta_beg-1 
         xyzdz(4)=xyzdz(2) 
         anglemax=theta_end 
         if(theta_end.lt.omega_end) anglemax=omega_end 
         thetabeg=theta_beg 
         omegabeg=omega_beg 
         thetaend=omega_end*1.01 
         omegaend=omega_end*1.01 
        end if 
                                                                        
       i_angle=0 
       i_angp1=0 
       j=0 
!      ------caculation of the specular angles (red line)-------        
       omega=omega_beg-domega 
       do while(omega.lt.anglemax) 
        omega=omega+domega 
        i_angp1=i_angp1+1 
        j=3*(i_angp1-1)+j6th 
        parray(j+1)=omega 
        parray(j+2)=omega 
!        write(6,'(a,6f12.2)')'omega, omega_beg/end Theta_beg/end=',    
!     &               omega,omegabeg,omegaend,thetabeg,thetaend         
        if(omega.gt.thetaend.or.omega.lt.thetabeg .or.                  &
     &     omega.gt.omegaend.or.omega.lt.omegabeg)i_angp1=i_angp1-1     
        parray(j+3)=0.0 
        if(log_mode) parray(j+3)=1.0 
                  ! n_omega                                             
       end do 
       i_angp1=i_angp1+1 
       j=3*(i_angp1-1)+j6th 
       parray(j+1)=i_angle 
       parray(j+2)=0 
       parray(j+3)=-1. 
!      ------ end of caculation of the specular angles (red line)-------
                                                                        
      do i_theta=1,n_theta 
       theta=theta_beg+dtheta*(i_theta-1) 
                                                                        
       do k_omega=1,n_omega 
        omega=omega_beg+domega*(k_omega-1) 
                                                                        
        if(icase.eq.1.or.icase.eq.4) then 
          grazinc=omega 
          grazout=theta 
        else if(icase.eq.2.or.icase.eq.3) then 
         grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta 
         grazout=2*omega_beg+domega*(n_omega-1)+(i_theta-1)*dtheta*2-grazinc
        else if(icase.eq.5) then 
!        PHI_s=omega N_s=n_omega                                        
         j=i_theta/2 
         if(2*j.eq.i_theta) then 
!         + dTheta_out                                                  
          grazinc=omega 
          grazout=(omega+dtheta*j) 
         else 
!         + dTheta_out                                                  
          grazinc=(omega+dtheta*j) 
          grazout=omega 
         end if 
         if(omega+dtheta*j.gt.omega_end)goto 77 
        end if 
        i_angle=i_angle+1 
        i_angp1=i_angp1+1 
        j=3*(i_angp1-1)+j6th 
        parray(j+1)=grazinc 
        parray(j+2)=grazout 
                                                                        
                                                                        
        if(b_showangles) then 
         parray(j+3)=0.01 
        else 
         h=real_fr(2*nstorTH+i_angle)*counts+background 
!         write(6,'(2i8,3g12.3)')2*nstorTH+i_angle,i_angle,             
!     &                  real_fr(2*nstorTH+i_angle)                     
         if(log_mode)then 
          parray(j+3)=alog10(h) 
!         write(6,'(i8,2g12.3)')j,h, parray(j+3)                        
         else 
          parray(j+3)=h 
         end if 
        end if 
   77   continue 
                                                                        
!       write(6,'(i4,2f12.1)')i_angle,grazinc,grazout                   
                  ! n_omega                                             
       end do 
        i_angp1=i_angp1+1 
        j=3*(i_angp1-1)+j6th 
        parray(j+1)=i_angle 
        parray(j+2)=0 
        parray(j+3)=-1. 
       end do    ! n_theta 
                                                                        
       i_angp1=i_angp1+1 
       j=3*(i_angp1-1)+j6th 
       parray(j+1)=-1. 
       parray(j+2)=-1. 
       parray(j+3)=-1. 
                                                                        
!       write(6,'(3f10.3)')(parray(j6th+i),i=1,3*i_angp1+3) ! ####      
                                                                        
       if(icase.eq.2.or.icase.eq.3) then 
        xbeg =0.02 
        vxbeg=omega_beg 
        xend=1.02 
        vxend=omega_end+dtheta*(n_theta-1)/1.4142 
        ybeg =0.02 
        vybeg=omega_beg 
        yend =xend 
        vyend=vxend 
            ! icase.eq.1 or 4 or 5                                      
       else 
        ybeg=0.02 
        vybeg=theta_beg 
        yend=1.02 
        xbeg=0.02 
        vxbeg=omega_beg 
        xend=1.02 
        if(theta_end-theta_beg.lt.omega_end-omega_beg) then 
         vyend=theta_beg+omega_end-omega_beg 
         vxend=omega_end 
        else 
         vyend=theta_end 
         vxend=omega_beg+theta_end-theta_beg 
        end if 
       end if 
                                                                        
!      decission for points or line                                     
       npnt3d(1)=1 
       if(b_showangles) npnt3d(1)=0 
!                                                                       
      if(log_mode)then 
       abscissa='omega[mrad]' 
       axisformat(1)='%5.1f ' 
       ordinata='log counts' 
       axisformat(2)='%12.2f ' 
      else 
       abscissa='omega [mrad]' 
       axisformat(1)='%5.1f ' 
       ordinata='counts' 
       axisformat(2)='%12.2f ' 
      end if 
                                                                        
      xyzdz(5)=1.e10 
      scmin=1.e10 
      xyzdz(6)=0. 
      if(b_showangles) then 
       xyzdz(5)=-0.1 
       xyzdz(6)=1.0 
      end if 
                                                                        
      if(b_theory)then 
       j=j6th 
       thmax=0. 
       do k=1,i_angp1 
        if(parray(j+3).gt.thmax)thmax=parray(j+3) 
        j=j+3 
       end do 
       nchanplot(6)=i_angp1 
       if(thmax.gt.xyzdz(6))xyzdz(6)=thmax 
       j=j6th 
       do k=1,i_angp1 
        if(parray(j+3).lt.thmax)thmax=parray(j+3) 
        j=j+3 
       end do 
       if(thmax.lt.xyzdz(5))xyzdz(5)=thmax 
       scmin=thmax 
      end if 
!       write(6,'(a,f12.5)') ' th_min=',scmin                           
                                                                        
      if(b_data)then 
       j=j9th 
       if(log_mode)then 
        ny=0 
        do k=2,ichanks(0),2 
         do jj=ichanks(k-1),ichanks(k),isd 
         ny=ny+1 
!        do k=1,nchannel                                                
         parray(j+1)=real_fr(mxpt+jj) 
         parray(j+2)=real_fr(mypt+jj) 
         if(real_fr(mfpt+jj).le.0)then 
          ny=ny-1 
          j=j-5 
         else 
          parray(j+3)=alog10(real_fr(mfpt+jj)) 
          parray(j+4)=real_fr(mdfpt+jj)/(real_fr(mfpt+jj)+2) 
!          write(6,'(a,5f10.3)') ' real_fr(mypt+jj)=',parray(j+1),      
!     &    parray(j+2),real_fr(mfpt+jj),parray(j+3),parray(j+4)         
         end if 
                                                                        
         parray(j+5)=1. 
         j=j+5 
         end do 
        end do 
!       residual not yet implemented                                    
       else 
        ny=0 
        do k=2,ichanks(0),2 
         do jj=ichanks(k-1),ichanks(k),isd 
         ny=ny+1 
         parray(j+1)=real_fr(mxpt+jj) 
         parray(j+2)=real_fr(mypt+jj) 
         parray(j+3)=real_fr(mfpt+jj) 
         parray(j+4)=real_fr(mdfpt+jj) 
         parray(j+5)=thfk(jj)-parray(j+3) 
         j=j+5 
         end do 
        end do 
                                                                        
        if(n_anglepair.gt.1.) then 
         j=j9th 
         do k=2,ichanks(0),2 
          do jj=ichanks(k-1),ichanks(k),isd 
           parray(j+3)=0.01 
           j=j+5 
          end do 
         end do 
                                                                        
        end if 
       end if 
                                                                        
       j=j9th 
       damax=0. 
       do k=1,ny 
!        write(6,'(i8,2f12.2)')j,parray(j+3),parray(j+4)                
        if(parray(j+3)+parray(j+4).gt.damax)                            &
     &            damax=parray(j+3)+parray(j+4)                         
        j=j+5 
       end do 
       j=j9th 
       damin=damax 
       do k=1,ny 
        if(parray(j+3)-parray(j+4).lt.damin)                            &
     &            damin=parray(j+3)-parray(j+4)                         
        j=j+5 
       end do 
       if(damax.gt.xyzdz(6)) xyzdz(6)=damax 
       if(damin.lt.xyzdz(5)) xyzdz(5)=damin 
       nchanplot(1)=ny 
                                                                        
       j=j9th 
       do k=1,ny 
        if(parray(j+3).lt.scmin) scmin=parray(j+3) 
         j=j+5 
       end do 
      end if    ! b_data  
                                                                        
      if(n_anglepair.gt.1) then 
        xyzdz(5)=0. 
        xyzdz(6)=1. 
      end if 
                                                                        
!      ------ begin of correction the specular angles (red line)------- 
!      the z-component of the first point (used for all z-values i xmosp
       if(log_mode)parray(j6th+3)=xyzdz(4) 
!      ------ end of correction of the specular angles (red line)-------
                                                                        
       i_angp1=i_angp1+1 
       j=3*(i_angp1-1)+j6th 
       parray(j+1)=i_angle 
       parray(j+2)=0 
       parray(j+3)=-1. 
!      ------ end of caculation of the specular angles (red line)-------
                                                                        
       axesname(1)=abscissa 
       axesname(2)='theta [mrad]' 
       axesname(3)=ordinata 
       auxcolor1='red'//char(0) 
       auxcolor2='yellow'//char(0) 
                                                                        
       title=name_data 
       if(.not.b_data) then 
        if(icase.eq.1) title=TRIM(name_theory)//': @4 detector scan@ ' 
        if(icase.eq.2) title=TRIM(name_theory)//': omega scan' 
        if(icase.eq.3) title=TRIM(name_theory)//': omega scan (3d)' 
        if(icase.eq.4) title=TRIM(name_theory)//': theta1/theta2 (3d)' 
        if(icase.eq.5) title=TRIM(name_theory)//': parallel scan' 
       end if 
                                                                        
       ISTEU=1 
       BREITE=0.5 
       HOEHE=0.6 
       ntxt=LEN_TRIM(text) 
!       write(6,'(i4,a)')ntxt,title                                     
       TEXT=title 
       alpha=90. 
       OP(0)=0.            ! no rotation around z-axis of inscription   
       OP(1)=0.            ! phix                                       
       OP(2)=0.            ! phiz                                       
       OP(3)=0.            ! phiy                                       
       OP(4)=10.            ! Xb                                        
       OP(5)=10.            ! Yb                                        
       OP(6)=0.0           ! Zb                                         
       OP(7)=0.            ! strsx                                      
       OP(8)=0.            ! strsy                                      
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
!       -------- omega axis -------------------------------             
       OP(0)=1 
       bsl=char(92) 
       dbsl='$'//bsl 
       form='f5.2' 
       alpha=0. 
       BREITE=0.4 
       HOEHE=0.4 
       TEXT=bsl//'gW' 
       ntxt=3 
       if(icase.eq.4)then 
          TEXT=bsl//'gq$_1$ ' 
          ntxt=8 
       end if 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=1.           ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=0.           ! strsx                                       
       OP(8)=-1.3*HOEHE   ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       BREITE=0.2 
       HOEHE=0.25 
       TEXT=bsl//'r   [mrad]' 
       ntxt=11 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=1.           ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=0.           ! strsx                                       
       OP(8)=-2.6*HOEHE   ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       BREITE=0.3 
       HOEHE=0.3 
       call trlnu(form,vxbeg,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       call TXTPLO(OP,-1,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=xbeg         ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=Xl           ! strsx                                       
       OP(8)=-0.4*HOEHE   ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       call trlnu(form,vxend,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=xend         ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=0.           ! strsx                                       
       OP(8)=-0.4*HOEHE   ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
!      -------- theta axis -------------------------------              
                                                                        
       ISTEU=1 
       alpha=0. 
       BREITE=0.4 
       HOEHE=0.5 
       TEXT=bsl//'gQ' 
       ntxt=3 
       if(icase.eq.4)then 
         TEXT=bsl//'gq$_2$ ' 
         ntxt=8 
       end if 
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=0.87           ! Yb                                        
       OP(6)=0.           ! Zb                                          
       OP(7)=-1.6*HOEHE     ! strsx                                     
       OP(8)=-Xl          ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
                                                                        
       BREITE=0.2 
       HOEHE=0.25 
       TEXT=bsl//'r   [mrad]' 
       ntxt=11 
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=1.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=-3.5*HOEHE     ! strsx                                     
       OP(8)=-Xl          ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       BREITE=0.3 
       HOEHE=0.3 
       call trlnu(form,vybeg,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=ybeg          ! Yb                                         
       OP(6)=0.           ! Zb                                          
       OP(7)=-0.4*HOEHE   ! strsx                                       
       OP(8)=0.0             ! strsy                                    
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
                                                                        
       call trlnu(form,vyend,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       call TXTPLO(OP,-1,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=yend         ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=-0.4*HOEHE   ! strsx                                       
       OP(8)=-Xl          ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
!      -------- z axis -------------------------------                  
       BREITE=0.21 
       HOEHE=0.25 
       if(log_mode)then 
        i=0.8*int(xyzdz(6)+1.) 
        ii=i/10 
        jj=i-10*ii 
        ch4=' '//char(jj+i0)//'.0' 
        if(ii.gt.0)ch4(1:1)=char(ii+i0) 
        TEXT='lg(counts)' 
        ntxt=10 
       else 
        i=int(alog(xyzdz(6)+1.)/alog(10.)) 
        TEXT='counts[10$^'//char(i+i0)//'$ ]' 
        ntxt=16 
        form='f4.1' 
        h=0.8*xyzdz(6)/10**i 
        call trlnu(form,h,chr,nn,chl,im) 
        ch4=chl 
       end if 
       alpha=90. 
       OP(0)=0.           ! no rotation around z-axis of inscription    
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=-0.05        ! Xb                                          
       OP(5)=-0.05        ! Yb                                          
       OP(6)=0.4         ! Zb                                           
       OP(7)=0.           ! strsx                                       
       OP(8)=0.           ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       TEXT=ch4 
       ntxt=4 
       alpha=0. 
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(0)=0.             ! no rotation around z-axis of inscription   
       OP(1)=0.             ! phix                                       
       OP(2)=0.             ! phiz                                       
       OP(3)=0.             ! phiy                                       
       OP(4)=0.             ! Xb                                         
       OP(5)=0.             ! Yb                                         
       OP(6)=0.75           ! Zb                                        
       OP(7)=0.             ! strsx                                      
       OP(8)=-Xl-0.4*HOEHE  ! strsy                                      
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       if(log_mode)then 
        i=int(scmin) 
!        write(6,'(a,i4)')'  log mode i=',i                             
         jj=abs(i) 
         ch4='-'//char(jj+i0)//'.0' 
         ii=10*(abs(scmin)-jj) 
         ch4(4:4)=char(ii+i0) 
        if(i.lt.0) then 
         TEXT=ch4 
         ntxt=4 
        else 
         ch4(1:1)=' ' 
         TEXT=ch4(2:4) 
         ntxt=3 
        end if 
       alpha=0. 
       OP(0)=0.             ! no rotation around z-axis of inscription    
       OP(1)=0.             ! phix                                        
       OP(2)=0.             ! phiz                                        
       OP(3)=0.             ! phiy                                        
       OP(4)=0.             ! Xb                                          
       OP(5)=0.             ! Yb                                          
       OP(6)=0.02           ! Zb                                          
       OP(7)=0.             ! strsx                                       
       OP(8)=-XL-0.4*BREITE ! strsy                                     
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       end if 
!       write(6,'(a,8g12.6)')' min-max=',                               
!     &       xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4),xyzdz(5),xyzdz(6)     
                                                                        
                                                                        
!      write(6,'(8f10.3)')(vtxtx(i),i=1,ltext(2))                       
!      write(6,'(a,2f10.3)') ' X2,Y2=',X2,Y2                            
!     fill in test data                                                 
      return 
                                                                        
 1000 continue 
                                                                        
       i_angle=0 
       i_angp1=0 
       do i_theta=1,n_theta 
        theta=theta_beg+dtheta*(i_theta-1) 
        do k_omega=1,n_omega 
         omega=omega_beg+domega*(k_omega-1) 
                                                                        
         if(icase.eq.2.or.icase.eq.3) then 
            grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta 
            grazout=2*omega_beg+domega*(n_omega-1)+                     &
     &        (i_theta-1)*dtheta*2-grazinc                              
         else if(icase.eq.5) then 
!         PHI_s=omega N_s=n_omega                                       
          j=i_theta/2 
          if(2*j.eq.i_theta) then 
!          + dTheta_out                                                 
           grazinc=omega 
           grazout=(omega+dtheta*j) 
          else 
!          + dTheta_out                                                 
           grazinc=(omega+dtheta*j) 
           grazout=omega 
          end if 
          if(omega+dtheta*j.gt.omega_end)goto 777 
         end if 
         i_angle=i_angle+1 
         i_angp1=i_angp1+1 
                                                                        
         if(.not.b_showangles)then 
          h=real_fr(2*nstorTH+i_angle)*counts+background 
          if(log_mode)then 
            plotyy(i_angp1)=alog10(h) 
          else 
           plotyy(i_angp1)=h 
          end if 
          plotxx(i_angp1)=i_angp1 
         end if 
  777    continue 
                   ! n_omega                                            
        end do 
        i_angp1=i_angp1+1 
        plotxx(i_angp1)=i_angp1 
        plotyy(i_angp1)=-1. 
        nchanplot(5)=i_angp1 
                  ! n_theta                                             
       end do 
                                                                        
                                                                        
!      write(6,'(2f12.2)') (real_fr(mfpt+j),real_fr(2*nstorTH+j),j=1,12)
      if(log_mode)then 
       abscissa='channel' 
       axisformat(1)='%5.1f ' 
       ordinata='lg(counts)' 
       axisformat(2)='%12.2f ' 
      else 
       abscissa='channel' 
       axisformat(1)='%5.1f ' 
       ordinata='counts' 
       axisformat(2)='%12.2f ' 
      end if 
                                                                        
      xyzdz(1)=1 
      xyzdz(2)=0. 
      xyzdz(3)=1.e10 
      xyzdz(4)=0. 
                                                                        
      if(b_data) then 
       if(log_mode)then 
        ny=0 
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k),isd 
          ny=ny+1 
          plotx(ny)=j 
          if(real_fr(mfpt+j).lt.1.0) then 
           ny=ny-1 
          else 
           ploty(ny)=alog10(real_fr(mfpt+j)) 
           ploterry(ny)=real_fr(mdfpt+j)/(real_fr(mfpt+j)+1) 
!          write(6,'(2i6,a,4g12.6)')ny,j,' ploty(ny)=',ploty(ny)        
          end if 
         end do 
        end do 
        nchanplot(1)=ny 
       else 
        ny=0 
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k),isd 
          ny=ny+1 
          plotx(ny)=j 
          if(real_fr(mfpt+j).lt.0.0) then 
           ny=ny-1 
          else 
           ploty(ny)=real_fr(mfpt+j) 
           ploterry(ny)=real_fr(mdfpt+j) 
!          write(6,'(2i6,a,4g12.6)')ny,j,' ploty(ny)=',ploty(ny)        
          end if 
         end do 
        end do 
        nchanplot(1)=ny 
       end if 
       xyzdz(1)=1 
       xyzdz(2)=ny 
       damax=0. 
       do i=1,ny 
        if(ploty(i)+ploterry(i).gt.damax)damax=ploty(i)+ploterry(i) 
       end do 
       if(damax.gt.xyzdz(4))xyzdz(4)=damax 
       do i=1,ny 
        if(ploty(i)-ploterry(i).lt.damax)damax=ploty(i)-ploterry(i) 
       end do 
       if(damax.lt.xyzdz(3))xyzdz(3)=damax 
               ! b_data                                                 
      end if 
                                                                        
                                                                        
      if(b_showangles.and..not.b_data) then 
       xyzdz(3)=-0.1 
       xyzdz(4)=1.0 
      end if 
                                                                        
                                                                        
      thmax=-1.e10 
      if(.not.b_showangles)then 
       jj=nchanplot(5) 
       do i=1,jj 
        if(plotyy(i).gt.thmax)thmax=plotyy(i) 
       end do 
       if(thmax.gt.xyzdz(4))xyzdz(4)=thmax 
       xyzdz(2)=jj 
       do i=1,jj 
        if(plotyy(i).lt.thmax)thmax=plotyy(i) 
       end do 
       if(thmax.lt.xyzdz(3))xyzdz(3)=thmax 
      end if 
!       write(6,'(i6,a,8g12.6)')nchanplot(5),' min-max=',               
!     &       xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4),xyzdz(5),xyzdz(6)     
                                                                        
                                                                        
      axesname(1)=abscissa 
      axesname(2)=ordinata 
      axesname(3)=' ' 
      title=name_data 
      if(.not.b_data) title=name_theory 
                                                                        
                                    ! color background  (0...) [0]      
       bgcolor='Ivory'//char(0) 
       fgcolor='black'//char(0) 
       datacolor=fgcolor 
       thcolor=fgcolor 
       rescolor='blue'//char(0) 
       do j=1,maxsub 
        ncolor(j)=icolor_sub(j) 
       end do 
                                                                        
       logx=0 
       logy=0 
       if(b_logx)logx=1 
       logf=0 
       if(b_logy)logf=1 
                                                                        
!      definitions taken from allplo                                    
       chx='B'                 ! (none,Both,bottom,top)  [B]            
       chbx='n'                ! (none,bottom,top)  [n]                 
       chlr='l'                ! (left,right)  [r]                      
       chy='r'                 ! (none,Both,left,right)  [B]            
       chby='r'                ! (none,left,right)  [r]                 
       chbt='b'                ! (bottom,top)  [t]                      
       chh=0.3                 !                                        
       chw=0.25                ! character cw,ch  [0.40,0.40]           
       syw=0.1                 !                                        
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]           

       frcolor=fgcolor         ! color frame       [black]              
       CTEXT=title 
       CXTEXT=abscissa 
       CYTEXT=ordinata 
                                                                        
       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,            &
                  chh,chw,syw,syh,                                      &
                  CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)    
                                                                        
                                                                        
!      write(6,'(a,i5)') ' rdplpu3d nchannel=',nchannel                 
!       write(6,'(a,4g12.6)')' b min-max=',                             
!     &       xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4)                       
!      write(6,'(8f10.4)') (plotxx(ii),ii=1,nchannel)                   
!      write(6,'(8f10.4)') (plotyy(ii),ii=1,nchanplot(5))               
!      write(6,'(8f10.4)') (ploterry(ii),ii=1,nchannel,16)              
                                                                        
      return 
      END                                           
                                                                        
      subroutine syn_selsubset(text) 
      use glbconst, only: maxfr1,maxfr2,maxthss,mi_scrd,mc_scrd,mr_scrd,&
                          maxs,maxscr
      use complt, only: n_int

      character(len=40),intent(in),dimension(3):: text                                                                        

      integer, parameter:: illc=3*(maxfr1+1+maxfr2+maxthss)
                                                                        
      character(len=64):: frthname 
      integer       mstruct1,istruct1,istruct2,i_array,iaddr
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                    i_array(illc),frthname(2),iaddr(8)                            
                                                                        
      integer, dimension(maxs+3):: npanum
      real,dimension(32):: out 
      character(len=132):: ch132,cp132,chcom
      character(len=40) :: htext
      character(len=4)  :: chp,chs 
      character(len=1)  :: ch1
      character(len=2)  :: ch2
      logical b_inc 
                                                                        
                                                                        
      i0=ichar('0') 
!     mlay : number of layers                                           
      if(mstruct1.gt.1) then 
       htext=text(2) 
       i=24 
       do while(htext(i:i).eq.' ') 
        i=i-1 
       end do 
       i=i+2 
                                                                        
       do lstruct1=1,mstruct1 
        j=0 
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
         j=j+1 
         lay=lstruct2 
         is_a=istruct2(lay-1)+1 
         is_e=istruct2(lay) 
         ii=is_e-is_a 
         if(j.eq.1) then 
          if(ii.gt.0) then 
           write(nwr,'(5x,a,i2,a,i2,a2,a,i2,a,i2)')                     &
     &     htext(:i),lstruct1,'    layer(',lay,'):',                    &
     &    '    sites from ',is_a,' to ',is_e                            
          else 
           write(nwr,'(5x,a,i2,a,i2,a2,a,i2)')                          &
     &     htext(:i),lstruct1,'    layer(',lay,'):','  with site ',is_a 
          end if 
         else 
!         i+5+2                                                         
          i10=(i+7)/10 
          i1=i+7-10*i10 
          ch2=char(i10+i0)//char(i1+i0) 
          if(ii.gt.0) then 
           write(nwr,'('//ch2//'x,a,i2,a2,a,i2,a,i2)')                  &
     &     '    layer(',lay,'):','    sites from ',is_a,' to ',is_e     
          else 
           write(nwr,'('//ch2//'x,a,i2,a2,a,i2)')                       &
     &     '    layer(',lay,'):','  with site ',is_a                    
          end if 
                                                                        
         end if 
        end do 
       end do 
       b_inc=.true. 
      else 
       mlay=istruct1(mstruct1) 
       iset_e=0 
       iset_a=maxthss 
       do lay=1,mlay 
        is_a=istruct2(lay-1)+1 
        is_e=istruct2(lay) 
        htext=text(1) 
        if(is_a.lt.iset_a) iset_a=is_a 
        if(is_e.gt.iset_e) iset_e=is_e 
        if(is_e.ge.is_a)                                                &
     &      write(nwr,'(a,i2,a2,2a,i2,a,i2)') ' layer(',lay,'):',       &
     &      htext(1:24),' sites from ',is_a,' to ',is_e                 
       end do 
       if(istruct2(mlay).lt.2) then 
        write(nwr,'(a)') '**  there are no sub-spectra ** ' 
        return 
       end if 
       b_inc=.false. 
      end if 
                                                                        
                                                                        
  809 continue 
      if(b_inc) then 
       write(nwr,'(/,a,a)') ' sub-spectrum_j',                          &
     & ' of incoherent parts(ji) of the scatterer sites(ki).',          &
     &    ' Number j (h-ide), p*art=j1...jn  s*ite=k1...kn'             
      else 
       write(nwr,'(/,a,a)') ' sub-spectrum_j',                          &
     & ' of the scatterer. Number j (h), site: k1...kn'                 
      end if 
                                                                        
  810  i=1 
       n_subset=0 
       do while(i.le.maxsub.and.abs(n_int(i,0)).gt.0) 
        ch1=' ' 
        j_int=n_int(i,0) 
        if(j_int.lt.0) ch1='h' 
        j_int=abs(j_int) 
        if(b_inc) then 
         jj=1 
                                                     ! ?? 5.3           
         do while(n_int(i,jj).gt.maxthss) 
          jj=jj+1 
         end do 
         j_intp=jj-1 
!         write(6,'(a,4i4)')'select j_intp,j_int=',j_intp,j_int         
         jj=j_int-j_intp 
         if(jj.gt.9) then 
          i10=jj/10 
          i1=jj-10*i10 
          chs=char(i10+i0)//char(i1+i0)//'i4' 
         else 
          chs=char(jj+i0)//'i4' 
         end if 
         chp=char(j_intp+i0)//'i4' 
         ch2='i1' 
         if(i.gt.9) ch2='i2' 
!         write(6,'(a,4(2x,a))')'select chs,chp,ch2=',chs,chp,ch2       
         write(nwr,'(a,'//ch2//'a1,a,'//chp//',a,'//chs//')')           &
     &   ' sub-spectrum_',i,ch1,                                        &
     &   ' part=',(n_int(i,jj)-2*maxthss,jj=1,j_intp),                  &
     &                  ' site=',(n_int(i,jj),jj=j_intp+1,j_int)        
                                                             ! ?? 5.3   
        else 
         jj=j_int 
         if(jj.gt.9) then 
          i10=jj/10 
          i1=jj-10*i10 
          chs=char(i10+i0)//char(i1+i0)//'i4' 
         else 
          chs=char(jj+i0)//'i4' 
         end if 
         ch2='i1' 
         if(i.gt.9) ch2='i2' 
!         write(6,'(a,4(2x,a))')'select chs,ch2=',chs,ch2               
         write(nwr,'(a,'//ch2//'a1,a1,'//chs//')')                      &
     &   ' sub-spectrum_',i,ch1,' ',(n_int(i,jj),jj=1,j_int)            
        end if 
                                                                        
        if(ch1.eq.' ') n_subset=i 
        i=i+1 
        if(i-1.eq.maxsub) goto 811 
       end do 
  811  n_ssub=i-1 
                                                                        
  820  read(nrd,'(a)') ch132 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
        i=index(frthname(1),' ') 
        chcom='<'//frthname(1)(1:i-1)//'>/sub-spectra/input' 
        call help(chcom) 
        goto 809 
       end if 
       if (ch132(1:1).ne.'*'.and.ch132(1:1).ne.'q') then 
        if (ch132(1:1).eq.'#') goto 810 
        call nextchar(ch132,0,ipos,cp132,ii) 
        call nextchar(cp132,ii,ipos,ch132,ia) 
                                                                        
        call trlch(80,cp132,iout,out) 
        iset=out(1) 
        if(iset.gt.maxsub) then 
          write(nwr,'(a,i3)') ' maximal number of sub-spectra ',maxsub 
          goto 810 
        end if 
        if(iout.lt.1) then 
          write(nwr,'(a)')                                              &
     &    ' q*uit or * to leave command ss'                             
          goto 820 
        end if 
        if(iout.eq.1) then 
         if(ch132(1:1).eq.'h') then 
          if(n_int(iset,0).lt.0) then 
           n_int(iset,0)= abs(n_int(iset,0)) 
           do j=maxsub,2,-1 
            do ji=0,maxthss 
             n_int(j,ji)=n_int(j-1,ji) 
            end do 
           end do 
           if(iset.lt.maxsub) then 
            do ji=0,maxthss 
             n_int(1,ji)=n_int(iset+1,ji) 
             n_int(iset+1,ji)=0 
            end do 
           end if 
          else 
           n_int(iset,0)=-abs(n_int(iset,0)) 
           if(iset.lt.n_ssub) then 
            j=n_ssub+1 
            do ji=0,maxthss 
             n_int(j,ji)=n_int(iset,ji) 
             n_int(iset,ji)=0 
            end do 
           end if 
           goto 840 
          end if 
         end if 
!        remove a sub-spectrum                                          
         if(ch132(1:2).eq.'rm') then 
          if(iset.lt.maxsub) then 
           do j=iset,maxsub-1 
            do ji=0,maxthss 
             n_int(j,ji)=n_int(j+1,ji) 
            end do 
           end do 
          end if 
          do ji=0,maxthss 
           n_int(maxsub,ji)=0 
          end do 
!          write(6,'(8i3)')n_int                                        
         end if 
        end if 
                                                                        
!       write(6,'(a,10i4)') ' 1 out=',(int(out(j)),j=1,iout)            
                                                                        
!         write(6,'(2a)')'select ch132=',ch132(:60)                     
        ig1=index(ch132,'=') 
        ig2=index(ch132(ig1+1:),'=')+ig1 
        cp132=ch132(ig1+1:ig1+3) 
!         write(6,'(a,2i4)')'select ig1,ig2=',ig1,ig2                   
                                                                        
        if(b_inc.and.(ig1.eq.0.or.ig2.eq.0)) then 
         write(nwr,'(a)')                                               &
     &    '**** at least one part(=) and one scatterer site(=)'         
          goto 820 
        end if 
        if(.not.b_inc) then 
         max=iset_e-iset_a+1 
!         write(6,'(a,2i4,2x,a)')'select iset_e,iset_a,ch132=',         
!     &                  iset_e,iset_a,ch132(:40)                       
         call panum(ch132,max,npanum,1) 
         iout=npanum(2) 
         if(iout.ge.1) then 
!         write(6,'(a,10i4)') ' 2 out=',(int(out(j)),j=1,iout)          
          n_int(iset,0)=0 
          jscatterer=0 
          do j=1,iout 
           nn=npanum(j+2) 
           if(nn.gt.is_e) then 
            write(nwr,'(a,i5,a)') ' ***',nn,' is not a site' 
           else 
            if(jscatterer.lt.maxss) then 
             jscatterer=jscatterer+1 
             n_int(iset,jscatterer)=nn 
            else 
             write(nwr,'(a,i5,a)') ' *** maximum number',maxthss,       &
     &                            ' of sites reached'                   
            end if 
           end if 
          end do 
          n_int(iset,0)=jscatterer 
          if(jscatterer.eq.0) then 
           write(nwr,'(a)')                                             &
     &     '****  at least one site of the scatterer'                   
           goto 820 
          end if 
         end if 
        else 
!         write(6,'(2a)')'select ch132=',ch132(:60)                     
!         write(6,'(2a)')'select cp132=',cp132(:60)                     
         max=mstruct1 
         call panum(cp132,max,npanum,1) 
         iout=npanum(2) 
                                                                        
         if(iout.eq.0) then 
          write(nwr,'(a)')                                              &
     &    '****  at least one incoherent part of the scatterer'         
          goto 820 
         end if 
                                                                        
         n_int(iset,0)=0 
         j_intp=0 
         do j=1,iout 
          nn=npanum(2+j) 
          if(nn.gt.mstruct1) then 
           write(nwr,'(a,i5,a)') ' ***',nn,' is not a part' 
          else 
           j_intp=j_intp+1 
                                                                 ! ?? 5.
           n_int(iset,j_intp)=nn+2*maxthss 
!           maxss -> mathss 7.5.2007                                    
          end if 
         end do 
                                                                        
                                                                        
         cp132=ch132(ig2+1:) 
         lay=istruct1(mstruct1) 
         is_e=istruct2(lay) 
         max=is_e 
         call panum(cp132,max,npanum,1) 
         iout=npanum(2) 
         if(iout.eq.0) then 
          write(nwr,'(a)')                                              &
     &    '****  all sites of the incoherent parts are taken'           
          iout=0 
          do j=1,j_intp 
                                                                ! ?? 5.3
           jj=n_int(iset,j)-2*maxthss 
!           maxss -> mathss 7.5.2007                                    
           layb=istruct1(jj-1)+1 
           laye=istruct1(jj) 
           iout=iout+2 
           npanum(2+2*j-1)=-istruct2(layb-1)-1 
           npanum(2+2*j)=-istruct2(laye) 
          end do 
         end if 
         j_int=0 
         do j=1,iout 
          nn=npanum(j+2) 
          if(nn.gt.is_e) then 
           write(nwr,'(a,i5,a)') ' ***',nn,' is not a site' 
          else 
                                                              ! ?? 5.3  
           if(j_int+j_intp.lt.maxthss) then 
            j_int=j_int+1 
            n_int(iset,j_intp+j_int)=nn 
           else 
           write(nwr,'(a,i5,a)') ' *** maximum number',maxss-j_intp,    &
     &                            ' of sites reached'                   
           end if 
          end if 
         end do 
         n_int(iset,0)=j_intp+j_int 
        end if 
!        write(6,'(a,10i4)')'n_int(1,0)=',(n_int(1,ji),ji=0,5)          
         jj=n_ssub 
         do i=1,maxsub-1 
          if(n_int(i,0).lt.0.and.n_int(i+1,0).gt.0) then 
           jj=jj+1 
           if(jj.le.maxsub) then 
            do ji=0,maxthss 
             n_int(jj,ji)=n_int(i,ji) 
            end do 
           else 
            do ji=0,maxthss 
             n_int(i,ji)=0 
            end do 
           end if 
          end if 
         end do 
         do i=1,maxsub 
          if(n_int(i,0).eq.0) then 
           do j=i,maxsub-1 
            do ji=0,maxthss 
             n_int(j,ji)=n_int(j+1,ji) 
            end do 
           end do 
          end if 
         end do 
         goto 810 
               ! * out                                                  
       end if 
                                                                        
  840 continue 
      return 
      END                                           
                                                                        
                                                                        
     subroutine syn_subset(m1,m3,cmch,isub,info) 
     use glbconst, only: max8,maxfr1,maxfr2,maxthss,maxscrt,maxsub,   &
                         icstrf
     use comdat, only: mfpt
     use complt, only: n_int,n_subset,n_sub,ndisplay_mode
     use comthe, only: real_fr,thfk    
     implicit none 

     character(len=4),intent(in):: cmch 
     integer ,intent(in):: m1,m3,isub
     integer,intent(out):: info

     integer,parameter ::istr=6+4*(maxfr1+maxfr2)+3*maxthss 
     character(len=64):: frthname 
     integer       dstr,iaddr
     common/struct/dstr(istr),frthname(2),iaddr(8)

     integer       nTH1,ifrth,ien   
     common/strLOC/nTH1,ifrth(11),ien(20)                    !13.9.05                  
                                                                       
     integer   idumsc 
     integer,parameter:: max4=max8/2,                                  &
                         idumscrt=maxscrt-max4*maxsub-5*max4 
     real        datx,errx,sym,subspectrum,daty,erry 
     common/scrt/datx(max4),errx(max4),sym(max4),                      &
                 subspectrum(max4,maxsub),                             &
                 daty(max4),erry(max4),idumsc(idumscrt)                
                                                                       
     real           dum,channels,dumcsp 
     common/acstrf/dum(9),channels,dumcsp(icstrf-10) 
                                                                       
     real      p0 
     real,dimension(maxthss):: plold,plold1,plold3 
                                                                       
     integer  i,ip,ia,ie,j,jj,k,k1,l,ll,llm,lj,n1,nexp,nthe 
                                                                        
       nexp=channels 
       nthe=nTH1*2 
                                                                        
      if(cmch.eq.'subs') then 
       call calpl('test') 
                                                                        
       do  i=1,m1 
        plold1(i)=0. 
       end do 
       do  i=1,m3 
        plold3(i)=0.0 
       end do 
                                                                        
       do  i=1,m1 
        j=-(2*maxthss+i) 
                                           ! - take out and write on plo
        call replace_wi(j,plold1(i),info) 
       end do 
       do  i=1,m3 
                                            ! - take out and write on pl
        call replace_wi(-i,plold3(i),info) 
       end do 
!       write(6,'(a,10f8.2)')'frame02 plold1()=',(plold1(i),i=1,m1)     
!       write(6,'(a,10f8.2)')'frame02 plold3()=',(plold3(i),i=1,m3)     
                                                                        
       do  l=1,n_subset 
        p0=0.0 
        do  i=1,m1 
         j=2*maxthss+i 
                                     ! + write 0 to wi values           
         call replace_wi(j,p0,info) 
        end do 
                                                                        
        llm=n_int(l,0) 
        ll=0 
        do while(ll.lt.llm.and.n_int(l,ll).gt.0) 
         ll=ll+1 
        end do 
                                                                        
!        write(6,'(a,2i4)')' frame02 ll,llm=',ll,llm                    
        if(ll.eq.llm.and.n_int(l,llm).gt.0) then 
         do  i=1,m3 
                                      ! + write 0 to wi values          
          call replace_wi(i,p0,info) 
         end do 
        end if 
!      write(6,'(a,i4,a,5i4)')' l_subsp=',l,                            
!     &         ' n_int(l,ll)=',(n_int(l,ll),ll=1,4)                    
        ll=1 
        do while(ll.le.llm.and.n_int(l,ll).gt.0 ) 
         ip=n_int(l,ll) 
         if(ip.gt.maxthss) then 
          i=ip-2*maxthss 
!          write(6,'(a,2i4,f10.3)')'frame02 ip,plold1(i)=',ip,i,plold1(i
                                              ! + write plold(ip) to wi 
          call replace_wi(ip,plold1(i),info) 
         else 
!          write(6,'(a,2i4,f10.3)')'frame02 ip,plold3(i)=',ip,i,plold3(i
                                               ! + write plold(ip) to wi
          call replace_wi(ip,plold3(ip),info) 
         end if 
         if(ll.eq.llm) goto 10 
         ll=ll+1 
        end do 
   10   continue 
!       ll le llm is now guaranteed      8.2.06                         
                                                                        
        if(ll.lt.llm) then 
         do lj=ll,llm,2 
          ia=-n_int(l,lj) 
          ie=-n_int(l,lj+1) 
          do ip=ia,ie 
!          write(6,'(a,i4,f10.3)')'frame02 ip,plold3(ip)=',ip,plold3(ip)
           call replace_wi(ip,plold3(ip),info) 
          end do 
         end do 
        end if 
                                                                        
        k1=3 
        call syn_the2exp(k1,info) 
                                                                        
        j=nexp 
        if(ndisplay_mode.eq.1)j=nthe 
         do  i=1,j 
          subspectrum(i,l)=thfk(i) 
         end do 
!        end if                                                         
       end do 
                                                                        
       do  i=1,m1 
        j=2*maxthss+i 
                                           ! + write plold(jj) to wi val
        call replace_wi(j,plold1(i),info) 
       end do 
       do  i=1,m3 
                                           ! + write plold(jj) to wi val
        call replace_wi(i,plold3(i),info) 
       end do 
              !  cmch=subs,test                                         
      end if 
                                                                        
                                                                        
                                                                        
      if(cmch.eq.'subt') then 
!     write(6,'(a,i4)') ' ********** m1=',m1                            
                                                                        
       call calpl('test') 
        do  i=1,m1 
                                           ! - take out and write on plo
        call replace_wi(-i,plold(i),info) 
       end do 
!      write(6,'(a,i2,a2,f15.5)') ' plold(',i,')=',plold(i)             
                                                                        
!      subtract y - yy                                                  
                                                                        
!      absorber complete , source and detector window subtracted        
                                                                        
                                                                        
       nexp=channels 
       do k=1,nexp 
        daty(k)=real_fr(mfpt+k) 
       end do 
                                                                        
       p0=0.0 
       do j=1,isub 
        do i=1,m1 
                                     ! + write 0 to wi values           
         call replace_wi(i,p0,info) 
        end do 
                                                                        
        do i=1,n_sub(j,0) 
         jj=abs(n_sub(j,i)) 
                                             ! + write plold(jj) to wi v
         call replace_wi(jj,plold(jj),info) 
        end do 
                                                                        
        k1=3 
        call syn_the2exp(n1,info) 
                                                                        
!      write(6,'(a)') ' ------1----back in subtract----------------'    
                                                                        
        do i=1,nexp 
         daty(i)=daty(i)-thfk(i) 
        end do 
               ! isub                                                   
       end do 
                                                                        
!      calculation of the theory of the stripped spectrum               
       p0=0.0 
       do i=1,m1 
                                    ! + write 0.0 to wi values          
        call replace_wi(i,p0,info) 
       end do 
                                                                        
       do i=1,n_sub(0,0) 
        jj=n_sub(0,i) 
                                            ! + write plold(jj) to wi va
        call replace_wi(jj,plold(jj),info) 
       end do 
                                                                        
       k1=3 
         ! values are not reset by calpl, written on theory-array       
       call syn_the2exp(k1,info) 
                                                                        
!      write(6,'(a)') ' ------2----back in subtract----------------'    
!      restore parameters                                               
       call calpl('test') 
                ! cmch='subt'                                           
      end if 
                                                                        
      k1=3 
      call syn_the2exp(k1,info) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
      SUBROUTINE INDEXi(N,IRRIN,INDX)
      implicit none
      integer N,J,L,I,IR,INDXT
      integer,DIMENSION(N):: IRRIN,INDX 
      real    Q
      DO  J=1,N 
        INDX(J)=J 
      END DO 
      L=N/2+1 
      IR=N 
   10 CONTINUE 
        IF(L.GT.1)THEN 
          L=L-1 
          INDXT=INDX(L) 
          Q=IRRIN(INDXT) 
        ELSE 
          INDXT=INDX(IR) 
          Q=IRRIN(INDXT) 
          INDX(IR)=INDX(1) 
          IR=IR-1 
          IF(IR.EQ.1)THEN 
            INDX(1)=INDXT 
            RETURN 
          ENDIF 
        ENDIF 
        I=L 
        J=L+L 
   20   IF(J.LE.IR)THEN 
          IF(J.LT.IR)THEN 
            IF(IRRIN(INDX(J)).LT.IRRIN(INDX(J+1)))J=J+1 
          ENDIF 
          IF(Q.LT.IRRIN(INDX(J)))THEN 
            INDX(I)=INDX(J) 
            I=J 
            J=J+J 
          ELSE 
            J=IR+1 
          ENDIF 
        GO TO 20 
        ENDIF 
        INDX(I)=INDXT 
      GO TO 10 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
    subroutine channels_adjust(nvch,nhyperfine,nstrob_order,nomega,iall)                                  
    use glbconst, only: maxn,maxscrd
    implicit none

!      the routine calculates channels needed for a nonequidistant     
!      channel numbers for all later shifts +- nomega in the stoboscopi
!      integration                                                     
!      iall is limited by maxn -> -maxn:maxn are the size of arrays    
       integer,intent(in) :: nvch,nhyperfine,nstrob_order,nomega
       integer,intent(out):: iall

       integer,parameter :: nn=16*maxn 
       integer,dimension(0:nn)  :: ichh
       integer,dimension(-nn:nn):: inp
       integer,dimension(nn)    :: IRRIN,INDX

       integer ichall,idumscrd                                 
       common/scrd/ichall(0:maxn*2),idumscrd(maxscrd-1-maxn*2) 
       equivalence (idumscrd(1),ichh(0)),(idumscrd(nn+2),inp(-nn)),    &
          (idumscrd(3*nn+3),IRRIN(1)),(idumscrd(4*nn+3),INDX(1))       

       integer    i,j,k,kk,kom,mcht,n

      iall=0 
      DO n=0,nstrob_order 
!      +-m =2m eqidistant steps,                                       
       kom=n*nomega/2 
        mcht=kom+nhyperfine 
        do i=0,mcht 
         inp(i)=i 
        end do 
        do i=1,mcht 
         inp(mcht+i)=i+kom 
        end do 
        j=2*mcht+1 
        do i=kom,mcht 
         inp(j+i)=i-kom 
        end do 
        j=3*mcht-kom+1 
        do i=1,nvch 
         inp(j+i)=mcht+i*(i+1)/2+kom 
        end do 
        j=3*mcht-kom+1+nvch 
        do i=1,nvch 
         inp(j+i)=mcht+i*(i+1)/2-kom 
        end do 
                                                                       
        j=3*mcht-kom+1+nvch*2 
        if(iall+j.gt.nn) then 
         iall=-iall-j 
!         write(6,'(a,i6)')' nn zu klein iall+j=',-iall                
         return 
        end if 
        do i=0,j 
         IRRIN(i+1+iall)=inp(i) 
        end do 
        iall=iall+j+1 
!        write(6,'(a,i7)')' before iall=',iall                         
        call INDEXi(iall,IRRIN,INDX) 
        do k=1,iall 
         ichh(k)=IRRIN(INDX(k)) 
        end do 
!        print '(a )', 'before             elimination'                
!        print '(20i5)',(ichh(i),i=1,iall)                             
!        print '(20i5)',(ichh(i),i=1,iall/2)                           
!        print '(20i5)',(ichh(i),i=iall/2+1,iall)                      
!        print '(20i5)',n,kj,m,nomega,nvch                             
!        read(5,'(a)')                                                 
                                                                       
        k=0 
!       elimination of multiple indices                                
  400   k=k+1 
        if(ichh(k).eq.ichh(k+1))then 
         iall=iall-1 
         do kk=k+1,iall 
          ichh(kk)=ichh(kk+1) 
         end do 
         k=k-1 
         ichh(iall+1)=0 
        end if 
        if(k.lt.iall-1) goto 400 
        do i=1,iall 
         IRRIN(i)=ichh(i) 
        end do 
!       print '(a )', 'after elimination'                              
!       print '(20i5)',(ichh(i),i=1,iall)                              
!       read(5,'(a)')                                                  
!       end do  ! +-nomega                                             
!       write(6,'(a,i7)')' after  iall=',iall                          
                                                                       
              !for all nStrobo                                         
      END DO 
!      print '(" order  ")'                                            
!      print '(" iall,nvch,nhyperfine= ",5i6)',iall,nvch,nhyperfine    
      ichall(0)=0 
      if(iall.le.2*maxn)then 
       do k=1,iall 
        ichall(k)=ichh(k) 
       end do 
      else 
       iall=-iall 
      end if 
                                                                       
      return 
     END                                           
                                                                        
                                                                        
      subroutine ot_theo(i_3d,ab_the,iaset,xb_the,dx_the,yb_the,dy_the) 
      use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd
      use comthe, only: array_fr      
      implicit none 

      integer,intent(out),dimension(128):: iaset
      real,intent(out)   ,dimension(128):: ab_the
      integer,intent(out):: i_3d
      real,intent(out)   :: xb_the,dx_the,yb_the,dy_the 

      integer,parameter ::istr=3*maxfr2+3*maxthss+2*(maxfr1+1)+32 
      integer       mstruct1,istruct1,istruct2,l1_get,idum,nstorTH,iaddr
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                    l1_get(0:maxfr1),idum(istr),nstorTH,iaddr(7)

      integer       nTH1,ien
      common/strLOC/nTH1,ien(31)                      

      integer     icase,k_omega,n_omega,i_theta,n_theta,i_angle,j,ig 
      real        omega,omega_beg,domega,omega_end,grazinc,grazout,     &
                  theta,theta_beg,dtheta,theta_end                      

      integer,parameter ::iscrd=maxscrd-128*128 
      integer     jth,idscrd
      common/scrd/jth(-3:124,-3:124),idscrd(iscrd) 
                                                                        
!      n_theta,theta_beg,dtheta,n_omega,omega_beg,domega                
       icase=int(real(array_fr(l1_get(0)+1))) 
       n_omega=int(real(array_fr(l1_get(0)+2))) 
       n_theta=int(aimag(array_fr(l1_get(0)+2))) 
       omega_beg=real(array_fr(l1_get(0)+3)) 
       domega=aimag(array_fr(l1_get(0)+3)) 
       theta_beg=real(array_fr(l1_get(0)+4)) 
       dtheta=aimag(array_fr(l1_get(0)+4)) 
       omega_end=real(array_fr(l1_get(0)+5)) 
       theta_end=aimag(array_fr(l1_get(0)+5)) 
                                                                        
!       write(6,'(6f10.1)')(array_fr(l1_get(0)+j),j=1,5)                
                                                                        
       nstorTH=l1_get(0)+6             ! see th_scanmode()  
       nTH1=real(array_fr(l1_get(0)+6)) 
!       write(6,'(a,3f10.1)')'fr_synmos array_fr=',array_fr(l1_get(0)+6)
!       write(6,'(a,i4,4x,3f10.4)')'n_theta,theta_beg,dtheta,theta_end=',&                         
!        n_theta,theta_beg,dtheta,theta_end                            
!       write(6,'(a,i4,4x,3f10.4)')'n_omega,omega_beg,domega,omega_end=',&                        
!        n_omega,omega_beg,domega,omega_end                            
      jth=0
      i_3d=0 

      if(icase.eq.3) i_3d=1 
      if(icase.eq.4) i_3d=-1 
      iaset=0
      iaset(1)=0 
      i_angle=0 
      do i_theta=1,n_theta 
       theta=theta_beg+dtheta*(i_theta-1) 
       ig=0 
       do k_omega=1,n_omega 
        omega=omega_beg+domega*(k_omega-1) 
                                                                        
        if(icase.eq.1.or.icase.eq.4) then 
          grazinc=omega 
          grazout=theta 
        else if(icase.eq.2.or.icase.eq.3) then 
           grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta 
           grazout=2*omega_beg+domega*(n_omega-1)+                      &
     &       (i_theta-1)*dtheta*2-grazinc                               
        else if(icase.eq.5) then 
!        PHI_s=omega N_s=n_omega                                        
         j=i_theta/2 
         if(2*j.eq.i_theta) then 
!         + dTheta_out                                                  
          grazinc=omega 
          grazout=(omega+dtheta*j) 
         else 
!         + dTheta_out                                                  
          grazinc=(omega+dtheta*j) 
          grazout=omega 
         end if 
         if(omega+dtheta*j.gt.omega_end)goto 77 
        end if 
        i_angle=i_angle+1 
        jth(k_omega-1,i_theta-1)=i_angle 
                                                                        
        ig=ig+1 
        if(ig.eq.1)then 
         ab_the(i_theta)=grazinc 
        end if 
                                                                        
   77   continue 
!       write(6,'(a,3i6)')'ot ',i_angle,k_omega-1,i_theta-1             
                  ! n_omega                                             
       end do 
       iaset(i_theta+1)=i_angle 
                  ! n_theta                                             
       end do 
!       write(6,'(10i5)')iaset
       xb_the=omega_beg 
       dx_the=domega 
       yb_the=theta_beg 
       dy_the=dtheta

!       write(6,'(a,4f12.2)')'xb_the,dx_the,yb_the,dy_the=',            
!     &      xb_the,dx_the,yb_the,dy_the                                
       return 
      END                                           
                                                                        
                                                                        
                                                                        
       subroutine opticN(mlay,b_Cm,MAXGRP,GEOSTR,SFI,                   &
                           Kmatrix,roughlay,VKD,Rmatrix)               
!                                                                       
! ******************************************************************    
!                                                                       
!                              OPTICS                                   
!                                                                       
!          Reflectivity calculation of anisotropic multilayers          
!          in the Mossbauer case. 1mrad<FI<10mrad, K~1.E-5.             
!                                                                       
!          (method of G. H. Borzbov et. al. - L. Deak et. al.)          
!                                                                       
!                         Laszlo Deak                                   
!                                                                       
!                         Budapest, 1995. July                          
!                         Mainz, 2002. October                          
!                                                                       
!                         Khaidukov Yuri                                
!	                  Budapest, 2003. April-May                           
!                                                                       
! *****************************************************************     
!                                                                       
! Geometry:                                                             
!                                                                       
!                                                                       
!               incident        reflected                               
!                                                                       
!                        \    /                                         
!                         \  /                                          
!                      FI (\/                                           
!      Z=0>           -------------                                     
!           covering  _____________         [D(1),K(1,I,J)]             
!                                  >Layer#1 [D(2),K(2,I,J)]             
!                 1.  .............                                     
!                           .                                           
!                           .                                           
!                     .............                                     
! Z=NP*Sum(D(L)) NL.  _____________Layer#NL [D(NL-1),K(NL-1,I,J)]       
!       I                                                               
!          substrate  _____________         [D(NL),K(NL,I,J)]           
!                            `                 ^                        
!                              `            infinit or finit            
!                             refracted                                 
!                                                                       
!                                                                       
!  Variables of system:                                                 
!                                                                       
!  INPUT:                                                               
!                                                                       
!                           covering   layer #L     substrate           
!                                                                       
!            thickneses:         D(1)     D(L)        D(NL)             
!                                                                       
!        susceptibility:                                                
!          (nuclear+electronic)                                         
!                                K(1)     K(L)        K(NL)             
!                                                                       
!         where  L=1..NL  I,J=1,2,3                                     
!                                                                       
!  OUTPUT:                                                              
!                                                                       
!         The 2x2 complex reflectivity (or transmitivity) matrix:  R    
!                                                                       
! ******************************************************************    
!       subroutine optic(mlay,b_Cm,MAXGRP,GEOSTR,SFI,Kmatrix,      
!     &                      chilay,roughlay,VKD,Rmatrix)               
!                                                                       
!                                                                       
!                                                                       
       implicit none 
!   input:                                                              
       integer,intent(in):: mlay,MAXGRP 
       real (kind=8),intent(in):: SFI
       logical,intent(in),dimension(mlay):: b_Cm 
       integer,intent(in),dimension(0:2*MAXGRP)::GEOSTR
       real (kind=8),intent(in),dimension(mlay)::roughlay,VKD 
       complex(kind=8),intent(in),dimension(2,2,mlay) :: Kmatrix 

!      NL=mlay: number of layers  (in period)( not expicitly used)      
       complex(kind=8),intent(out),dimension(2,2):: Rmatrix

!      other variables: 
       complex(kind=8),dimension(2,2):: KL,KLprev 
       real(kind=8)    :: DL 
       complex(kind=8),dimension(4,4):: M,ML,MS
       complex(kind=8),parameter:: C0=(0.D0,0.D0), C1=(1.D0,0.D0),    &
                                    CI=(0.D0,1.D0) 
       logical    b_odz,b_first,b_grp,both_dgnl,prev_dgnl 
       integer    I,J,L,n_rep,GRP,LMIN,LMAX,Lprev,POINTER,NLOG 
       real       absCmatr,absMatr 
                                                                        
!      print *,b_Cm	                                                    
!      print *,SFI                                                      
!      print *,MAXGRP                                                   
!      print *,GEOSTR                                                   
!      print *,chilay                                                   
!      print *,VKD                                                      
                                                                        
       b_first     =.true. 
       POINTER=0 
                            ! loop for the groups                       
       do GRP=1,MAXGRP 
!       To set the characteristic matrix to unit matrix                 
        ML=C0

        do I=1,4 
         ML(I,I)=C1 
        end do 
                                                                        
        b_grp=.false. 
!                                                                       
        LMIN =POINTER+1 
        LMAX =POINTER+GEOSTR(2*GRP) 
        n_rep=GEOSTR(2*GRP-1) 
!                                                                       
        do L=LMIN,LMAX 
         DL=VKD(L) 
         if(DL.ne.0.) then 
          if(DL.lt.0)DL=1.0d30 
          b_odz=.false. 
          b_grp=.true. 
          if(b_Cm(L))then 
           KL(1,1)=Kmatrix(1,1,L) 
           KL(1,2)=Kmatrix(1,2,L) 
           KL(2,1)=Kmatrix(2,1,L) 
           KL(2,2)=Kmatrix(2,2,L) 
                                                                        
           absCmatr=dreal( KL(1,2)*conjg( KL(1,2))+                     &
     &                    KL(2,1)*conjg( KL(2,1)))                      
           if(absCmatr.lt.1.e-15) b_odz=.true. 
          else 
           KL(1,1)=Kmatrix(1,1,L) 
           KL(1,2)=Kmatrix(1,2,L) 
           KL(2,1)=Kmatrix(2,1,L) 
           KL(2,2)=Kmatrix(2,2,L) 
           b_odz=.true. 
          end if 
                                                                        
          call genM(b_odz,SFI,DL,KL,M) 
                                                                        
! --------------------Roughness calculation of Y. Khaidukov:------------
!                                                                       
        if(roughlay(L).gt.0.) then 
                                              ! In case of repeating lay
           if(n_rep.gt.1.and.L.eq.Lmin) then 
                             ! we are more interested in the            
          Lprev=Lmax 
                                            ! information about roughnes
         else 
                                      ! in repeated ones.               
                            ! #Khaidukov                                
          Lprev=L-1 
                ! n_rep.gt.1.and.L.eq.Lmin                              
         endif 
                                                                        
         do I=1,2 
          do J=1,2 
           if (Lprev.eq.0) then 
                                   ! In case of 1st layer KLprev is for 
            KLprev(I,J)=C0 
                                   ! This variable for check the diagona
            prev_dgnl=.true. 
           endif 
                                                                        
             if (Lprev.gt.0) then 
              prev_dgnl=.not.b_Cm(Lprev) 
              KLprev(I,J)=Kmatrix(I,J,Lprev) 
           endif 
                                                                        
                    ! J                                                 
            end do 
                  ! I                                                   
         end do 
!                                                                       
           absMatr=dreal(                                               &
     &              (KLprev(1,2)-KL(1,2))*conjg((KLprev(1,2)-KL(1,2)))+ &
     &              (KLprev(2,1)-KL(2,1))*conjg((KLprev(2,1)-KL(2,1)))) 
                                                                        
                                                                        
                                              ! If susceptibility of bot
           if(prev_dgnl.and.b_odz) then 
                                              ! are diagonal we give tru
            both_dgnl=.true. 
                                            ! for roughness subroutine  
           elseif (absMatr.lt.1.e-15) then 
          both_dgnl=.true. 
           else 
          both_dgnl=.false. 
           endif 
                                                                        
!           call roughnessN(both_dgnl,roughlay(L),SFI,KLprev,KL,M)      
          endif 
! --------------------end of Roughness calculation ---------------      
                                                                        
                                                                        
          call mat4(M,ML,ML) 
               ! VKD(L)>0.                                              
         endif 
               ! L                                                      
        end do 
                                                                        
!     For periodic multilayers the int. propagation matrix is (ML)**n_re
!     where n_rep is the number of periods.                             
!                                                                       
!                                                                       
        if(n_rep.gt.1.and.b_grp)then 
         do I=1,4 
          do J=1,4 
           M(I,J)=ML(I,J) 
          end do 
         end do 
!                                                                       
         NLOG=alog(float(n_rep))/alog(2.0) 
!                                                                       
         do I=1,NLOG 
          call mat4(ML,ML,ML) 
         end do 
                                                                        
         do I=1,n_rep-2**NLOG 
          call mat4(M,ML,ML) 
         end do 
!                                                                       
                ! n_rep>1                                               
        end if 
                                                                        
        if(b_first) then 
         b_first=.false. 
         MS=ML 
        else 
         call mat4(ML,MS,MS) 
        end if 
!                                                                       
        POINTER=POINTER+GEOSTR(2*GRP) 
              ! GRP                                                     
       end do 
!                                                                       
!     Now we have the integreted propagation matrix of the structure: ML
!     Calculation of reflectivity matrix (2x2):                         
!                                                                       
      call refl(MS,Rmatrix) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
       subroutine optic(mlay,b_Cm,MAXGRP,GEOSTR,SFI,Cmatrix,       &
                                     chilay,roughlay,VKD,Rmatrix)                
!                                                                       
! ******************************************************************    
!                                                                       
!                              OPTICS                                   
!                                                                       
!          Reflectivity calculation of anizotropic multilayers          
!          in the Mossbauer case. 1mrad<FI<10mrad, K~1.E-5.             
!                                                                       
!          (method of G. H. Borzbov et. al. - L. Deak et. al.)          
!                                                                       
!                         Laszlo Deak                                   
!                                                                       
!                         Budapest, 1995. July                          
!                         Mainz, 2002. October                          
!                                                                       
!                         Khaidukov Yuri                                
!	                  Budapest, 2003. April-May                           
!                                                                       
! *****************************************************************     
!                                                                       
! Geometry:                                                             
!                                                                       
!                                                                       
!               incident        reflected                               
!                                                                       
!                        \    /                                         
!                         \  /                                          
!                      FI (\/                                           
!      Z=0>           -------------                                     
!           covering  _____________         [D(1),K(1,I,J)]             
!                                  >Layer#1 [D(2),K(2,I,J)]             
!                 1.  .............                                     
!                           .                                           
!                           .                                           
!                     .............                                     
! Z=NP*Sum(D(L)) NL.  _____________Layer#NL [D(NL-1),K(NL-1,I,J)]       
!       I                                                               
!          substrate  _____________         [D(NL),K(NL,I,J)]           
!                            `                 ^                        
!                              `            infinit or finit            
!                             refracted                                 
!                                                                       
!                                                                       
!  Variables of system:                                                 
!                                                                       
!  INPUT:                                                               
!                                                                       
!                           covering   layer #L     substrate           
!                                                                       
!            thickneses:         D(1)     D(L)        D(NL)             
!                                                                       
!        susceptibility:                                                
!          (nuclear+electronic)                                         
!                                K(1)     K(L)        K(NL)             
!                                                                       
!         where  L=1..NL  I,J=1,2,3                                     
!                                                                       
!  OUTPUT:                                                              
!                                                                       
!         The 2x2 complex reflectivity (or transmitivity) matrix:  R    
!                                                                       
! ******************************************************************    
!       subroutine optic(mlay,b_Cm,MAXGRP,GEOSTR,SFI,Cmatrix,      
!     &                      chilay,roughlay,VKD,Rmatrix)               
!                                                                       
!                                                                       
!                                                                       
       implicit none 
!   input:
       integer ,intent(in):: mlay,MAXGRP 
       real,    intent(in):: SFI                                                              
       logical,intent(in),dimension(mlay):: b_Cm
       integer,intent(in),dimension(0:2*MAXGRP):: GEOSTR
       real,intent(in),dimension(mlay):: roughlay,VKD

       complex(kind=4),intent(in),dimension(2,2,mlay) :: Cmatrix
       complex(kind=4),intent(in),dimension(mlay) :: chilay
       complex(kind=4),intent(out),dimension(2,2) :: Rmatrix 
!      NL=mlay: number of layers  (in period)( not expicitly used)      
!      other variables:                                                 
       integer    I,J,L,n_rep,GRP,LMIN,LMAX,Lprev,POINTER,NLOG 
       real       absCmatr,absMatr 
       real(kind=8) ::     sinFI, DL 
       complex(kind=8),dimension(2,2) :: R,KL,KLprev,UnMat
       complex(kind=8),dimension(4,4) :: M,ML,MS
       logical    b_odz,b_first,b_grp,both_dgnl,prev_dgnl 
       complex(kind=8),parameter :: C0=(0.D0,0.D0), C1=(1.D0,0.D0),     &
                                    CI=(0.D0,1.D0) 
                                                                        
       UnMat(1,1)=C1 
                      !Unit matrix                                      
       UnMat(1,2)=C0 
       UnMat(2,1)=C0 
       UnMat(2,2)=C1 
                                                                        
!      print *,b_Cm	                                                    
!      print *,SFI                                                      
!      print *,MAXGRP                                                   
!      print *,GEOSTR                                                   
!      print *,chilay                                                   
!      print *,VKD                                                      
!      read(5,'(a)')                                                    
                                                                        
                            ! the double precision grazing angle        
       sinFI=sin(dble(SFI)) 
!                                                                       
       b_first     =.true. 
       POINTER=0 
                            ! loop for the groups                       
       do GRP=1,MAXGRP 
!       To set the characteristic matrix to unit matrix                 
        do I=1,4 
         do J=1,4 
          ML(I,J)=C0 
         end do 
         ML(I,I)=C1 
        end do 
        b_grp=.false. 
!                                                                       
        LMIN =POINTER+1 
        LMAX =POINTER+GEOSTR(2*GRP) 
        n_rep=GEOSTR(2*GRP-1) 
!                                                                       
        do L=LMIN,LMAX 
         if(VKD(L).gt.0.) then 
          b_odz=.false. 
          b_grp=.true. 
          DL=VKD(L) 
          if(b_Cm(L))then 
           KL(1,1)=Cmatrix(1,1,L)+chilay(L) 
           KL(1,2)=Cmatrix(1,2,L) 
           KL(2,1)=Cmatrix(2,1,L) 
           KL(2,2)=Cmatrix(2,2,L)+chilay(L) 
           absCmatr=dreal( KL(1,2)*conjg( KL(1,2))+                     &
     &                    KL(2,1)*conjg( KL(2,1)))                      
           if(absCmatr.lt.1.e-15) b_odz=.true. 
          else 
           KL(1,1)=chilay(L) 
           KL(1,2)=C0 
           KL(2,1)=C0 
           KL(2,2)=chilay(L) 
           b_odz=.true. 
          end if 
                                                                        
          call genM(b_odz,sinFI,DL,KL,M) 
! Roughness calculation of Y. Khaidukov:                                
!                                                                       
        if(roughlay(L).gt.0.) then 
                                              ! In case of repeating lay
           if(n_rep.gt.1.and.L.eq.Lmin) then 
                             ! we are more interested in the            
          Lprev=Lmax 
                                            ! information about roughnes
         else 
                                      ! in repeated ones.               
                            ! #Khaidukov                                
          Lprev=L-1 
                ! n_rep.gt.1.and.L.eq.Lmin                              
         endif 
                                                                        
         do I=1,2 
          do J=1,2 
           if (Lprev.eq.0) then 
                                   ! In case of 1st layer KLprev is for 
            KLprev(I,J)=C0 
                                   ! This variable for check the diagona
            prev_dgnl=.true. 
           endif 
                                                                        
             if (Lprev.gt.0) then 
              prev_dgnl=.not.b_Cm(Lprev) 
            if(b_Cm(Lprev))then 
               KLprev(I,J)=Cmatrix(I,J,Lprev)+chilay(Lprev)*UnMat(I,J) 
              else 
               KLprev(I,J)=chilay(Lprev)*UnMat(I,J) 
              endif 
           endif 
                                                                        
                    ! J                                                 
            end do 
                  ! I                                                   
         end do 
!                                                                       
           absMatr=real(dble(                                           &
     &              (KLprev(1,2)-KL(1,2))*conjg((KLprev(1,2)-KL(1,2)))+ &
     &              (KLprev(2,1)-KL(2,1))*conjg((KLprev(2,1)-KL(2,1)))))
                                                                        
                                                                        
                                              ! If susceptibility of bot
           if(prev_dgnl.and.b_odz) then 
                                              ! are diagonal we give tru
            both_dgnl=.true. 
                                            ! for roughness subroutine  
           elseif (absMatr.lt.1.e-15) then 
          both_dgnl=.true. 
           else 
          both_dgnl=.false. 
           endif 
                                                                        
           call roughness(both_dgnl,roughlay(L),sinFI,KLprev,KL,M) 
          endif 
!   ***********************	                                            
          call mat4(M,ML,ML) 
               ! VKD(L)>0.                                              
         endif 
               ! L                                                      
        end do 
                                                                        
!     For periodic multilayers the int. propagation matrix is (ML)**n_re
!     where n_rep is the number of periods.                             
!                                                                       
!                                                                       
        if(n_rep.gt.1.and.b_grp)then 
         M=ML 
         NLOG=alog(float(n_rep))/alog(2.0) 
!                                                                       
         do I=1,NLOG 
          call mat4(ML,ML,ML) 
         end do 
                                                                        
         do I=1,n_rep-2**NLOG 
          call mat4(M,ML,ML) 
         end do 
!                                                                       
                ! n_rep>1                                               
        end if 
                                                                        
        if(b_first) then 
         b_first=.false. 
         MS=ML 
        else 
         call mat4(ML,MS,MS) 
        end if 
!                                                                       
        POINTER=POINTER+GEOSTR(2*GRP) 
              ! GRP                                                     
       end do 
!                                                                       
!     Now we have the integreted propagation matrix of the structure: ML
!     Calculation of reflectivity matrix (2x2):                         
      call refl(MS,R) 
      Rmatrix=R 

      return 
      END                                           
!                                                                       
                                                                        
                                                                        
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
!                                                                       
      subroutine refl(M,R) 
!                                                                       
! *******************************************************************   
!                                                                       
!                 Calculation of reflectivity matrix (2X2)              
!                                                                       
! ******************************************************************    
!                                                                       
      implicit none 
      complex(kind=8),intent(in),dimension(4,4) :: M
      complex(kind=8),intent(out),dimension(2,2):: R
      complex(kind=8):: AA,BB,CC,DD 
      complex(kind=8),dimension(2,2):: R1,R2,R11 
      integer    I,J 
!                                                                       
!    Definition of 2x2 block matrices:                                  
!                                                                       
      do I=1,2 
        do J=1,2 
          AA= M(I,J) 
          BB= M(I,J+2) 
          CC= M(I+2,J) 
          DD= M(I+2,J+2) 
          R1(I,J)= AA-BB-CC+DD 
          R2(I,J)= AA+BB-CC-DD 
        end do 
      end do 
!                                                                       
      call inv2(R1,R11) 
!                                                                       
      call mat2(R11,R2,R) 
!                                                                       
      return 
      END                                           
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++   
!                                                                       
    subroutine genM(b_odz,sinFI,DL,KL,M) 
!                                                                       
! ******************************************************************    
!                                                                       
!            Definition of the integral propagation matrix              
!                   (see  Eq. (3.20) in the paper)                      
!                                                                       
! *****************************************************************     
    implicit none 
    logical,     intent(in):: b_odz 
    real(kind=8),intent(in):: DL,sinFI 
    complex(kind=8),intent(in), dimension(2,2) :: KL
    complex(kind=8),intent(out),dimension(4,4) :: M
                                                                        
    integer    I,J 
    real(kind=8)    :: aimFFF,sin2FI 
    complex(kind=8) :: FFF,sinFFF,FF1                                
    complex(kind=8),dimension(2,2):: exppF,expmF,FL,invF,shF,M12,M21,FF           
                                                                        
    complex(kind=8),parameter :: C0=(0.D0,0.D0),CI=(0.D0,1.D0),       &
                                 C1=(1.D0,0.D0)          
    real(kind=8),parameter :: aLIMIT=2.D1                                           
                                                                        
!     Definition of F and X ( Eq. (3.20) L.Deak et al, Phys. Rev B 1996)
                                                                        
      sin2FI = sinFI*sinFI 
!                                                                       
      FF(1,1)=-sin2FI-KL(1,1) 
      FF(1,2)=-KL(1,2) 
      FF(2,1)=-KL(2,1) 
      FF(2,2)=-sin2FI-KL(2,2) 
!                                                                       
!        b_odz==(FF(2,1).eq.C0).and.(FF(1,2).eq.C0)                     
      if(b_odz)then 
       FF(1,1)=sqrt(FF(1,1)) 
       FF(2,2)=sqrt(FF(2,2)) 
      else 
       call sqrt2(FF,FF) 
      endif 
!                                                                       
      do I=1,2 
       do J=1,2 
        FL(I,J)=DL*FF(I,J) 
       end do 
      end do 
!                                                                       
      do I=1,2 
       do J=1,2 
        exppF(I,J) =FL(I,J) 
        M(I,J)     =C0 
        M(I+2,J+2) =C0 
        M(I,J+2)   =C0 
        M(I+2,J)   =C0 
       end do 
      end do 
!        b_odz==(FL(2,1).eq.C0).and.(FL(1,2).eq.C0)                     
      if(b_odz)then 
       do J=1,2 
        FF1   =FF(J,J) 
        FFF   =FL(J,J)*CI 
        aimFFF=dimag(FFF) 
        if(aimFFF.gt.aLIMIT)then 
         M(J,J)    = C1 
         M(J+2,J+2)= C1 
         M(J,J+2)  =-CI*FF1/sinFI 
                                       ! aimFFF -> +infinit             
         M(J+2,J)  = CI/FF1*sinFI 
!         write(*,*)'+inf'                                              
        else 
         if(aimFFF.lt.-aLIMIT)then 
          M(J,J)    = C1 
          M(J+2,J+2)= C1 
          M(J,J+2)  = CI*FF1/sinFI 
                                       ! aimFFF -> -infinit             
          M(J+2,J)  =-CI/FF1*sinFI 
!          write(*,*)'-inf'                                             
         else 
          sinFFF    = sin(FFF) 
          M(J,J)    = cos(FFF) 
          M(J+2,J+2)= M(J,J) 
          M(J,J+2)  =-sinFFF*FF1/sinFI 
                                       ! general case                   
          M(J+2,J)  = sinFFF/FF1*sinFI 
!          write(*,*)'general'                                          
         end if 
        end if 
       end do 
!                                                                       
      else 
!                                                                       
       call inv2(FF,invF) 
       call exp2(exppF) 
       call inv2(exppF,expmF) 
!                                                                       
       do I=1,2 
        do J=1,2 
         M(I,J)    = 0.5D0*(exppF(I,J)+expmF(I,J)) 
         M(I+2,J+2)= M(I,J) 
         shF(I,J)  = 0.5D0*(exppF(I,J)-expmF(I,J)) 
        end do 
       end do 
!                                                                       
       call mat2(FF,shF,M12) 
       call mat2(invF,shF,M21) 
!                                                                       
       do I=1,2 
        do J=1,2 
         M(I,J+2) = -M12(I,J)/sinFI*CI 
         M(I+2,J) =  M21(I,J)*sinFI*CI 
        end do 
       end do 
!                                                                       
            ! b_odz == KL diagonal                                      
      endif 
!                                                                       
      return 
      END                                           
                                                                        
      subroutine roughness(both_dgnl,sigma,A0,A1,A2,M) 
! ******************************************************************    
                                                                        
!  This ysubroutine updates integrated matrix of distibution with roughne
!	 the top border of a given layer.                                     
!      M->Mupd, where Mupd=exp(sigma**2)*[W1,W2]*0.5*M. For the details 
!      R. Rohlsberger, Hyperfine Inreractions 123/124 (1999) 301-325    
!      ------------------------------------------------------------     
!	 Differential matrix of distribution is  represented like             
!		      0		  I*Ao+Ai/Ao                                                
!      Wi   =	                                                          
!                    I*Ao		0                                            
                                                                        
!      ---------------------------------------------------------------  
       implicit none 
                                                                        
!      Input variables	                                                 
       logical,intent(in):: both_dgnl 
       real,   intent(in):: sigma 
       real(kind=8),intent(in):: A0 
       complex(kind=8),intent(in), dimension(2,2):: A1,A2
       complex(kind=8),intent(out),dimension(4,4):: M

       complex(kind=8),dimension(4,4):: Mupd 
                                                                        
       real(kind=8)   :: sigma2 
       complex(kind=8),dimension(2,2):: exp_Dp,exp_Dm,C,dA,TMP,C2 
       complex(kind=8),dimension(4)  :: exp_scalar
       complex(kind=8),dimension(2)  :: dA_scal,C_scal

       complex(kind=8),parameter::  C1=(1.D0,0.D0),C0=(0.0,0.0) 
       integer    I,J,K 
                                                                        
       sigma2=sigma 
       sigma2=sigma2*sigma2 
                                                                        
       Mupd=C0 
                                                                        
       if(both_dgnl) then 
        do I=1,2 
         dA_scal(I)      = A2(I,I)-A1(I,I) 
                                                             ! C=2*(2*A0
         C_scal(I)       = 2.D0*(2.D0*A0*A0+A2(I,I)+A1(I,I)) 
         exp_scalar(I)   = dA_scal(I)*(C1/C_scal(I))*                   &
                          (-exp(-0.5D0*sigma2*C_scal(I))+C1)           
         exp_scalar(I)   = exp(exp_scalar(I)) 
         exp_scalar(I+2) = C1/exp_scalar(I) 
        end do 
                                                                        
!        do I=1,4                                                       
!         do J=1,4                                                      
!          Mupd(I,J) =  exp_scalar(J)*M(I,J)                            
!         end do                                                        
!	end do                                                                
                                                                        
                                              ! instead of the above loo
        Mupd(1,1) =  exp_scalar(1)*M(1,1) 
                                              ! the direct definitions, 
        Mupd(2,2) =  exp_scalar(2)*M(2,2) 
                                              ! 8 complex products inste
        Mupd(3,1) =  exp_scalar(1)*M(3,1) 
                                              ! # L. Deak               
        Mupd(4,2) =  exp_scalar(2)*M(4,2) 
                                                                        
        Mupd(1,3) =  exp_scalar(3)*M(1,3) 
        Mupd(2,4) =  exp_scalar(4)*M(2,4) 
        Mupd(3,3) =  exp_scalar(3)*M(3,3) 
        Mupd(4,4) =  exp_scalar(4)*M(4,4) 
                                                                        
       elseif(.not.both_dgnl)  then 
        C(1,1)=2.D0*(2.D0*A0*A0+A1(1,1)+A2(1,1)) 
                                                             ! C=2*(2*A0
        C(2,2)=2.D0*(2.D0*A0*A0+A1(2,2)+A2(2,2)) 
        C(1,2)=2.D0*(A1(1,2)+A2(1,2)) 
        C(2,1)=2.D0*(A1(2,1)+A2(2,1)) 
                                                                        
      do I=1,2 
       do J=1,2 
                                                 ! A=A2-A1              
          dA(I,J)=A2(I,J)-A1(I,J) 
                                                 ! TMP=-0.5*sigma**2*C  
          TMP(I,J)=-0.5D0*sigma2*C(I,J) 
         end do 
        end do 
                                                                        
                                                 ! TMP=exp(-0.5*sigma**2
        call exp2(TMP) 
                                                 ! C2=1/C               
        call inv2(C,C2) 
                                                 ! C2=dA*1/C            
        call mat2(dA,C2,C2) 
                                                                        
        TMP(1,1)= C1-TMP(1,1) 
        TMP(1,2)=-TMP(1,2) 
                                                 ! TMP=I-exp(-0.5*sigma*
        TMP(2,1)=-TMP(2,1) 
        TMP(2,2)= C1-TMP(2,2) 
                                                                        
                                                 ! expDp=dA*1/C*(I-exp(-
        call mat2(C2,TMP,exp_Dp) 
                                                 ! expDp=exp(dA*1/C*(I-e
        call exp2(exp_Dp) 
        call inv2(exp_Dp,exp_Dm) 
                                                                        
        do I=1,2 
         do J=1,2 
        do K=1,2 
           Mupd(I,J)     = Mupd(I,J)    +  M(I,K)*exp_Dp(K,J) 
           Mupd(I,J+2)   = Mupd(I,J+2)  +  M(I,K+2)*exp_Dm(K,J) 
           Mupd(I+2,J)   = Mupd(I+2,J)  +  M(I+2,K)*exp_Dp(K,J) 
           Mupd(I+2,J+2) = Mupd(I+2,J+2)+  M(I+2,K+2)*exp_Dm(K,J) 
          end do 
         end do 
        end do 
                                                                        
                                                 ! both_dgnl            
       end if 
                                                                        
       do I=1,4 
        do J=1,4 
         M(I,J)=Mupd(I,J) 
        end do 
       end do 
                                                                        
       return 
      END                                           
