      subroutine frstr_mossbauer(l_nfrtheo,lstruct1,lstruct2,           &
                                                cmch,nhelpentry)
      use comstr,only: nameth,namepg,ntheory,nstruct,ndevice,istruct,n_device,&
                       strcmt,thco,ntrmt,ctrmt,thpa,thvr
      implicit none

      integer,intent(in):: l_nfrtheo,lstruct1,lstruct2
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      character(len=4)  :: layn 
      integer   jc,jm,jp,jv 

      integer mstruct1,idum,number_device  
      common/struct/mstruct1,idum(istruct-1) 
      logical lfrthi2i6 
      integer i1,i2,i3,i4,i5,i6,i7                                                                 
!      write(6,'(2a,i6)')'####frstr_mossbauer cmch=',cmch,l_nfrtheo     
      if(cmch.eq.'name') then 
!#######################################################################
       nhelpentry  ='Mossbauer spectrum' 
       ntheory(1)='Mossbauer radioactive source' 
                                                                        
       n_device=3 
       ndevice(1)='source' 
       ndevice(2)='absorber/scatterer' 
       ndevice(3)='detector' 
!#######################################################################
       return 
      end if 
!     nhelpentry defines the name of the helpfile: Mossbauer_spectrum.he
                                                                        
!     the different cases of theories are selected by the subroutine    
!     thstr_frmossbauer:                                                
!     l_nfrtheo=1 :'Mossbauer transmission_vA'                          
!     l_nfrtheo=2 :'Mossbauer transmission_vB'                          
!     l_nfrtheo=3 :'Mossbauer reemission_vA'                            
!     l_nfrtheo=4 :'Mossbauer reemission_vB'                            
!     l_nfrtheo=5 :'Mossbauer transmission_vC'                          
!     l_nfrtheo=6 :'Mossbauer transmission_vD'                          
                                                                        
!c    l_nfrtheo=7 :'Mossbauer resonance reflection'                     
                                                                        
!     Constants and parameters defined in thstr_frmossbauer are global  
!     (may be different for each of the theories) and therefore the same
!     for all devices. The devices are addressed by lstruct1=1,2,3 which
!     only available in the frstr_...() routine.                        
!     For lstruct1=0 Constants and parameters are also global.          
                                                                        
!     The choice of the theories follows the sequence defined in        
!     thstr_mossbauer, which is allowed to be different from the list   
!     in the routine fr_mossbauer.                                      
!     The sequence in thstr_mossbauer has been changed in order         
!     to have first the transmission theories and then the reemission   
!     theories.                                                         
!     Example: Having selected  -Mossbauer transmission_vC- (the 3rd the
!              in the list) the name is identified for the case number  
!              l_nfrtheo=5 in the theory fr_mossbauer                   
      i1=1    !  nameth(1)  ='Mossbauer transmission_vA'                
      i2=2    !  nameth(2)  ='Mossbauer transmission_vB'                
      i3=5    !  nameth(5)  ='Mossbauer reemission_vA'                  
      i4=6    !  nameth(6)  ='Mossbauer reemission_vB'                  
      i5=3    !  nameth(3)  ='Mossbauer transmission_vC'                
      i6=4    !  nameth(4)  ='Mossbauer transmission_vD'                
      i7=7    !  nameth(7)  ='Mossbauer resonance reflection'           
!     Decissions asked for the theory out of the list nameth(n) are     
!     translated by the numbers in.                                     
                                                                        
!      The numbers l_nfrtheo are used for selection of constants and    
!      variables (defined by parameters and transformation matices)     
!      for the common blocks from which the theories (1,...,5) take     
!      the values.                                                      
!      lstruct1=0                common/acstrf/    /avstrf/             
!                                applies to all devices                 
!      lstruct1=1  lstruct2=0    common/acfr1trf/    /avfr1trf/         
!                  lstruct2=1    common/acfr2trf/    /avfr2trf/         
!                                device: source                         
!      lstruct1=2  lstruct2=0    common/acfr1trf/    /avfr1trf/         
!                  lstruct2=1    common/acfr2trf/    /avfr2trf/         
!                                device: absorber/scatterer             
!      lstruct1=2  lstruct2=0    common/acfr1trf/    /avfr1trf/         
!                  lstruct2=1    common/acfr2trf/    /avfr2trf/         
!                                device: detector                       
                                                                        
      lfrthi2i6=l_nfrtheo.eq.i2.or.l_nfrtheo.eq.i6 
                                                                        
!     In the list of the frame routine fr_mossbauer the numbers         
!     in brackets (without any blanks!) at the end of the names are arbi
!     (different for each case). These numbers are accessible as ifrcase
!     in routines fr_mossbauer and th_mossbauer by the 'common/thpt/'   
!     in comthe.for:                                                    
                                                                        
!       theoryname='Mossbauer radioactive source'                       
!       thfrcase(1)='Mossbauer transmission_vA(1)'                      
!       thfrcase(2)='Mossbauer transmission_vB(3)'                      
!       thfrcase(3)='Mossbauer reemission_vA(2)'                        
!       thfrcase(4)='Mossbauer reemission_vB(4)'                        
!       thfrcase(5)='Mossbauer transmission_vC(5)'                      
!       thfrcase(6)='Mossbauer transmission_vD(3)'                      
                                                                        
!c      thfrcase(7)='Mossbauer resonance reflection(6)' not in use      
                                                                        
!       ifrcase may be the same for different theories which uses the sa
!       part of code in the subroutine.                                 
!--------------------------------------------------------               
                                                                        
      chth='fr'//nhelpentry(1:6) 
                                                                        
      if(lstruct1.eq.0) then 
!      global definitions                                               
       if(cmch.eq.'hdbk') then 
        nstruct='handbook=nucleus.hdb    list=1   chth='//chth 
        return 
       end if 
                                                                        
       call conmatpar('coll',jc,jm,jp,jv,chth) 
                                                                        
       if(l_nfrtheo.eq.i1.or.lfrthi2i6) then 
        strcmt(1)='source_absorber_detector n_set=[sp] [2] 0' 
        strcmt(2)='name for the spectrum ' 
        strcmt(3)='v=0 between source and detector with resonant nuclei' 
        strcmt(4)='theory/'//chth//'/Mossbauer transmission/go' 
        strcmt(5)='theory/'//chth//'/detector/layer_v0' 
       else if(l_nfrtheo.eq.i3.or.l_nfrtheo.eq.i4) then 
        strcmt(1)='source_scatterer  n_set=[sp]   2 0  ' 
        strcmt(2)=' set name for the spectrum of the scatterer ' 
        strcmt(3)='detector is device 3 , v(source-detector)=0 ' 
        strcmt(4)='theory/'//chth//'/Mossbauer reemission/go' 
        strcmt(5)='theory/'//chth//'/layer/CEMS' 
       else if(l_nfrtheo.eq.i5) then 
        strcmt(1)='source_absorber_detector   n_set=[sp] [2] 2 ' 
        strcmt(2)=' set name for the mosaic spectrum  ' 
        strcmt(3)='number of incoherent parts of the mosaic absorber' 
        strcmt(4)='theory/'//chth//'/Mossbauer mosaic-absorber/go' 
        strcmt(5)='theory/'//chth//'/absorber/mosaic_layer' 
       else if(l_nfrtheo.eq.i7) then 
        strcmt(1)='source_scatterer    n_set=sp   2 0' 
        strcmt(2)=' set name for the scattering spectrum  ' 
        strcmt(3)='v=0 between source and detector with resonant nuclei' 
        strcmt(4)='theory/'//chth//'/Mossbauer reflection/go' 
        strcmt(5)='theory/'//chth//'/scatterer/layer' 
       end if 
                                                                        
       call conmatpar('dev0',jc,jm,jp,jv,chth) 
       return 
      end if 
                                                                        
      goto(100,200,300)number_device(lstruct1) 
!-----------------------------------------------------------------------
!     device number 1:Mossbauer source                                  
  100 if(lstruct2.gt.0) goto 110 
!     device  common/acfr1trf/    /avfr1trf/                            
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
                                                                        
      strcmt(1)='source_layer   n_device=[sc]   1 1' 
      strcmt(2)='name of source ' 
                                                         ! not used     
      strcmt(3)='(the source has one layer)' 
      strcmt(4)='distribution of parameters at sites of the source' 
      strcmt(5)='theory/'//chth//'/source/layer' 
                                                                        
      call conmatpar('dev1',jc,jm,jp,jv,chth) 
      return 
!     --------------------------------------------------                
  110 continue 
!     layers of device source  common/acfr2trf/    /avfr2trf/           
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
                                                                        
      strcmt(1)='source   n_cmpt=[s] [1] 1' 
      strcmt(2)='one letter for name of the site ' 
      strcmt(3)='number of inequivalent sites of the source ' 
      strcmt(4)='distribution of parameters of site number' 
      strcmt(5)='theory/'//chth//'/source/sites' 
                                                                        
                                                                        
!     Temperature of the source at position 5 of  common/acfr2trf/      
!     (all theories l_nfrtheo)                                          
      thco(jc+1) ='T_source         i_pos=5    include=[n]   300.0' 
                ! temperatue of the layer                               
      jc=jc+1 
                                                                        
      if(l_nfrtheo.eq.i1.or.l_nfrtheo.eq.i3) then 
                                                                        
!      l_nfrtheo=1 :'Mossbauer transmission_vA'                         
!                   call of subroutine th_hdeq,th_lines126,th_hdeqmiscel
!                   th_relaxglobalsad,th_relaxtwostatesad               
!      common/acfr2trf/acfr2                                            
                                                                        
       thco(jc+1)='iset_powder  i_pos=2  include=[n]  0' 
                ! iset=1-6 for 4-128 points on 1/48 of the sphere       
       thco(jc+2)='isymmetry  i_pos=3  include=[n]  10' 
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)          
       jc=jc+2 
                                                                        
!      common/avfr2trf/ avfr2,dum(5),Hext,thetaHe,phiHe,phi,theta,psi   
       ntrmt(jm+1)='Hextern_sc  matrix=(3,3) include=[n]' 
       ctrmt(jm+1)='external magnetic field (lab) at the source' 
        thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0' 
        thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+1)='Hext                     6    1 0 0  ' 
        thvr(jv+2)='thetaHe                  7    0 1 0 ' 
        thvr(jv+3)='phiHe                    8    0 0 1' 
                                                                        
       ntrmt(jm+2)='euler_source matrix=(3,3) include=[n]' 
       ctrmt(jm+2)='orientation of the source (lab)' 
        thpa(jp+4)='phi              , 0.0  0.0 0.0  1.0' 
        thpa(jp+5)='theta            , 0.0 0.0 0.0   1.0' 
        thpa(jp+6)='psi              , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+4)='phi                       9    1 0 0  ' 
        thvr(jv+5)='theta                    10    0 1 0 ' 
        thvr(jv+6)='psi                      11    0 0 1' 
       jm=jm+2 
       jp=jp+6 
       jv=jv+6 
                                                                        
      else if(lfrthi2i6.or.l_nfrtheo.eq.i4.or.l_nfrtheo.eq.i5)then 
!      l_nfrtheo=2 :'Mossbauer transmission_vB'                         
!                   call of subroutine th_hdeqf                         
!      common/acfr2trf/acfr2,rep_grp,aset,asymmetry,a_psi,temperature   
!      common/avfr2trf/avfr2,th_factor,dum(4),Hext,thetaHe,phiHe,       
!                      phi,theta,psi                                    
                                                                        
                                                                        
       thco(jc+1)='iset_powder  i_pos=2  include=[n]  0' 
                ! iset=1-6 for 4-128 points on 1/48 of the sphere       
       thco(jc+2)='isymmetry  i_pos=3  include=[n]  10' 
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)          
       thco(jc+3)='n_psi_powder  i_pos=4  include=[n]  0' 
                ! 3rd Euler angle, rotation around S_lab(z)             
                ! neccessary if Hext not parallel S_lab(z)              
       jc=jc+3 
                                                                        
       ntrmt(jm+1)='thickn_factor  matrix=(1,1) include=[n]' 
       ctrmt(jm+1)='thickness factor for all sites of the layer' 
        thpa(jp+1)='th_factor           , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='th_factor               1    1  ' 
                                                                        
       ntrmt(jm+2)='x2_anisotropy  matrix=(2,2) include==[n] ' 
       ctrmt(jm+2)='mean square <x2> of a crystal (source)' 
        thpa(jp+2)='d_x2                  ,  0.0  0.0 0.0  0.1' 
        thpa(jp+3)='x2_eta                ,  0.0  0.0 0.0  0.1' 
        thvr(jv+2)='d_x2                     12    1 0  ' 
        thvr(jv+3)='x2_eta                   13    0 1  ' 
                                                                        
       ntrmt(jm+3)='x2_orientation   matrix=(3,3) include=[n] ' 
       ctrmt(jm+3)='x2_orientation with ref. to a crystal (source)' 
        thpa(jp+4)='x2_phi                , 0.0  0.0 0.0  1.0' 
        thpa(jp+5)='x2_theta              , 0.0  0.0 0.0  1.0' 
        thpa(jp+6)='x2_psi                , 0.0  0.0 0.0  1.0' 
        thvr(jv+4)='x2_phi                   14    1 0 0 ' 
        thvr(jv+5)='x2_theta                 15    0 1 0 ' 
        thvr(jv+6)='x2_psi                   16    0 0 1 ' 
                                                                        
       ntrmt(jm+4)='ax_texture  matrix=(2,2) include=[n] ' 
       ctrmt(jm+4)='texture of the source layer ' 
        thpa(jp+7)='t200                   , 0.0  0.0 0.0  0.1' 
        thpa(jp+8)='t400                   , 0.0  0.0 0.0  0.1' 
        thvr(jv+7)='t200                     17    1 0' 
        thvr(jv+8)='t400                     18    0 1 ' 
       jm=jm+4 
       jp=jp+8 
       jv=jv+8 
       ntrmt(jm+1)='Hextern_sc  matrix=(3,3) include=[n] ' 
       ctrmt(jm+1)='external magnetic field (lab) at the source' 
        thpa(jp+1)='Hext             , 0.0  0.0 0.0   1.0' 
        thpa(jp+2)='thetaHe          , 0.0  0.0 0.0   1.0' 
        thpa(jp+3)='phiHe            , 0.0  0.0 0.0   1.0 ' 
        thvr(jv+1)='Hext                     6    1 0 0  ' 
        thvr(jv+2)='thetaHe                  7    0 1 0 ' 
        thvr(jv+3)='phiHe                    8    0 0 1' 
       jm=jm+1 
       jp=jp+3 
       jv=jv+3 
      end if 
                                                                        
      call conmatpar('_518',jc,jm,jp,jv,chth) 
                                                                        
      return 
!--------------------------------------------------------------------   
!     device number 2:Mossbauer absorber/scatterer                      
  200 if(lstruct2.gt.0) goto 210 
                                                                        
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
                                                                        
      if(l_nfrtheo.le.i1.or.lfrthi2i6)then 
       strcmt(1)='absorber n_device=[ab] mijk=po;sw;an [1]  1' 
       strcmt(2)='name of the absorber ' 
       strcmt(3)='number of layers of the absorber ' 
       strcmt(4)='distribution of parameters at sites of the layer' 
       strcmt(5)='theory/'//chth//'/absorber/layer' 
      else if(l_nfrtheo.eq.i3.or.l_nfrtheo.eq.i4)then 
       strcmt(1)='scatterer n_device=[sr] mijk=po;sw;an [1]  1' 
       strcmt(2)='name of the scatterer ' 
       strcmt(3)='number of layers of the scatterer ' 
       strcmt(4)='distribution of parameters at sites of the layer' 
       strcmt(5)='theory/'//chth//'/scatterer/layer' 
                                                                        
!      common/avfr1trf/avfr1,dumint,Hext,thetaHe,phiHe,phi,theta,psi    
!      If the theories: th_22nuclear.f, th_hyperfine.f are selected     
!      for the reemission program the common/avfr1trf/(3-8)             
!      has to be mapped onto common/avfr2trf/(6-11) for each layer,     
!      since these theories take the external field and the orientation 
!      from the layer parameter (allowing each layer having another     
!      external field and orientation - which make no sence for CEMS etc
                                                                        
       ntrmt(jm+1)='Hextern_dv   matrix=(3,3) include=[n]' 
       ctrmt(jm+1)=                                                     &
     &  'external magnetic field (lab) at all scatterer layers'         
        thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0' 
        thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+1)='Hext                     2    1 0 0  ' 
        thvr(jv+2)='thetaHe                  3    0 1 0 ' 
        thvr(jv+3)='phiHe                    4    0 0 1' 
        jm=jm+1 
        jp=jp+3 
        jv=jv+3 
       ntrmt(jm+1)='euler_dv  matrix=(3,3) include=[n]' 
       ctrmt(jm+1)='orientation of the scatterer (lab)' 
        thpa(jp+1)='phi_dv              , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='theta_dv            , 0.0 0.0 0.0   1.0' 
        thpa(jp+3)='psi_dv              , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+1)='phi_dv                       5    1 0 0  ' 
        thvr(jv+2)='theta_dv                     6    0 1 0 ' 
        thvr(jv+3)='psi_dv                       7    0 0 1' 
       jm=jm+1 
       jp=jp+3 
       jv=jv+3 
!                                                                       
      else if(l_nfrtheo.eq.i5)then 
       strcmt(1)='absorber n_device=[Mj] mij=l1;ln [1]  1' 
       strcmt(2)='name of the mosaic area section' 
       strcmt(3)='number of layers of the  mosaic area section' 
       strcmt(4)=                                                       &
     &       'distribution of parameters at sites of the area section'  
       strcmt(5)='theory/'//chth//'/mosaicabsorber/layer' 
                                                                        
                                                                        
       ntrmt(jm+1)='device_factor  intensity' 
       ctrmt(jm+1)='device factor for all sites of the device' 
        thpa(jp+1)='dev_factor           , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='dev_factor               1    1  ' 
        jm=jm+1 
        jp=jp+1 
        jv=jv+1 
       ntrmt(jm+1)='Hextern_dev   matrix=(3,3) include=[n]' 
       ctrmt(jm+1)='external magnetic field (lab) at the absorber' 
        thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0' 
        thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+1)='Hext                     2    1 0 0  ' 
        thvr(jv+2)='thetaHe                  3    0 1 0 ' 
        thvr(jv+3)='phiHe                    4    0 0 1' 
       jm=jm+1 
       jp=jp+3 
       jv=jv+3 
!                                                                       
      else if(l_nfrtheo.eq.i6)then 
       strcmt(1)='scatterer_layer n_device=[sr] mijk=po;sw;an [3]  1' 
       strcmt(2)='name of the scatterer' 
       strcmt(3)='number of layers of the scatterer ' 
       strcmt(4)='distribution of parameters at sites of the layer' 
       strcmt(5)='theory/'//chth//'/scatterer/layer' 
      end if 
                                                                        
      call conmatpar('___7',jc,jm,jp,jv,chth) 
                                                                        
      return 
!     --------------------------------------------                      
  210 continue 
!     layers of device absorber/scatterer  common/acfr2trf/  /avfr2trf/ 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
                                                                        
      thco(jc+1) ='temperature  i_pos=5 include=[n]  300.0 ' 
                ! temperatue of the layer                               
      jc=jc+1 
                                                                        
      if(l_nfrtheo.eq.i1.or.l_nfrtheo.eq.i3) then 
                                                                        
       if(l_nfrtheo.eq.i1) then 
        strcmt(1)='absorber_site   n_cmpt=s  [1]  1' 
        strcmt(2)='one letter for name of the site ' 
        strcmt(3)='number of inequivalent sites of the absorber layer' 
        strcmt(4)='distribution of parameters of site number' 
        strcmt(5)='theory/'//chth//'/absorber/layer/sites' 
       else if(l_nfrtheo.eq.i3) then 
        strcmt(1)='scatterer_site   n_cmpt=s  [1]  0' 
        strcmt(2)='one letter for name of the site ' 
        strcmt(3)='Number of inequivalent sites of the scatterer' 
        strcmt(4)='distribution of parameters of site number' 
        strcmt(5)='theory/'//chth//'/scatterer/sites' 
       end if 
                                                                        
                                                                        
       thco(jc+1)='iset_powder  i_pos=2 include=[n] 0 ' 
                ! iset=1-6 for 4-128 points on 1/48 of the sphere       
       thco(jc+2)='isymmetry   i_pos=3 include=[n] 10  ' 
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)          
       jc=jc+2 
                                                                        
!      l_nfrtheo=1,3 :'Mossbauer transmission_vA, reemission_vA'        
!                   call of subroutine th_hdeq                          
!      common/acfr2trf/acfr2                                            
!      common/avfr2trf/ avfr2,dum(5),Hext,thetaHe,phiHe,phi,theta,psi   
       ntrmt(jm+1)='thickn_factor matrix=(1,1) include=[n]' 
       ctrmt(jm+1)='thickness factor for all sites of the layer' 
        thpa(jp+1)='th_factor           , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='th_factor               1    1  ' 
                                                                        
       if(l_nfrtheo.eq.i3.or.l_nfrtheo.eq.i4.or.l_nfrtheo.eq.i5)then 
!        ntrmt(jm+2)='dummy  matrix=(1,1) from_data=y ' 
!        ctrmt(jm+2)='dummy ' 
!         thpa(jp+2)='dummy                0.0  0.0 0.0  0.0' 
!         thvr(jv+2)='dummy                    11    1  ' 
         jm=jm+1 
         jp=jp+1 
         jv=jv+1 
         layn='_5_11' 
!       reservation for 11 parameters on common/avfr2trf/               
       else 
        ntrmt(jm+2)='Hextern_layer   matrix=(3,3) include=[n]' 
        ctrmt(jm+2)='external magnetic field (lab) at the absorber' 
         thpa(jp+2)='Hext             , 0.0  0.0 0.0  1.0' 
         thpa(jp+3)='thetaHe          , 0.0 0.0 0.0   1.0' 
         thpa(jp+4)='phiHe            , 0.0 0.0 0.0   1.0 ' 
         thvr(jv+2)='Hext                     6    1 0 0  ' 
         thvr(jv+3)='thetaHe                  7    0 1 0 ' 
         thvr(jv+4)='phiHe                    8    0 0 1' 
                                                                        
        ntrmt(jm+3)='euler_layer    matrix=(3,3) include=[n]' 
        ctrmt(jm+3)='orientation of the absorber/scatterer (lab)' 
         thpa(jp+5)='phi              , 0.0  0.0 0.0  1.0' 
         thpa(jp+6)='theta            , 0.0 0.0 0.0   1.0' 
         thpa(jp+7)='psi              , 0.0 0.0 0.0   1.0 ' 
         thvr(jv+5)='phi                       9    1 0 0  ' 
         thvr(jv+6)='theta                    10    0 1 0 ' 
         thvr(jv+7)='psi                      11    0 0 1' 
        jm=jm+3 
        jp=jp+7 
        jv=jv+7 
       end if 
                                                                        
      else if(lfrthi2i6.or.l_nfrtheo.eq.i4.or.l_nfrtheo.eq.i5)then 
                                                                        
       if(lfrthi2i6) then 
        strcmt(1)='absorber_site   n_cmpt=[s] [1] 1' 
        strcmt(2)=' one letter for name of the site ' 
        strcmt(3)='number of inequivalent sites of the absorber layer' 
        strcmt(4)='distribution of parameters of site number' 
        strcmt(5)='theory/'//chth//'/absorber/layer/sites' 
       else if(l_nfrtheo.eq.i4) then 
        strcmt(1)='scatterer_site  n_cmpt=[s] [1] 0' 
        strcmt(2)=' one letter for name of the site ' 
        strcmt(3)='Number of inequivalent sites of the scatterer' 
        strcmt(4)='distribution of parameters of site number' 
        strcmt(5)='theory/'//chth//'/scatterer/sites' 
       else if(l_nfrtheo.eq.i5) then 
        strcmt(1)='mosaic_absorber_site   n_cmpt=[s] [1] 0' 
        strcmt(2)=' one letter for name of the site ' 
        strcmt(3)='number of inequivalent sites of the layer' 
        strcmt(4)='distribution of parameters of site number' 
        strcmt(5)='theory/'//chth//'/absorber/part/sites' 
       end if 
                                                                        
!      l_nfrtheo=2,4,5 :'Mossbauer transmission_vB, reemission_vB       
!                                  transmission_vC                      
!                   call of subroutine th_hdeqf                         
!      common/acfr2trf/acfr2,rep_grp,aset,asymmetry,a_psi,temperature   
!      common/avfr2trf/avfr2,th_factor,dum(4),Hext,thetaHe,phiHe,       
!                      phi,theta,psi                                    
                                                                        
       if(l_nfrtheo.ne.i5)then 
        thco(jc+1)='iset_powder  i_pos=2 include=[n] 0 ' 
                 ! iset=1-6 for 4-128 points on 1/48 of the sphere      
        thco(jc+2)='isymmetry   i_pos=3 include=[n] 10 ' 
                 ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)         
        thco(jc+3)='n_psi_powder i_pos=4 include=[n] 0 ' 
                ! 3rd Euler angle, rotation around S_lab(z)             
                ! neccessary if Hext not parallel S_lab(z)              
        jc=jc+3 
       end if 
                                                                        
       ntrmt(jm+1)='thickn_factor   matrix=(1,1) include=[n]' 
       ctrmt(jm+1)='thickness factor for all sites of the layer' 
        thpa(jp+1)='th_factor             , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='th_factor               1    1  ' 
                                                                        
       ntrmt(jm+2)='x2_anisotropy  matrix=(2,2) include=[y]' 
       ctrmt(jm+2)='mean square <x2> of a crystal of the scatterer layer'
       if(lfrthi2i6)&
        ctrmt(jm+2)='mean square <x2> of a crystal of the absorber layer'
        thpa(jp+2)='d_x2                  ,  0.0  0.0 0.0  0.1' 
        thpa(jp+3)='x2_eta                ,  0.0  0.0 0.0  0.1' 
        thvr(jv+2)='d_x2                     12    1 0  ' 
        thvr(jv+3)='x2_eta                   13    0 1  ' 
                                                                        
       ntrmt(jm+3)='x2_orientation  matrix=(3,3) include=[y]' 
       ctrmt(jm+3)='x2_orientation with ref. to a crystal (scatterer layer)'
       if(lfrthi2i6)&
       ctrmt(jm+3)='x2_orientation with ref. to a crystal (absorber layer)'
       thpa(jp+4)='x2_phi                , 0.0  0.0 0.0  1.0' 
       thpa(jp+5)='x2_theta              , 0.0  0.0 0.0  1.0' 
       thpa(jp+6)='x2_psi                , 0.0  0.0 0.0  1.0' 
       thvr(jv+4)='x2_phi                   14    1 0 0 ' 
       thvr(jv+5)='x2_theta                 15    0 1 0 ' 
       thvr(jv+6)='x2_psi                   16    0 0 1 ' 
                                                                        
       ntrmt(jm+4)='ax_texture   matrix=(2,2) include=[n]' 
       ctrmt(jm+4)='texture of the scatterer layer ' 
       if(lfrthi2i6)ctrmt(jm+4)='texture of the absorber layer' 
        thpa(jp+7)='t200                   , 0.0  0.0 0.0  0.1' 
        thpa(jp+8)='t400                   , 0.0  0.0 0.0  0.1' 
        thvr(jv+7)='t200                     17    1 0' 
        thvr(jv+8)='t400                     18    0 1 ' 
       jm=jm+4 
       jp=jp+8 
       jv=jv+8 
       if(l_nfrtheo.ne.i5)then 
        ntrmt(jm+1)='Hextern   matrix=(3,3) include=[n]' 
        ctrmt(jm+1)='external magnetic field (lab) at the scatterer layer'
        if(lfrthi2i6)&
         ctrmt(jm+1)='external magnetic field (lab) at the absorber layer'
         thpa(jp+1)='Hext             , 0.0  0.0 0.0   1.0' 
         thpa(jp+2)='thetaHe          , 0.0  0.0 0.0   1.0' 
         thpa(jp+3)='phiHe            , 0.0  0.0 0.0   1.0 ' 
         thvr(jv+1)='Hext                     6    1 0 0  ' 
         thvr(jv+2)='thetaHe                  7    0 1 0 ' 
         thvr(jv+3)='phiHe                    8    0 0 1' 
        jm=jm+1 
        jp=jp+3 
        jv=jv+3 
       end if 
                                                                        
      else if(l_nfrtheo.eq.i7) then 
                                                                        
       strcmt(1)='scatterer_site   n_cmpt=[s] [1]  0' 
       strcmt(2)='one letter for name of the site ' 
       strcmt(3)='number of inequivalent sites of the scatterer layer' 
       strcmt(4)='distribution of parameters of site number' 
       strcmt(5)='theory/'//chth//'/scatterer/layer/sites' 
                                                                        
       thco(jc+1)='rep.grp    i_pos=1 include=[n] 1.1 ' 
                ! layer belongs to a group which repeat with period     
       jc=jc+1 
                                                                        
       ntrmt(jm+1)='Hextern   matrix=(3,3) include=[n]' 
       ctrmt(jm+1)='external magnetic field (lab) at the scatterer' 
        thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0' 
        thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+1)='Hext                     6    1 0 0  ' 
        thvr(jv+2)='thetaHe                  7    0 1 0 ' 
        thvr(jv+3)='phiHe                    8    0 0 1' 
                                                                        
       ntrmt(jm+2)='rotation    matrix=(3,3) include=[n]' 
       ctrmt(jm+2)='rotation of the scatterer surface' 
        thpa(jp+4)='phi              , 0.0  0.0 0.0  1.0' 
        thvr(jv+4)='phi                     9    1 0 0  ' 
                                                                        
       ntrmt(jm+3)='thickn_lay  matrix=(1,1) include=y' 
       ctrmt(jm+3)='thickness of the layer' 
        thpa(jp+5)='thicklay        , 1.0  0.0 0.0  0.1' 
        thvr(jv+5)='thicklay                1    1  ' 
!              0         012345                                         
                                                                        
       ntrmt(jm+4)='r_chi_electronic   matrix=(1,1) include=y' 
       ctrmt(jm+4)='real part of chi_electronic of the layer  ' 
        thpa(jp+6)='r_chilay        , 0.0  0.0 0.0  0.1' 
        thvr(jv+6)='r_chilay                2    1 ' 
                                                                        
       ntrmt(jm+5)='i_chi_electronic  matrix=(1,1) include=y' 
       ctrmt(jm+5)='imaginary part of chi_electronic of the layer' 
        thpa(jp+7) ='i_chilay        , 0.0  0.0 0.0  0.1' 
        thvr(jv+7) ='i_chilay                3    1' 
                                                                        
       ntrmt(jm+6)='roughness   matrix=(1,1) include=[n]' 
       ctrmt(jm+6)='roughness of the layer  ' 
        thpa(jp+8)='roughness        , 0.0  0.0 0.0  0.1' 
        thvr(jv+8)='roughness               4    1 ' 
       jm=jm+6 
       jp=jp+8 
       jv=jv+8 
      end if 
                                                                        
      call conmatpar(layn,jc,jm,jp,jv,chth) 
                                                                        
      return 
!--------------------------------------------------------------------   
!      common/avfr1trf/pvfr1,Hext,thetaHe,phiHe                         
!      device number 3:detector                                         
  300 if(lstruct2.gt.0) goto 310 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
                                                                        
      strcmt(1)='detector_layer  n_device=[dt]   1 1' 
      strcmt(2)='name of the detector layer' 
      strcmt(3)=' ' 
      strcmt(3)=' ' 
      strcmt(5)='theory/'//chth//'/detector/layer' 
                                                                        
      call conmatpar('dev3',jc,jm,jp,jv,chth) 
       return 
!-----------------------------------------------------------------------
  310 continue 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
                                                                        
      strcmt(1)='detector_site   n_cmpt=[s] [1] 1' 
      strcmt(2)=' one letter for name of the site ' 
      strcmt(3)='number of inequivalent sites of the detector' 
      strcmt(4)='distribution of parameters of site number' 
      strcmt(5)='theory/'//chth//'/detector/sites' 
                                                                        
      ntrmt(jm+1)='Hextern_dt  matrix=(3,3)   include=[n]' 
      ctrmt(jm+1)='external magnetic field (lab) at the detector' 
       thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0' 
       thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0' 
       thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 ' 
       thvr(jv+1)='Hext                    6     1 0 0 ' 
       thvr(jv+2)='thetaHe                 7     0 1 0 ' 
       thvr(jv+3)='phiHe                   8     0 0 1 ' 
      jm=jm+1 
      jp=jp+3 
      jv=jv+3 
                                                                        
      call conmatpar('___8',jc,jm,jp,jv,chth) 
      return 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
      subroutine thstr_mossbauer(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission and   Mossbauer resonance reflection theori
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      integer   jc,jm,jp,jv 
      logical   name_eq_ntheo                                                                         
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='Mossbauer radioactive source (distribute)' 
!      names for child theories, sequence l_frtheo=1,2,3,.. , mthchild=6
       nameth(1)  ='Mossbauer transmission_vA' 
       nameth(2)  ='Mossbauer transmission_vB' 
       nameth(5)  ='Mossbauer reemission_vA' 
       nameth(6)  ='Mossbauer reemission_vB' 
       nameth(3)  ='Mossbauer transmission_vC' 
       nameth(4)  ='Mossbauer transmission_vD' 
!      nameth(7)  ='Mossbauer resonance reflection'                     
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory, mthparent=1 <=max_nth                          
       ntheory(1)='Mossbauer radioactive source' 
                                        ! mthparent=1,mthchild=6        
       if(name_eq_ntheo(1))l_jth=6 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
                                                                        
!   common/acstrf/acsp,uthick_w,dum,flag_basis,unit_chi,channels,vm_SC,c
!  &              th_dum,drive_mode,channels_vmax,flag_misfit,          
!  &              om_samp,Dsource,Dabsorber,                            
!  &              sc2absorber,sc2aperture,dumcs(icstrf-17)              
                                                                        
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
                                                                        
      thco(jc+1)='vm_SC   i_pos=5  include=y     0.0' 
!               ! value of source splitting'                            
!                 >0  gt absorber splitting                             
!                 =0  single line source                                
!                 <0  lt absorber splitting                             
                                                                        
      thco(jc+2)='i_convol  i_pos=6  include=y  128' 
                  ! limits of convolution integrals +/- 128             
                                                                        
      thco(jc+3)='nu_channels    i_pos=4   from_data=y  1024 ' 
                ! channel number of the spectrum                        
      thco(jc+4)='channels_vmax  i_pos=9 from_data=[y]  256 ' 
                ! period of the drive unit                              
      thco(jc+5)='drive_mode     i_pos=8 from_data=[y]  1 ' 
                ! determines function for channel to velocity scale     
      thco(jc+6)=' flag_misfit    i_pos=10  include=y  0' 
                ! determines function for channel to velocity scale     
      jc=jc+6 
      if(l_jth.eq.7) then 
       thco(jc+1)='unit_chi    i_pos=3  include=y  1.0e-6 ' 
                ! susceptibility multiplied by                          
       thco(jc+2)='flag_basis  i_pos=2   1 ' 
                ! 1/0 : circular/linear basis                           
       jc=jc+2 
      end if 
                                                                        
!-----------------------------------------------------------------------
!     variables of frame theory: source,absorber and detector orientatio
!      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,              
!     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,            
!     &        Daperture,d_absorber,d_source                            
                                                                        
      ntrmt(jm+1)='baseline  matrix=(1,1) include=y ' 
      ctrmt(jm+1)='(1) parameter base line ' 
       thpa(jp+1)='base            , 100000.0  0.0 0.0 10.0' 
       thvr(jv+1)='base                    2    , 1 ' 
                                                                        
      ntrmt(jm+2)='source   matrix=(1,1) from_data=[n] ' 
      ctrmt(jm+2)='(1) parameter f_factor of the source' 
       thpa(jp+2)='f_source        , 0.70  0.0  1.0  0.02' 
       thvr(jv+2)='f_source                1    , 1  ' 
                                                                        
      ntrmt(jm+3)='background   matrix=(1,1) from_data=[n] ' 
      ctrmt(jm+3)='(1) parameter back ground fraction of the source' 
       thpa(jp+3)='bg_fraction     , 0.2  0.0  1.0  0.01' 
       thvr(jv+3)='bg_fraction             3    , 1 ' 
                                                                        
      ntrmt(jm+4)='geometry  matrix=(1,1) from_data=[n] ' 
      ctrmt(jm+4)='(1) parameter geo=v_max**2/2bF' 
       thpa(jp+4)='geo              ,  0.000e-4   0.0 0.0 0.1' 
       thvr(jv+4)='geo              ,      12     , 1 ' 
      jm=jm+4 
      jp=jp+4 
      jv=jv+4 
      ntrmt(jm+1)='calibration  matrix=(2,2) from_data=[n] ' 
      ctrmt(jm+1)='(2) parameters for calibration v_max,channel_v0' 
       thpa(jp+1)='v_max             ,  8.0   0.0 0.0 0.05 ' 
       thpa(jp+2)='channel_v0        , 256.0  0.0 0.0 0.1 ' 
       thvr(jv+1)='v_max                   4     , 1 0' 
       thvr(jv+2)='channel_v0              5     , 0 1 ' 
                                                                        
      ntrmt(jm+2)='non_linearity  matrix=(6,6) include=[n]' 
      ctrmt(jm+2)='(4) non linearity parameters for calibration' 
       thpa(jp+3)='vcos1             0.0000   0.0 0.0 0.01 ' 
       thpa(jp+4)='phase1            256.00  0.0 0.0 1.0 ' 
       thpa(jp+5)='vcos2             0.0000   0.0 0.0 0.01 ' 
       thpa(jp+6)='phase2            256.00  0.0 0.0 1.0 ' 
       thpa(jp+7)='vcos3             0.0000  0.0 0.0 0.01 ' 
       thpa(jp+8)='phase3            256.00  0.0 0.0 1.0 ' 
       thvr(jv+3)='vcos1                6     1 0 0 0 0 0' 
       thvr(jv+4)='phase1               7     0 1 0 0 0 0 ' 
       thvr(jv+5)='vcos2                8     0 0 1 0 0 0 ' 
       thvr(jv+6)='phase2               9     0 0 0 1 0 0 ' 
       thvr(jv+7)='vcos3                10    0 0 0 0 1 0  ' 
       thvr(jv+8)='phase3               11    0 0 0 0 0 1  ' 
      jm=jm+2 
      jp=jp+8 
      jv=jv+8 
      call conmatpar('__12',jc,jm,jp,jv,chth) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine thstr_11indexmoss(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission , powder, anisotropic f-factor             
!     level 3 theory                                                    
                                                                        
!     sad= source,absorber,detector : lstr1case=1,2,3                   
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      integer   jc,jm,jp,jv 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='scalar refraction index (sad)' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='scalar refraction index (static,sad)' 
       namepg(1)='1x1_ref_index_static_sad  scal,1 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=5 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vA_3' 
       ntheory(2)='Mossbauer transmission_vB_3' 
       ntheory(3)='Mossbauer reemission_vA_3' 
       ntheory(4)='Mossbauer reemission_vB_3' 
       ntheory(5)='Mossbauer transmission_vC_3' 
                                                                        
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(5))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=3   chth='//chth 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
      thco(jc+1)='flag_SAMP     i_pos=1   include=y  1' 
               ! discrete (1) , continuous(0) LG-curves                 
      thco(jc+2)='flag_Voigt    i_pos=2   include=y  0' 
                ! LG-convolution (1) , Voigt profile (0)                
      jc=jc+2 
                                                                        
      ntrmt(jm+1)='t_eff  intensity     ' 
      ctrmt(jm+1)='effective thickness by the f-factor at the site' 
       thpa(jp+1)='mg/cm2xf          , 1.0  0.0 0.0  0.1' 
       thvr(jv+1)='mg/cm2xf                 1     1  ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
      if(l_jth.eq.1) then 
       ntrmt(jm+1)='isomer_shift  matrix=(1,1)   include=y' 
       ctrmt(jm+1)='isomer shift of the spectrum' 
        thpa(jp+1)='shift            , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='shift                   2     1 ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
      end if 
      call conmatpar('layn',jc,jm,jp,jv,chth) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine thstr_11indexmossdyn(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission , powder, anisotropic f-factor             
!     level 3 theory                                                    
                                                                        
!     sad= source,absorber,detector : lstr1case=1,2,3                   
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      integer   jc,jm,jp,jv 
      logical   name_eq_ntheo 

      if(cmch.eq.'name')then 
       nhelpentry='scalar refraction index (dynamic)' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='scalar refraction index (dynamic,sad-interpol.)' 
       namepg(1)='1x1_ref_index_dynamic_sad  scal,1 ' 
       nameth(2)='scalar refraction index (dynamic,sad)' 
       namepg(2)='1x1_ref_index_dynamic_sad  scal,2 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=5 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vA_3b' 
       ntheory(2)='Mossbauer transmission_vB_3b' 
       ntheory(3)='Mossbauer reemission_vA_3' 
       ntheory(4)='Mossbauer reemission_vB_3' 
       ntheory(5)='Mossbauer transmission_vC_3b' 
                                                                        
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(5))l_jth=2 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
      thco(jc+1)='flag_SAMP     i_pos=1   include=y  1' 
               ! discrete (1) , continuous(0) LG-curves                 
      thco(jc+2)='flag_Voigt    i_pos=2   include=y  0' 
                ! LG-convolution (1) , Voigt profile (0)                
      jc=jc+2 
                                                                        
      ntrmt(jm+1)='t_eff  intensity     ' 
      ctrmt(jm+1)='effective thickness by the f-factor at the site' 
       thpa(jp+1)='mg/cm2xf          , 1.0  0.0 0.0  0.1' 
       thvr(jv+1)='mg/cm2xf                 1     1  ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
      if(l_jth.eq.1) then 
       ntrmt(jm+1)='isomer_shift  matrix=(1,1)   include=y' 
       ctrmt(jm+1)='isomer shift of the spectrum' 
        thpa(jp+1)='shift            , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='shift                   2     1 ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
      end if 
      call conmatpar('layn',jc,jm,jp,jv,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_11indexMB(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission , powder, anisotropic f-factor             
!     level 3 theory                                                    
                                                                        
!     sad= source,absorber,detector : lstr1case=1,2,3                   
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      integer   jc,jm,jp,jv 
      logical   name_eq_ntheo                                                                        
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='scalar refraction index MB' 
                                                                        
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='scalar refraction index (static,sad)' 
       namepg(1)='1x1_ref_index_static_sad  scal,1 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=1 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vD_3' 
                                                                        
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       if(l_jth.eq.1) then 
        nstruct='handbook=nucleus.hdb   list=3   chth='//chth 
!       2 constants                                                     
       else 
        nstruct=' ' 
       end if 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
       thco(jc+1)='flag_SAMP   i_pos=1   include=y  1' 
                 ! discrete (1) , continuous(0) LG-curves               
       thco(jc+2)='flag_Voigt  i_pos=2   include=y  0' 
                 ! LG-convolution (1) , Voigt profile (0)               
       jc=jc+2 
                                                                        
      ntrmt(jm+1)='t_eff   intensity ' 
      ctrmt(jm+1)='effective thickness by the f-factor at the site' 
       thpa(jp+1)='mg/cm2xf          , 1.0  0.0 0.0  0.1' 
       thvr(jv+1)='mg/cm2xf                 1     1  ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
      if(l_jth.eq.1) then 
       ntrmt(jm+1)='isomer_shift    matrix=(1,1)   include=y' 
       ctrmt(jm+1)='isomer shift of the spectrum' 
        thpa(jp+1)='shift            , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='shift                   2     1 ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
      end if 
      call conmatpar('layn',jc,jm,jp,jv,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_22indexmoss(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission and   Mossbauer resonance reflection theori
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      integer   jc,jm,jp,jv 
      logical   name_eq_ntheo                                                                         
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='2x2 refraction index (sad)' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='2x2 refraction index (static,sad)' 
       namepg(1)='2x2_ref_index_static_sad plrs,1 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=5 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vA_3b' 
       ntheory(2)='Mossbauer transmission_vB_3b' 
       ntheory(3)='Mossbauer reemission_vA_3' 
       ntheory(4)='Mossbauer reemission_vB_3' 
       ntheory(5)='Mossbauer transmission_vC_3b' 
!      ntheory(6)='Mossbauer resonance reflection_3'                    
                                                                        
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(5))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=3   chth='//chth 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
                                                                        
       thco(jc+1)='flag_SAMP        i_pos=1  include=y   1 ' 
                 ! discrete (1) , continuous(0) LG-curves               
       thco(jc+2)='flag_Voigt       i_pos=2  include=y   0' 
                 ! LG-convolution (1) , Voigt profile (0)               
       jc=jc+2 
                                                                        
!                     123456789012345678901234567                       
       ntrmt(jm+1)='t_eff   intensity' 
       ctrmt(jm+1)='effective thickness by the f-factor at the site' 
        thpa(jp+1)='mg/cm2xf         , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='mg/cm2xf                1     1  ' 
                                                                        
       ntrmt(jm+2)='position  matrix=(1,1)   include=y' 
       ctrmt(jm+2)='position of the spectrum' 
        thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1' 
        thvr(jv+2)='is_shift                2    1  ' 
       jm=jm+2 
       jp=jp+2 
       jv=jv+2
       ntrmt(jm+1)='broadening  matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='broadening of the lines of the spectrum' 
        thpa(jp+1)='G_width          , 0.0  0.0 0.0  0.1' 
        thpa(jp+2)='L_width          , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='G_width                 3      1 0 ' 
        thvr(jv+2)='L_width                 4      0 1 ' 
       jm=jm+1 
       jp=jp+2 
       jv=jv+2
      call conmatpar('___4',jc,jm,jp,jv,chth) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine thstr_22indexfmoss(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission , powder, anisotropic f-factor             
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      integer   jc,jm,jp,jv 
      logical   name_eq_ntheo 

      if(cmch.eq.'name')then 
       nhelpentry='2x2 refraction index_f (sad)' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='2x2 refraction index (static,f_anisotrop,sad)' 
       namepg(1)='2x2_ref_index_static_sad plrs,1 ' 
       nameth(2)='2x2 refraction index (Lwidth,f_anisotrop,sad)' 
       namepg(2)='2x2_ref_index_static_sad plrs,2 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=3 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vB_3b' 
       ntheory(2)='Mossbauer reemission_vB_3' 
       ntheory(3)='Mossbauer transmission_vC_3b' 
       if(name_eq_ntheo(3))l_jth=2      !mthparent=3,mthchild=1
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
      thco(jc+1)='flag_SAMP  i_pos=1  include=y  1 ' 
                 ! discrete (1) , continuous(0) LG-curves               
      thco(jc+2)='flag_Voigt  i_pos=2    include=y  0 ' 
                 ! LG-convolution (1) , Voigt profile (0)               
      jc=jc+2 
                                                                        
      ntrmt(jm+1)='t_eff  intensity' 
      ctrmt(jm+1)='effective thickness by the f-factor at the site' 
       thpa(jp+1)='mg/cm2xf         , 1.0  0.0 0.0  0.1' 
       thvr(jv+1)='mg/cm2xf                 1     1  ' 
                                                                        
      ntrmt(jm+2)='position  matrix=(1,1)   include=y' 
      ctrmt(jm+2)='position of the spectrum' 
       thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1' 
       thvr(jv+2)='is_shift                 2    1  ' 
       jm=jm+2 
       jp=jp+2 
       jv=jv+2

      if(l_jth.eq.1)then                                                                       
       ntrmt(jm+1)='broadening  matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='broadening of the lines of the spectrum' 
        thpa(jp+1)='G_width          , 0.0  0.0 0.0  0.1' 
        thpa(jp+2)='L_width          , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='G_width                 3      1 0 ' 
        thvr(jv+2)='L_width                 4      0 1 ' 
       jm=jm+1 
       jp=jp+2 
       jv=jv+2
      else if(l_jth.eq.2)then 

       thco(jc+1)='ioffset         i_pos=3  include=y   0' 
                 ! if more then 8 lines > L(ioffset),...,L(ioffset-1)               
       jc=jc+1 
       ntrmt(jm+1)='broadening  matrix=(1,1)   include=[n]' 
       ctrmt(jm+1)='Gauss broadening of all  lines of the spectrum' 
        thpa(jp+1)='G_width            , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='G_width                 3  1 ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1

       ntrmt(jm+1)='broadening  matrix=(8,8)   include=[n]' 
       ctrmt(jm+1)='Lorentz broadening of 8  lines of the spectrum' 
        thpa(jp+1)='L_width_1          , 0.0  0.0 0.0  0.1' 
        thpa(jp+2)='L_width_2          , 0.0  0.0 0.0  0.1' 
        thpa(jp+3)='L_width_3          , 0.0  0.0 0.0  0.1' 
        thpa(jp+4)='L_width_4          , 0.0  0.0 0.0  0.1' 
        thpa(jp+5)='L_width_5          , 0.0  0.0 0.0  0.1' 
        thpa(jp+6)='L_width_6          , 0.0  0.0 0.0  0.1' 
        thpa(jp+7)='L_width_7          , 0.0  0.0 0.0  0.1' 
        thpa(jp+8)='L_width_8          , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='L_width_1            4  1 0 0 0 0 0 0 0' 
        thvr(jv+2)='L_width_2            5  0 1 0 0 0 0 0 0' 
        thvr(jv+3)='L_width_3            6  0 0 1 0 0 0 0 0' 
        thvr(jv+4)='L_width_4            7  0 0 0 1 0 0 0 0' 
        thvr(jv+5)='L_width_5            8  0 0 0 0 1 0 0 0' 
        thvr(jv+6)='L_width_6            9  0 0 0 0 0 1 0 0' 
        thvr(jv+7)='L_width_7           10  0 0 0 0 0 0 1 0' 
        thvr(jv+8)='L_width_8           11  0 0 0 0 0 0 0 1' 
       jm=jm+1 
       jp=jp+8 
       jv=jv+8
      end if    
      call conmatpar('__11',jc,jm,jp,jv,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_22indexMB(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission , powder, anisotropic f-factor             
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      integer   jc,jm,jp,jv 
      logical   name_eq_ntheo                                                                         
                                                                          
      if(cmch.eq.'name')then 
       nhelpentry='2x2 refraction index MB' 
                                                                        
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='2x2 refraction index (static,sad)' 
       namepg(1)='2x2_ref_index_static_sad plrs,1 ' 
       nameth(2)='2x2 refraction index (f,t,spinham,sad)' 
       namepg(2)='2x2_ref_index_static_sad plrs,1 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=1 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vD_3b' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=2 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
                                                                        
       thco(jc+1)='flag_SAMP   i_pos=1    include=y  1 ' 
                 ! discrete (1) , continuous(0) LG-curves               
       thco(jc+2)='flag_Voigt  i_pos=2    include=y  0 ' 
                 ! LG-convolution (1) , Voigt profile (0)               
       jc=jc+2 
                                                                        
!                     123456789012345678901234567                       
       ntrmt(jm+1)='t_eff    intensity' 
       ctrmt(jm+1)='effective thickness by the f-factor at the site' 
        thpa(jp+1)='mg/cm2xf         , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='mg/cm2xf                 1     1  ' 
                                                                        
       ntrmt(jm+2)='position   matrix=(1,1)   include=y' 
       ctrmt(jm+2)='position of the spectrum' 
        thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1' 
        thvr(jv+2)='is_shift                 2    1  ' 
                                                                        
       ntrmt(jm+3)='broadening  matrix=(2,2)   include=[n]' 
       ctrmt(jm+3)='broadening of the lines of the spectrum' 
        thpa(jp+3)='G_width          , 0.0  0.0 0.0  0.1' 
        thpa(jp+4)='L_width          , 0.0  0.0 0.0  0.1' 
        thvr(jv+3)='G_width                  3      1 0 ' 
        thvr(jv+4)='L_width                  4      0 1 ' 
       jm=jm+3 
       jp=jp+4 
       jv=jv+4 
       call conmatpar('___4',jc,jm,jp,jv,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_sampleorient(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission                                            
!     level 2 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      integer   jc,jm,jp,jv,i,i0 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='sample orientation' 
                                                                        
!      names for child theories , mthchild=5 <= max_nth                 
       nameth(1)='nocall (angle(sample)=0)' 
       namepg(1)='sample_orientation    nono,1 ' 
       nameth(2)='sample orient.(rot-axis)' 
       namepg(2)='sample_orientation    nono,2 ' 
       nameth(3)='sample orient.(rot-axis & thickness)' 
       namepg(3)='sample_orientation    nono,3 ' 
       nameth(4)='sample orient.(x,z-axis)' 
       namepg(4)='sample_orientation    nono,4 ' 
       nameth(5)='sample orient.(x,z-axis & thickness)' 
       namepg(5)='sample_orientation    nono,5 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=3 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vB_2' 
       ntheory(2)='Mossbauer transmission_vC_1' 
       ntheory(3)='Mossbauer transmission_vD_2' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(3))l_jth=5 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
                                                                        
      if(l_jth.eq.2.or.l_jth.eq.3) then 
       ntrmt(jm+1)='orient_euler   matrix=(3,3)   include=y' 
       ctrmt(jm+1)='orientation of the sample in the lab' 
        thpa(jp+1)='phi                  , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='theta                , 0.0  0.0 0.0  1.0' 
        thpa(jp+3)='psi                  , 0.0  0.0 0.0  1.0' 
        thvr(jv+1)='phi                      1    1 0 0 ' 
        thvr(jv+2)='theta                    2    0 1 0 ' 
        thvr(jv+3)='psi                      3    0 0 1 ' 
                                                                        
       ntrmt(jm+2)='rotation  matrix=(3,3)   include=[y]' 
       ctrmt(jm+2)='rotation axes in the lab system, rot.angle' 
        thpa(jp+4)='axtheta               , 0.0  0.0 0.0  0.1' 
        thpa(jp+5)='axphi                 , 0.0  0.0 0.0  0.1' 
        thpa(jp+6)='omega                 , 0.0  0.0 0.0  0.1' 
        thvr(jv+4)='axtheta                  4    1 0 0 ' 
        thvr(jv+5)='axphi                    5    0 1 0 ' 
        thvr(jv+6)='omega                    6    0 0 1 ' 
       jm=jm+2 
       jp=jp+6 
       jv=jv+6 
                                                                        
      else if(l_jth.gt.3)then 
       do i=1,6 
        ntrmt(jm+1)='dum matrix=(1,1) include= n' 
        thvr(jv+1)='dumvr            '//char(i0+i)//'     , 1' 
        thpa(jp+1)='dumpa                , 0.0  0.0 0.0  1.0' 
        jm=jm+1 
        jp=jp+1 
        jv=jv+1 
       end do 
       ntrmt(jm+1)='orientation_x,z  matrix=(4,4)   include=y' 
       ctrmt(jm+1)='x,z orientation of the sample in the lab' 
        thpa(jp+1)='x_theta              , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='x_phi                , 0.0  0.0 0.0  1.0' 
        thpa(jp+3)='z_theta              , 0.0  0.0 0.0  1.0' 
        thpa(jp+4)='z_phi                , 0.0  0.0 0.0 1.0' 
        thvr(jv+1)='x_theta                  7    1 0 0 0 ' 
        thvr(jv+2)='x_phi                    8    0 1 0 0 ' 
        thvr(jv+3)='z_theta                  9    0 0 1 0 ' 
        thvr(jv+4)='z_phi                    10   0 0 0 1 ' 
       jm=jm+1 
       jp=jp+4 
       jv=jv+4 
      end if 
                                                                        
      call conmatpar('___6',jc,jm,jp,jv,chth) 
      return 
      END                                           
                                                                        
      subroutine thstr_aperture(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none

      integer,intent(out):: l_jth
      character(len=4),   intent(inout)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      integer   jc,jm,jp,jv,i,i0 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='Mossbauer geometry' 
!      names for child theories , mthchild=4 <= max_nth                 
       nameth(1)='source-absorber distance=large' 
       nameth(2)='cos smearing & aperture effect' 
       nameth(3)='extended source' 
       nameth(4)='missalignment: point source-absorber-detector' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=6 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vA_0' 
       ntheory(2)='Mossbauer transmission_vB_0' 
       ntheory(3)='Mossbauer reemission_vA_0' 
       ntheory(4)='Mossbauer reemission_vB_0' 
       ntheory(5)='Mossbauer transmission_vC_0' 
       ntheory(6)='Mossbauer transmission_vD_0' 
                                                                        
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(6))l_jth=4 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
!     geometry effects are only calculated if N_om_samp > 0             
!     if source-absorber distance=larg : l_jth=1 the value              
!     om_samp=0 taken from                                              
!     common/acstrf/acsp,uthick_w,dum,flag_basis,unit_chi,channels,     
!     &              vm_SC,convol,th_dum,drive_mode,channels_vmax,      
!     &              flag_misfit,om_samp,dumcs(icstrf-13)               
!     has to be ensured. this can be done defining                      
!     'N_om_samp i_pos=1  include= n  0 '                               
                                                                        
      call conmatpar('coll',jc,jm,jp,jv,chth) 
                                                                        
      if(l_jth.eq.1)then 
       i0=ichar('0') 
       do i=1,5 
        thco(jc+1)='N_om_samp i_pos='//char(i0+i)//'  include= n  5 ' 
        jc=jc+1 
       end do 
      else 
!      common/acstrf/acsp,uthick_w,dum,flag_basis,unit_chi,channels,vm_S
!     &              th_dum,drive_mode,channels_vmax,yflag_misfit,      
!     &              om_samp,dsource,dabsorber,                         
!     &              sc2absorber,sc2aperture                            
                                                                        
                                                                        
       thco(jc+1)='N_om_samp i_pos=1  include= [y]  0 ' 
                ! determines function for channel to velocity scale     
       thco(jc+2)='sc-aperture i_pos=5  from_data=[n]  10.0 ' 
                ! distance source to aperture/detector                  
       thco(jc+3)='Dabsorber   i_pos=3  from_data=[n]  2.0 ' 
                 ! diameter of the absorber                             
       thco(jc+4)='sc-absorber i_pos=4  from_data=[n]  5.0 ' 
                ! distance source to absorber                           
       jc=jc+4 
       if(l_jth.eq.3) then 
        thco(jc+1)='Dsource  i_pos=2  from_data=n  0.1 ' 
                ! diameter of the source (point source 0.0)             
       else 
        thco(jc+1)='Dsource      i_pos=2  include= n  0.0 ' 
       end if 
       jc=jc+1 
                                                                        
                                                                        
!     variables of frame theory: source,absorber and detector orientatio
!      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,              
!     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,            
!     &        Daperture,d_absorber,d_source                            
                                                                        
!                    1                  012345                          
       ntrmt(jm+1)='Daperture matrix=(1,1) from_data=[y]' 
       ctrmt(jm+1)='(1) diameter Daperture of the detector' 
        thpa(jp+1)='Daperture           2.00  0.0 0.0 0.1' 
        thvr(jv+1)='Daperture               1     , 1' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
                                                                        
       ntrmt(jm+1)='misalign   matrix=(2,2) from_data=[y]' 
       ctrmt(jm+1)='(2) misalignmernt of absorber/source' 
        thpa(jp+1)='d_absorber          0.00  0.0 0.0 0.1' 
        thpa(jp+2)='d_source            0.00  0.0 0.0 0.1' 
        thvr(jv+1)='d_absorber               2     , 1 0' 
        thvr(jv+2)='d_source                 3     , 0 1' 
       jm=jm+1 
       jp=jp+2 
       jv=jv+2 
      end if 
      call conmatpar('___3',jc,jm,jp,jv,chth) 
                                                                        
      return 
      END                                           
