      subroutine cLORGAU(gamnat,e_xsi,srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,ipLG,ipos)
      use glbconst, only: maxscrd
      use comthe, only: mGa,array_fr
      implicit none 
!     calculation of the Lorentz-Gauss functions                        
      real,    intent(in) :: gamnat,e_xsi,srw8,w_Lorentz,w_Gauss 
      integer, intent(in) :: nLG,iflag_Voigt,ipLG
      integer, intent(out):: ipos 
                                                                        
      real     gauss,dumscrd
      integer, parameter:: idumscrd=maxscrd-(mGa+2) 
      common/scrd/gauss(0:mGa+1),dumscrd(idumscrd) 

      integer  ipLG_6,iposLor,iposGau,i,ibg,j,ij,n
      logical  b_Lorentz,b_Gauss,b_gamnat,b_xsi,b_srw8,b_nLG,            &
               b_Gaussgt0,b_flag_Voigt,b_com,b_ipos,b_iposLor            

      real     w_aLorentz,w_aGauss,wpi,dxc,xc,yc,vxy,dvxy,              &
               halpda1,halpda2,hbeta1,hbeta2,beta1,beta2,beta3,beta4,   &
               alpha1,alpha2,alpha3,alpha4,widthg,widthl2,width2,       &
               disp,hp,h0,h1                                            
      real, parameter:: a1=-1.2150,a2=-1.3509,b1= 1.2359,b2= 0.3786,    &
                        c1=-0.3085,c2= 0.5906,d1= 0.0210,d2=-1.1858,    &
                        d12=0.0105,d22=-0.5928,wln2=0.832554611
      complex  hc,hc1,hxsi 
                                                                        
!      write(6,'(2a,/,2l5,4f10.3,5i6)') 'cLORGAU b_Lorentz,b_Gauss,',   
!     & 'gamnat,w_Lorentz,w_Gauss,srw8,iflag_Voigt,nLG,nstorFR,ipLG',   
!     & b_Lorentz,b_Gauss,gamnat,w_Lorentz,w_Gauss,srw8,                
!     & iflag_Voigt,nLG,iarray_sp+nstorFR,ipLG                          
                                                                        
      ipLG_6=ipLG+6 
      iposLor=ipLG_6+(nLG+1) 
      h0=gamnat/100. 
      h1=h0/100. 
      b_gamnat =abs(gamnat-real(array_fr(ipLG+1))).lt.h0 
      b_xsi    =abs(e_xsi-aimag(array_fr(ipLG+1))).lt.h0 
      b_Lorentz=abs(w_Lorentz-real(array_fr(ipLG+2))).lt.h0 
      b_Gauss  =abs(w_Gauss-aimag(array_fr(ipLG+2))).lt.h0 
      b_srw8   =abs(srw8-real(array_fr(ipLG+3))).lt.h1 
      b_nLG    =nLG  .eq.int(aimag(array_fr(ipLG+3))+0.01) 
      b_com=b_gamnat.and.b_xsi.and.b_Lorentz.and.b_Gauss.and.b_srw8.and.b_nLG
!         write(6,'(a,6f15.6)')' w_Lorentz,w_Gauss=',                   
!     &     array_fr(ipLG+2),w_Lorentz,w_Gauss                          
!         write(6,'(a,8L4)')'b_gamnat...=',                             
!     &     b_gamnat,b_xsi,b_Lorentz,b_srw8,b_nLG                       
                                                                        
      b_flag_Voigt=iflag_Voigt.eq.int(aimag(array_fr(ipLG+4))+0.01) 
      b_ipos=ipLG_6.eq.int(real(array_fr(ipLG+4))+0.01) 
      b_iposLor=iposLor.eq.int(real(array_fr(ipLG+5))+0.01) 
                                                                        
      w_aLorentz=abs(w_Lorentz)+1. 
      w_aGauss=abs(w_Gauss) 
      b_Gaussgt0=w_aGauss.gt.0.01 
                                                                        
!     if(iflag_Voigt.eq.1)  changed to eq.0, such that missing definitio
!     of iflag_Voigt (=0) leads to the approximation and not to time    
!     consuming integration                                             
      if(iflag_Voigt.eq.0)then 
       if(b_Gaussgt0)then 
        ipos=ipLG_6 
        if(.not.(b_com.and.b_flag_Voigt.and.b_ipos)) then 
!        Voigt profile according to A.B. McLean, C.E.J. Mitchell and    
!        D.M. Swantston, J.Electron Spectroscopy 69(1994)125-132        
!         write(6,'(a)')' iflag_Voigt.eq.0 &  b_Gaussgt0'               
         wpi=1.772453851/w_aLorentz 
         hxsi=cmplx(1.,2*e_xsi)*wpi 
         dxc=2.0*wln2*srw8/gamnat/w_aGauss 
         yc=wln2*w_aLorentz/w_aGauss 
         halpda1=c1*(yc-a1)-d1*b1 
         halpda2=c2*(yc-a2)-d2*b2 
         hbeta1=(yc-a1)**2 
         hbeta2=(yc-a2)**2 
         xc=-dxc 
         do  n=0,nLG 
          xc=xc+dxc 
          beta1=hbeta1+(xc-b1)**2 
          beta3=hbeta1+(xc+b1)**2 
          beta2=hbeta2+(xc-b2)**2 
          beta4=hbeta2+(xc+b2)**2 
          alpha1=(halpda1+d1*xc)/beta1 
          alpha3=(halpda1-d1*xc)/beta3 
          alpha2=(halpda2+d2*xc)/beta2 
          alpha4=(halpda2-d2*xc)/beta4 
          vxy=alpha1+alpha2+alpha3+alpha4 
          dvxy=( d12-alpha1*(xc-b1))/beta1+                             &
     &         (-d12-alpha3*(xc+b1))/beta3+                             &
     &         ( d22-alpha2*(xc-b2))/beta2+                             &
     &         (-d22-alpha4*(xc+b2))/beta4                              
           array_fr(ipLG_6+n)=cmplx(xc*vxy+dvxy,yc*vxy)*hxsi 
         end do 
                                                                        
         array_fr(ipLG+1)=cmplx(gamnat,e_xsi) 
         array_fr(ipLG+2)=cmplx(w_Lorentz,w_Gauss) 
         array_fr(ipLG+3)=cmplx(srw8,float(nLG)) 
         array_fr(ipLG+4)=cmplx(float(ipos),float(iflag_Voigt)) 
        end if 
       else 
!       Lorentz                                                         
        ipos=iposLor 
        if(.not.(b_com.and.b_iposLor)) then 
!         write(6,'(a)')' iflag_Voigt.eq.0 &  w_Gauss=0'                
         widthL2=w_aLorentz*gamnat/2. 
         disp=srw8/widthL2 
         hp=-disp 
         hxsi=cmplx(1.,2*e_xsi)/w_aLorentz 
         do  n=0,nLG 
          hp=hp+disp 
          array_fr(iposLor+n)=cmplx(hp,1.)/(1.0+hp*hp)*hxsi 
         end do 
         array_fr(ipLG+1)=cmplx(gamnat,e_xsi) 
         array_fr(ipLG+2)=cmplx(w_Lorentz,w_Gauss) 
         array_fr(ipLG+3)=cmplx(srw8,float(nLG)) 
         array_fr(ipLG+5)=cmplx(float(iposLor),float(iflag_Voigt)) 
        end if 
       end if 
      else if(iflag_Voigt.eq.1)then 
!      Lorentz curve is needed from 0 to nLG+mGa                        
!      the wider range does not disturb                                 
       if(.not.(b_com.and.b_flag_Voigt.and.b_iposLor)) then 
!        write(6,'(a)')' iflag_Voigt.eq.1 &  w_Gauss=0'                 
        widthL2=w_aLorentz*gamnat/2. 
        disp=srw8/widthL2 
        hp=-disp 
        hxsi=cmplx(1.,2*e_xsi)/w_aLorentz 
        do  n=0,nLG+mGa 
         hp=hp+disp 
         array_fr(iposLor+n)=cmplx(hp,1.)/(1.0+hp*hp)*hxsi 
        end do 
        ipos=iposLor 
        array_fr(ipLG+1)=cmplx(gamnat,e_xsi) 
        array_fr(ipLG+2)=cmplx(w_Lorentz,w_Gauss) 
        array_fr(ipLG+3)=cmplx(srw8,float(nLG)) 
        array_fr(ipLG+5)=cmplx(float(ipos),float(iflag_Voigt)) 
       end if 
                                                                        
       if(b_Gaussgt0.and.                                               &
     &      (.not.(b_com.and.b_flag_Voigt.and.b_ipos))) then            
!         write(6,'(a)')' iflag_Voigt.eq.0 &  w_Gauss >0'               
                                                                        
        ipos=ipLG_6 
        iposGau=iposLor+(nLG+mGa+1) 
                                                                        
        widthG=w_aGauss*gamnat 
                                      ! 0.0005 precission               
        ibg=(6.*widthG/srw8+1.)/2. 
        ibg=2*ibg 
                                                                        
        if(ibg.gt.0) then 
         if(ibg.gt.mGa) ibg=mGa 
!        -ibg--------0--------ibg           gauss                       
                                                                        
                                  ! in units of gamma natural           
         width2=widthG/wln2/2.0 
         disp=srw8/width2 
         h0=-disp 
         do i=0,ibg+1 
          h0=h0+disp 
          gauss(i)=exp(-h0**2) 
         end do 
          h1=0. 
         do j=1,ibg-1,2 
          h1=h1+ gauss(j)*2. 
         end do 
         do j=2,ibg-2,2 
          h1=h1+ gauss(j) 
         end do 
         h1=(h1*2.+gauss(0)+gauss(ibg))*2. 
         h1=2.*h1/3. 
         do i=0,ibg+1 
          gauss(i)=gauss(i)/h1 
         end do 
         do i=0,ibg/2 
          array_fr(iposGau+i)=cmplx(gauss(2*i),gauss(2*i+1)) 
         end do 
                                                                        
!        convolution with exp(-x**2/(sGgL*gamnat)**2)                   
!                                                                       
!        0------------------------------------nLG---nLor                
!                                       ibg----0----ibg                 
!        0------------------------------------nLG                       
                                                                        
!        this convolution is calculated with stepwidth srw8             
                                                                        
         do i=0,nLG 
          hc=(0.,0.) 
          do j=-ibg+1,-1,2 
           ij=i+j 
           if(ij.gt.0) then 
            hc=hc+gauss(-j)*array_fr(iposLor+ij)*2. 
           else 
            hc=hc-gauss(-j)*conjg(array_fr(iposLor-ij))*2. 
           end if 
          end do 
          do j=1,ibg-1,2 
           hc=hc+gauss(j)*array_fr(iposLor+i+j)*2. 
          end do 
          do j=-ibg+2,-2,2 
           ij=i+j 
           if(ij.gt.0) then 
            hc=hc+gauss(-j)*array_fr(iposLor+ij) 
           else 
            hc=hc-gauss(-j)*conjg(array_fr(iposLor-ij)) 
           end if 
          end do 
          do j=0,ibg-2,2 
           hc=hc+gauss(j)*array_fr(iposLor+i+j) 
          end do 
          ij=i-ibg 
          if(ij.gt.0) then 
           hc1=array_fr(iposLor+ij) 
          else 
           hc1=-conjg(array_fr(iposLor-ij)) 
          end if 
                                                                        
          hc=hc*2.+gauss(ibg)*(hc1+array_fr(iposLor+i+ibg)) 
!         cLG(i,iset)=cmplx(hr,hi)/3.                                   
          array_fr(ipLG_6+i)=hc/1.5 
         end do 
                         ! if ibg >0                                    
        end if 
        array_fr(ipLG+1)=cmplx(gamnat,e_xsi) 
        array_fr(ipLG+2)=cmplx(w_Lorentz,w_Gauss) 
        array_fr(ipLG+3)=cmplx(srw8,float(nLG)) 
        array_fr(ipLG+5)=cmplx(float(ipos),float(iflag_Voigt)) 
                         ! Gauusgt0                                     
       end if 
              ! iflag_Voigt=1                                           
      end if 
                                                                        
!     If a Gauss broadening is used (simulating                         
!     a hyperfine field distribution), the sum of the Gauss function    
!     values (weighting factors)  have to be 1.                         
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine aLORGAU(Eagd,gamnat,e_xsi,srw,w_Lorentz,w_Gauss,nLG,iflag_Voigt)
      use glbconst, only: maxscrd
      use comthe, only: mLG,mGa
      implicit none 

      real,    intent(in):: Eagd,gamnat,e_xsi,srw,w_Lorentz,w_Gauss 
      integer, intent(in):: nLG,iflag_Voigt
                                                                        
      integer, parameter:: mLor=mLG+mGa,                                          &
                idumscrd=maxscrd-2*(mLG+1)-2*(2*mLG+1)                 &
                                -2*(2*mLor+1)-(mGa+2)                 
      real        sTr,gauss,dumscrd
      complex     cLG,cLOR 
      common/scrd/sTr(-mLG:mLG+1),cLG(-mLG:mLG),cLOR(-mLor:mLor),       &
                  gauss(0:mGa+1),dumscrd(idumscrd)                      

      real    w_aLorentz,w_aGauss,wpi,dxc,xc,yc,vxy,dvxy,              &
              halpda1,halpda2,hbeta1,hbeta2,beta1,beta2,beta3,beta4,   &
              alpha1,alpha2,alpha3,alpha4,widthg,widthl2,disp,hp,h0,h1  
      complex hc,hxsi
      real, parameter:: a1=-1.2150,a2=-1.3509,b1= 1.2359,b2= 0.3786,    &
                        c1=-0.3085,c2= 0.5906,d1= 0.0210,d2=-1.1858,    &
                        d12=0.0105,d22=-0.5928,wln2=0.832554611
      integer   i,j,ibg,n,nLor 
                                                                        
!      write(6,'(2a)')' aLORGAU:',                                      
!     &'Eagd,gamnat,srw,w_Lorentz,w_Gauss,nLG,iflag_Voigt'              
!      write(6,'(f12.5,f8.4,f10.5,2f8.3,2x,i6,i4)')                     
!     & Eagd,gamnat,srw,w_Lorentz,w_Gauss,nLG,iflag_Voigt               
                                                                        
!      1/(j*srw8-Eagd)+iG/2) =(j*srw8-Eagd)/(j*srw8-Eagd)**2+G**2/4)    
!                            -iG/2/(j*srw8-Eagd)**2+G**2/4)             
                                                                        
      w_aGauss=abs(w_Gauss) 
      w_aLorentz=abs(w_Lorentz)+1. 
                                                                        
      if(iflag_Voigt.eq.0) then 
                                                                        
                                    ! Lorentz                           
       if(w_aGauss.lt.0.01) then 
                                                                        
        widthL2=w_aLorentz*gamnat/2. 
        disp=srw/widthL2 
        hp=-Eagd/widthL2-disp*float(nLG+1) 
        do  n=-nLG,nLG 
         hp=hp+disp 
         cLG(n)=cmplx(hp,1.)/(1.0+hp*hp)/w_aLorentz 
        end do 
       else 
                                                                        
!       Voigt profile according to A.B. McLean, C.E.J. Mitchell and     
!       D.M. Swantston, Queens's University, Kingston, Ontario, Canada  
                                                                        
        wpi=1.772453851/w_aLorentz 
        yc=wln2/w_aGauss*w_aLorentz 
        halpda1=c1*(yc-a1)-d1*b1 
        halpda2=c2*(yc-a2)-d2*b2 
        hbeta1=(yc-a1)**2 
        hbeta2=(yc-a2)**2 
                                                                        
        dxc=2.0*wln2*srw/gamnat/w_aGauss 
        xc=-2.0*wln2*Eagd/gamnat/w_aGauss-dxc*float(nLG+1) 
        do  n=-nLG,nLG 
         xc=xc+dxc 
         beta1=hbeta1+(xc-b1)**2 
         beta3=hbeta1+(xc+b1)**2 
         beta2=hbeta2+(xc-b2)**2 
         beta4=hbeta2+(xc+b2)**2 
         alpha1=(halpda1+d1*xc)/beta1 
         alpha3=(halpda1-d1*xc)/beta3 
         alpha2=(halpda2+d2*xc)/beta2 
         alpha4=(halpda2-d2*xc)/beta4 
         vxy=alpha1+alpha2+alpha3+alpha4 
         dvxy=( d12-alpha1*(xc-b1))/beta1+                              &
     &        (-d12-alpha3*(xc+b1))/beta3+                              &
     &        ( d22-alpha2*(xc-b2))/beta2+                              &
     &        (-d22-alpha4*(xc+b2))/beta4                               
          cLG(n)=cmplx(xc*vxy+dvxy,yc*vxy)*wpi 
        end do 
       end if 
       if(abs(e_xsi).gt.gamnat/100.) then 
        hxsi=cmplx(1.,2.*e_xsi) 
        do  n=-nLG,nLG 
         cLG(n)=cLG(n)*hxsi 
        end do 
       end if 
      else if(iflag_Voigt.eq.1) then 
                                                                        
       widthG=w_aGauss*gamnat 
                                    ! 0.0005 precission                 
       ibg=(6.*widthG/srw+1.)/2. 
       ibg=2*ibg 
!      Gauss is always calculated for aLORGAU                           
       if(ibg.gt.mGa) ibg=mGa 
                                                                        
       nLor=nLG+ibg 
       widthL2=w_aLorentz*gamnat/2. 
       disp=srw/widthL2 
       hp=-Eagd/widthL2-disp*float(nLor+1) 
                                                                        
!      convolution numerically                                          
!      Lorentz curve  with stepwidth (srw)                              
!                                                                       
!      0---------------------------------------nLor                     
                                                                        
       do  n=-nLor,nLor 
        hp=hp+disp 
        cLOR(n)=cmplx(hp,1.)/(1.0+hp*hp)/w_aLorentz 
       end do 
                                                                        
!      write(6,'(a)') 'cLOR(n)='                                        
!      write(6,'(i4,2f12.3)') (n,cLOR(n)*100.,n=-5,5)                   
                                                                        
       if(ibg.gt.0) then 
!        -ibg--------0--------ibg           gauss                       
                                                                        
         disp=2.0*wln2*srw/widthG 
         h0=-disp 
         do i=0,ibg+1 
          h0=h0+disp 
          gauss(i)=exp(-h0**2) 
         end do 
          h1=0. 
         do j=1,ibg-1,2 
          h1=h1+ gauss(j)*2. 
         end do 
         do j=2,ibg-2,2 
          h1=h1+ gauss(j) 
         end do 
         h1=(h1*2.+gauss(0)+gauss(ibg)) 
         h1=2.*h1/3. 
         do i=0,ibg+1 
          gauss(i)=gauss(i)/h1 
         end do 
                                                                        
                                                                        
!       convolution with exp(-x**2/(sGgL*gamnat)**2)                    
!                                                                       
!       0------------------------------------nLG---nLor                 
!                                     ibg----0----ibg                   
!       0------------------------------------nLG                        
                                                                        
!       this convolution is calculated with stepwidth srw8              
                                                                        
!        write(6,'(a,i4)')  ' ####aLORGAU igb=',ibg                     
         do i=-nLG,nLG 
          hc=(0.,0.) 
          do j=-ibg+1,-1,2 
            hc=hc+gauss(-j)*cLOR(i+j)*2. 
          end do 
          do j=1,ibg-1,2 
           hc=hc+gauss(j)*cLOR(i+j)*2. 
          end do 
          do j=-ibg+2,-2,2 
           hc=hc+gauss(-j)*cLOR(i+j) 
          end do 
          do j=0,ibg-2,2 
           hc=hc+gauss(j)*cLOR(i+j) 
          end do 
          hc=hc*2.+gauss(ibg)*(cLOR(i-ibg)+cLOR(i+ibg)) 
          cLG(i)=hc/3. 
         end do 
       else 
        do i=-nLG,nLG 
         cLG(i)=cLOR(i) 
        end do 
                        ! if ibg >0                                     
       end if 
       if(abs(e_xsi).gt.gamnat/100.) then 
        hxsi=cmplx(1.,2.*e_xsi) 
        do  n=-nLG,nLG 
         cLG(n)=cLG(n)*hxsi 
        end do 
       end if 
                ! convolution numerically                               
      end if 
      return 
      END                                           
